# SparkSQL LSP language server web extension

A SparkSQL LSP server that runs in a web extension/WebWorker.

## Functionality

This Language Server runs syntax validation while the textDocument's content is changing (turned off by default).
In addition, it supports LSP capabilities including:

- Auto-completion
- Custom commands:
  - extension.sparksql.validationOn: used to turn on/off syntax validation in language server.

## Usage

The package exports a worker JS file named "**sparksql-server-worker**". To run in a browser env, such as `monaco-editor`, 
please use it to create a `Worker` instance with the help of `monaco-languageclient`.

Use `sendRequest` API to execute custom commands:
```typescript
languageClient.sendRequest(ExecuteCommandRequest.type, {
    command: "extension.sparksql.validationOn",
    arguments: [true]
});
```

## Other language servers

- [flink-sql-language-server](https://www.npmjs.com/package/flink-sql-language-server)
- [mysql-language-server](https://www.npmjs.com/package/mysql-language-server)
