"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleExecuteCommand = void 0;
const constant_1 = require("./constant");
function handleExecuteCommand(documents, lspServer, params) {
    if (params.command === constant_1.REGISTER_SCHEMAS_COMMAND) {
        const registerMode = params.arguments?.[0];
        if (registerMode !== 'set' && registerMode !== 'patch') {
            console.error("Language Server: Fist argument must be either 'patch' or 'set' to indicate register mode.");
            return;
        }
        const schemas = params.arguments?.[1];
        if (!schemas || typeof schemas !== 'object') {
            console.error('Language Server: Schemas must be provided for Register Schemas command.');
            return;
        }
        lspServer.schemaRegistry.register(registerMode, schemas);
    }
}
exports.handleExecuteCommand = handleExecuteCommand;
//# sourceMappingURL=execute-commands.js.map