import { ATN } from "antlr4ts/atn/ATN";
import { CharStream } from "antlr4ts/CharStream";
import { Lexer } from "antlr4ts/Lexer";
import { RuleContext } from "antlr4ts/RuleContext";
import { Vocabulary } from "antlr4ts/Vocabulary";
export declare class SparkSqlLexer extends Lexer {
    static readonly SEMICOLON = 1;
    static readonly LEFT_PAREN = 2;
    static readonly RIGHT_PAREN = 3;
    static readonly COMMA = 4;
    static readonly DOT = 5;
    static readonly LEFT_BRACKET = 6;
    static readonly RIGHT_BRACKET = 7;
    static readonly ADD = 8;
    static readonly AFTER = 9;
    static readonly ALL = 10;
    static readonly ALTER = 11;
    static readonly ALWAYS = 12;
    static readonly ANALYZE = 13;
    static readonly AND = 14;
    static readonly ANTI = 15;
    static readonly ANY = 16;
    static readonly ANY_VALUE = 17;
    static readonly ARCHIVE = 18;
    static readonly ARRAY = 19;
    static readonly AS = 20;
    static readonly ASC = 21;
    static readonly AT = 22;
    static readonly AUTHORIZATION = 23;
    static readonly BETWEEN = 24;
    static readonly BIGINT = 25;
    static readonly BINARY = 26;
    static readonly BOOLEAN = 27;
    static readonly BOTH = 28;
    static readonly BUCKET = 29;
    static readonly BUCKETS = 30;
    static readonly BY = 31;
    static readonly BYTE = 32;
    static readonly CACHE = 33;
    static readonly CASCADE = 34;
    static readonly CASE = 35;
    static readonly CAST = 36;
    static readonly CATALOG = 37;
    static readonly CATALOGS = 38;
    static readonly CHANGE = 39;
    static readonly CHAR = 40;
    static readonly CHARACTER = 41;
    static readonly CHECK = 42;
    static readonly CLEAR = 43;
    static readonly CLUSTER = 44;
    static readonly CLUSTERED = 45;
    static readonly CODEGEN = 46;
    static readonly COLLATE = 47;
    static readonly COLLECTION = 48;
    static readonly COLUMN = 49;
    static readonly COLUMNS = 50;
    static readonly COMMENT = 51;
    static readonly COMMIT = 52;
    static readonly COMPACT = 53;
    static readonly COMPACTIONS = 54;
    static readonly COMPUTE = 55;
    static readonly CONCATENATE = 56;
    static readonly CONSTRAINT = 57;
    static readonly COST = 58;
    static readonly CREATE = 59;
    static readonly CROSS = 60;
    static readonly CUBE = 61;
    static readonly CURRENT = 62;
    static readonly CURRENT_DATE = 63;
    static readonly CURRENT_TIME = 64;
    static readonly CURRENT_TIMESTAMP = 65;
    static readonly CURRENT_USER = 66;
    static readonly DAY = 67;
    static readonly DAYS = 68;
    static readonly DAYOFYEAR = 69;
    static readonly DATA = 70;
    static readonly DATE = 71;
    static readonly DATABASE = 72;
    static readonly DATABASES = 73;
    static readonly DATEADD = 74;
    static readonly DATE_ADD = 75;
    static readonly DATEDIFF = 76;
    static readonly DATE_DIFF = 77;
    static readonly DBPROPERTIES = 78;
    static readonly DEC = 79;
    static readonly DECIMAL = 80;
    static readonly DEFAULT = 81;
    static readonly DEFINED = 82;
    static readonly DELETE = 83;
    static readonly DELIMITED = 84;
    static readonly DESC = 85;
    static readonly DESCRIBE = 86;
    static readonly DFS = 87;
    static readonly DIRECTORIES = 88;
    static readonly DIRECTORY = 89;
    static readonly DISTINCT = 90;
    static readonly DISTRIBUTE = 91;
    static readonly DIV = 92;
    static readonly DOUBLE = 93;
    static readonly DROP = 94;
    static readonly ELSE = 95;
    static readonly END = 96;
    static readonly ESCAPE = 97;
    static readonly ESCAPED = 98;
    static readonly EXCEPT = 99;
    static readonly EXCHANGE = 100;
    static readonly EXCLUDE = 101;
    static readonly EXISTS = 102;
    static readonly EXPLAIN = 103;
    static readonly EXPORT = 104;
    static readonly EXTENDED = 105;
    static readonly EXTERNAL = 106;
    static readonly EXTRACT = 107;
    static readonly FALSE = 108;
    static readonly FETCH = 109;
    static readonly FIELDS = 110;
    static readonly FILTER = 111;
    static readonly FILEFORMAT = 112;
    static readonly FIRST = 113;
    static readonly FLOAT = 114;
    static readonly FOLLOWING = 115;
    static readonly FOR = 116;
    static readonly FOREIGN = 117;
    static readonly FORMAT = 118;
    static readonly FORMATTED = 119;
    static readonly FROM = 120;
    static readonly FULL = 121;
    static readonly FUNCTION = 122;
    static readonly FUNCTIONS = 123;
    static readonly GENERATED = 124;
    static readonly GLOBAL = 125;
    static readonly GRANT = 126;
    static readonly GROUP = 127;
    static readonly GROUPING = 128;
    static readonly HAVING = 129;
    static readonly BINARY_HEX = 130;
    static readonly HOUR = 131;
    static readonly HOURS = 132;
    static readonly IDENTIFIER_KW = 133;
    static readonly IF = 134;
    static readonly IGNORE = 135;
    static readonly IMPORT = 136;
    static readonly IN = 137;
    static readonly INCLUDE = 138;
    static readonly INDEX = 139;
    static readonly INDEXES = 140;
    static readonly INNER = 141;
    static readonly INPATH = 142;
    static readonly INPUTFORMAT = 143;
    static readonly INSERT = 144;
    static readonly INTERSECT = 145;
    static readonly INTERVAL = 146;
    static readonly INT = 147;
    static readonly INTEGER = 148;
    static readonly INTO = 149;
    static readonly IS = 150;
    static readonly ITEMS = 151;
    static readonly JOIN = 152;
    static readonly KEYS = 153;
    static readonly LAST = 154;
    static readonly LATERAL = 155;
    static readonly LAZY = 156;
    static readonly LEADING = 157;
    static readonly LEFT = 158;
    static readonly LIKE = 159;
    static readonly ILIKE = 160;
    static readonly LIMIT = 161;
    static readonly LINES = 162;
    static readonly LIST = 163;
    static readonly LOAD = 164;
    static readonly LOCAL = 165;
    static readonly LOCATION = 166;
    static readonly LOCK = 167;
    static readonly LOCKS = 168;
    static readonly LOGICAL = 169;
    static readonly LONG = 170;
    static readonly MACRO = 171;
    static readonly MAP = 172;
    static readonly MATCHED = 173;
    static readonly MERGE = 174;
    static readonly MICROSECOND = 175;
    static readonly MICROSECONDS = 176;
    static readonly MILLISECOND = 177;
    static readonly MILLISECONDS = 178;
    static readonly MINUTE = 179;
    static readonly MINUTES = 180;
    static readonly MONTH = 181;
    static readonly MONTHS = 182;
    static readonly MSCK = 183;
    static readonly NAME = 184;
    static readonly NAMESPACE = 185;
    static readonly NAMESPACES = 186;
    static readonly NANOSECOND = 187;
    static readonly NANOSECONDS = 188;
    static readonly NATURAL = 189;
    static readonly NO = 190;
    static readonly NOT = 191;
    static readonly NULL = 192;
    static readonly NULLS = 193;
    static readonly NUMERIC = 194;
    static readonly OF = 195;
    static readonly OFFSET = 196;
    static readonly ON = 197;
    static readonly ONLY = 198;
    static readonly OPTION = 199;
    static readonly OPTIONS = 200;
    static readonly OR = 201;
    static readonly ORDER = 202;
    static readonly OUT = 203;
    static readonly OUTER = 204;
    static readonly OUTPUTFORMAT = 205;
    static readonly OVER = 206;
    static readonly OVERLAPS = 207;
    static readonly OVERLAY = 208;
    static readonly OVERWRITE = 209;
    static readonly PARTITION = 210;
    static readonly PARTITIONED = 211;
    static readonly PARTITIONS = 212;
    static readonly PERCENTILE_CONT = 213;
    static readonly PERCENTILE_DISC = 214;
    static readonly PERCENTLIT = 215;
    static readonly PIVOT = 216;
    static readonly PLACING = 217;
    static readonly POSITION = 218;
    static readonly PRECEDING = 219;
    static readonly PRIMARY = 220;
    static readonly PRINCIPALS = 221;
    static readonly PROPERTIES = 222;
    static readonly PURGE = 223;
    static readonly QUARTER = 224;
    static readonly QUERY = 225;
    static readonly RANGE = 226;
    static readonly REAL = 227;
    static readonly RECORDREADER = 228;
    static readonly RECORDWRITER = 229;
    static readonly RECOVER = 230;
    static readonly REDUCE = 231;
    static readonly REFERENCES = 232;
    static readonly REFRESH = 233;
    static readonly RENAME = 234;
    static readonly REPAIR = 235;
    static readonly REPEATABLE = 236;
    static readonly REPLACE = 237;
    static readonly RESET = 238;
    static readonly RESPECT = 239;
    static readonly RESTRICT = 240;
    static readonly REVOKE = 241;
    static readonly RIGHT = 242;
    static readonly RLIKE = 243;
    static readonly ROLE = 244;
    static readonly ROLES = 245;
    static readonly ROLLBACK = 246;
    static readonly ROLLUP = 247;
    static readonly ROW = 248;
    static readonly ROWS = 249;
    static readonly SECOND = 250;
    static readonly SECONDS = 251;
    static readonly SCHEMA = 252;
    static readonly SCHEMAS = 253;
    static readonly SELECT = 254;
    static readonly SEMI = 255;
    static readonly SEPARATED = 256;
    static readonly SERDE = 257;
    static readonly SERDEPROPERTIES = 258;
    static readonly SESSION_USER = 259;
    static readonly SET = 260;
    static readonly SETMINUS = 261;
    static readonly SETS = 262;
    static readonly SHORT = 263;
    static readonly SHOW = 264;
    static readonly SKEWED = 265;
    static readonly SMALLINT = 266;
    static readonly SOME = 267;
    static readonly SORT = 268;
    static readonly SORTED = 269;
    static readonly SOURCE = 270;
    static readonly START = 271;
    static readonly STATISTICS = 272;
    static readonly STORED = 273;
    static readonly STRATIFY = 274;
    static readonly STRING = 275;
    static readonly STRUCT = 276;
    static readonly SUBSTR = 277;
    static readonly SUBSTRING = 278;
    static readonly SYNC = 279;
    static readonly SYSTEM_TIME = 280;
    static readonly SYSTEM_VERSION = 281;
    static readonly TABLE = 282;
    static readonly TABLES = 283;
    static readonly TABLESAMPLE = 284;
    static readonly TARGET = 285;
    static readonly TBLPROPERTIES = 286;
    static readonly TEMPORARY = 287;
    static readonly TERMINATED = 288;
    static readonly THEN = 289;
    static readonly TIME = 290;
    static readonly TIMESTAMP = 291;
    static readonly TIMESTAMP_LTZ = 292;
    static readonly TIMESTAMP_NTZ = 293;
    static readonly TIMESTAMPADD = 294;
    static readonly TIMESTAMPDIFF = 295;
    static readonly TINYINT = 296;
    static readonly TO = 297;
    static readonly TOUCH = 298;
    static readonly TRAILING = 299;
    static readonly TRANSACTION = 300;
    static readonly TRANSACTIONS = 301;
    static readonly TRANSFORM = 302;
    static readonly TRIM = 303;
    static readonly TRUE = 304;
    static readonly TRUNCATE = 305;
    static readonly TRY_CAST = 306;
    static readonly TYPE = 307;
    static readonly UNARCHIVE = 308;
    static readonly UNBOUNDED = 309;
    static readonly UNCACHE = 310;
    static readonly UNION = 311;
    static readonly UNIQUE = 312;
    static readonly UNKNOWN = 313;
    static readonly UNLOCK = 314;
    static readonly UNPIVOT = 315;
    static readonly UNSET = 316;
    static readonly UPDATE = 317;
    static readonly USE = 318;
    static readonly USER = 319;
    static readonly USING = 320;
    static readonly VALUES = 321;
    static readonly VARCHAR = 322;
    static readonly VERSION = 323;
    static readonly VIEW = 324;
    static readonly VIEWS = 325;
    static readonly VOID = 326;
    static readonly WEEK = 327;
    static readonly WEEKS = 328;
    static readonly WHEN = 329;
    static readonly WHERE = 330;
    static readonly WINDOW = 331;
    static readonly WITH = 332;
    static readonly WITHIN = 333;
    static readonly YEAR = 334;
    static readonly YEARS = 335;
    static readonly ZONE = 336;
    static readonly EQ = 337;
    static readonly NSEQ = 338;
    static readonly NEQ = 339;
    static readonly NEQJ = 340;
    static readonly LT = 341;
    static readonly LTE = 342;
    static readonly GT = 343;
    static readonly GTE = 344;
    static readonly PLUS = 345;
    static readonly MINUS = 346;
    static readonly ASTERISK = 347;
    static readonly SLASH = 348;
    static readonly PERCENT = 349;
    static readonly TILDE = 350;
    static readonly AMPERSAND = 351;
    static readonly PIPE = 352;
    static readonly CONCAT_PIPE = 353;
    static readonly HAT = 354;
    static readonly COLON = 355;
    static readonly ARROW = 356;
    static readonly FAT_ARROW = 357;
    static readonly HENT_START = 358;
    static readonly HENT_END = 359;
    static readonly QUESTION = 360;
    static readonly STRING_LITERAL = 361;
    static readonly DOUBLEQUOTED_STRING = 362;
    static readonly BIGINT_LITERAL = 363;
    static readonly SMALLINT_LITERAL = 364;
    static readonly TINYINT_LITERAL = 365;
    static readonly INTEGER_VALUE = 366;
    static readonly EXPONENT_VALUE = 367;
    static readonly DECIMAL_VALUE = 368;
    static readonly FLOAT_LITERAL = 369;
    static readonly DOUBLE_LITERAL = 370;
    static readonly BIGDECIMAL_LITERAL = 371;
    static readonly IDENTIFIER = 372;
    static readonly BACKQUOTED_IDENTIFIER = 373;
    static readonly SIMPLE_COMMENT = 374;
    static readonly BRACKETED_COMMENT = 375;
    static readonly WS = 376;
    static readonly UNRECOGNIZED = 377;
    static readonly channelNames: string[];
    static readonly modeNames: string[];
    static readonly ruleNames: string[];
    private static readonly _LITERAL_NAMES;
    private static readonly _SYMBOLIC_NAMES;
    static readonly VOCABULARY: Vocabulary;
    get vocabulary(): Vocabulary;
    has_unclosed_bracketed_comment: boolean;
    isValidDecimal(): boolean;
    isHint(): boolean;
    markUnclosedComment(): void;
    constructor(input: CharStream);
    get grammarFileName(): string;
    get ruleNames(): string[];
    get serializedATN(): string;
    get channelNames(): string[];
    get modeNames(): string[];
    action(_localctx: RuleContext, ruleIndex: number, actionIndex: number): void;
    private BRACKETED_COMMENT_action;
    sempred(_localctx: RuleContext, ruleIndex: number, predIndex: number): boolean;
    private EXPONENT_VALUE_sempred;
    private DECIMAL_VALUE_sempred;
    private FLOAT_LITERAL_sempred;
    private DOUBLE_LITERAL_sempred;
    private BIGDECIMAL_LITERAL_sempred;
    private BRACKETED_COMMENT_sempred;
    private static readonly _serializedATNSegments;
    private static readonly _serializedATNSegment0;
    private static readonly _serializedATNSegment1;
    private static readonly _serializedATNSegment2;
    private static readonly _serializedATNSegment3;
    private static readonly _serializedATNSegment4;
    private static readonly _serializedATNSegment5;
    private static readonly _serializedATNSegment6;
    static readonly _serializedATN: string;
    static __ATN: ATN;
    static get _ATN(): ATN;
}
