import { ParseTreeVisitor } from "antlr4ts/tree/ParseTreeVisitor";
import { TableNameContext } from "./SparkSqlParser";
import { AliasedQueryContext } from "./SparkSqlParser";
import { AliasedRelationContext } from "./SparkSqlParser";
import { InlineTableDefault2Context } from "./SparkSqlParser";
import { TableValuedFunctionContext } from "./SparkSqlParser";
import { SingleInsertQueryContext } from "./SparkSqlParser";
import { MultiInsertQueryContext } from "./SparkSqlParser";
import { DeleteFromTableContext } from "./SparkSqlParser";
import { UpdateTableContext } from "./SparkSqlParser";
import { MergeIntoTableContext } from "./SparkSqlParser";
import { CurrentLikeContext } from "./SparkSqlParser";
import { TimestampaddContext } from "./SparkSqlParser";
import { TimestampdiffContext } from "./SparkSqlParser";
import { SearchedCaseContext } from "./SparkSqlParser";
import { SimpleCaseContext } from "./SparkSqlParser";
import { CastContext } from "./SparkSqlParser";
import { StructContext } from "./SparkSqlParser";
import { FirstContext } from "./SparkSqlParser";
import { Any_valueContext } from "./SparkSqlParser";
import { LastContext } from "./SparkSqlParser";
import { PositionContext } from "./SparkSqlParser";
import { ConstantDefaultContext } from "./SparkSqlParser";
import { StarContext } from "./SparkSqlParser";
import { RowConstructorContext } from "./SparkSqlParser";
import { SubqueryExpressionContext } from "./SparkSqlParser";
import { IdentifierClauseContext } from "./SparkSqlParser";
import { FunctionCallContext } from "./SparkSqlParser";
import { LambdaContext } from "./SparkSqlParser";
import { SubscriptContext } from "./SparkSqlParser";
import { ColumnReferenceContext } from "./SparkSqlParser";
import { DereferenceContext } from "./SparkSqlParser";
import { ParenthesizedExpressionContext } from "./SparkSqlParser";
import { ExtractContext } from "./SparkSqlParser";
import { SubstringContext } from "./SparkSqlParser";
import { TrimContext } from "./SparkSqlParser";
import { OverlayContext } from "./SparkSqlParser";
import { PercentileContext } from "./SparkSqlParser";
import { UnquotedIdentifierContext } from "./SparkSqlParser";
import { QuotedIdentifierAlternativeContext } from "./SparkSqlParser";
import { TableFileFormatContext } from "./SparkSqlParser";
import { GenericFileFormatContext } from "./SparkSqlParser";
import { SampleByPercentileContext } from "./SparkSqlParser";
import { SampleByRowsContext } from "./SparkSqlParser";
import { SampleByBucketContext } from "./SparkSqlParser";
import { SampleByBytesContext } from "./SparkSqlParser";
import { ComplexDataTypeContext } from "./SparkSqlParser";
import { YearMonthIntervalDataTypeContext } from "./SparkSqlParser";
import { DayTimeIntervalDataTypeContext } from "./SparkSqlParser";
import { PrimitiveDataTypeContext } from "./SparkSqlParser";
import { TransformQuerySpecificationContext } from "./SparkSqlParser";
import { RegularQuerySpecificationContext } from "./SparkSqlParser";
import { ErrorIdentContext } from "./SparkSqlParser";
import { RealIdentContext } from "./SparkSqlParser";
import { WindowRefContext } from "./SparkSqlParser";
import { WindowDefContext } from "./SparkSqlParser";
import { StatementDefaultContext } from "./SparkSqlParser";
import { DescribeStatementContext } from "./SparkSqlParser";
import { UseStatementContext } from "./SparkSqlParser";
import { DdlStatementContext } from "./SparkSqlParser";
import { DmlStatementContext } from "./SparkSqlParser";
import { UseContext } from "./SparkSqlParser";
import { UseNamespaceContext } from "./SparkSqlParser";
import { SetCatalogContext } from "./SparkSqlParser";
import { CreateNamespaceContext } from "./SparkSqlParser";
import { SetNamespacePropertiesContext } from "./SparkSqlParser";
import { SetNamespaceLocationContext } from "./SparkSqlParser";
import { DropNamespaceContext } from "./SparkSqlParser";
import { ShowNamespacesContext } from "./SparkSqlParser";
import { CreateTableContext } from "./SparkSqlParser";
import { CreateTableLikeContext } from "./SparkSqlParser";
import { ReplaceTableContext } from "./SparkSqlParser";
import { AnalyzeContext } from "./SparkSqlParser";
import { AnalyzeTablesContext } from "./SparkSqlParser";
import { AddTableColumnsContext } from "./SparkSqlParser";
import { RenameTableColumnContext } from "./SparkSqlParser";
import { DropTableColumnsContext } from "./SparkSqlParser";
import { RenameTableContext } from "./SparkSqlParser";
import { SetTablePropertiesContext } from "./SparkSqlParser";
import { UnsetTablePropertiesContext } from "./SparkSqlParser";
import { AlterTableAlterColumnContext } from "./SparkSqlParser";
import { HiveChangeColumnContext } from "./SparkSqlParser";
import { HiveReplaceColumnsContext } from "./SparkSqlParser";
import { SetTableSerDeContext } from "./SparkSqlParser";
import { AddTablePartitionContext } from "./SparkSqlParser";
import { RenameTablePartitionContext } from "./SparkSqlParser";
import { DropTablePartitionsContext } from "./SparkSqlParser";
import { SetTableLocationContext } from "./SparkSqlParser";
import { RecoverPartitionsContext } from "./SparkSqlParser";
import { DropTableContext } from "./SparkSqlParser";
import { DropViewContext } from "./SparkSqlParser";
import { CreateViewContext } from "./SparkSqlParser";
import { CreateTempViewUsingContext } from "./SparkSqlParser";
import { AlterViewQueryContext } from "./SparkSqlParser";
import { CreateFunctionContext } from "./SparkSqlParser";
import { DropFunctionContext } from "./SparkSqlParser";
import { ExplainContext } from "./SparkSqlParser";
import { ShowTablesContext } from "./SparkSqlParser";
import { ShowTableExtendedContext } from "./SparkSqlParser";
import { ShowTblPropertiesContext } from "./SparkSqlParser";
import { ShowColumnsContext } from "./SparkSqlParser";
import { ShowViewsContext } from "./SparkSqlParser";
import { ShowPartitionsContext } from "./SparkSqlParser";
import { ShowFunctionsContext } from "./SparkSqlParser";
import { ShowCreateTableContext } from "./SparkSqlParser";
import { ShowCurrentNamespaceContext } from "./SparkSqlParser";
import { ShowCatalogsContext } from "./SparkSqlParser";
import { DescribeFunctionContext } from "./SparkSqlParser";
import { DescribeNamespaceContext } from "./SparkSqlParser";
import { DescribeRelationContext } from "./SparkSqlParser";
import { DescribeQueryContext } from "./SparkSqlParser";
import { CommentNamespaceContext } from "./SparkSqlParser";
import { CommentTableContext } from "./SparkSqlParser";
import { RefreshTableContext } from "./SparkSqlParser";
import { RefreshFunctionContext } from "./SparkSqlParser";
import { RefreshResourceContext } from "./SparkSqlParser";
import { CacheTableContext } from "./SparkSqlParser";
import { UncacheTableContext } from "./SparkSqlParser";
import { ClearCacheContext } from "./SparkSqlParser";
import { LoadDataContext } from "./SparkSqlParser";
import { TruncateTableContext } from "./SparkSqlParser";
import { RepairTableContext } from "./SparkSqlParser";
import { ManageResourceContext } from "./SparkSqlParser";
import { FailNativeCommandContext } from "./SparkSqlParser";
import { SetTimeZoneContext } from "./SparkSqlParser";
import { SetQuotedConfigurationContext } from "./SparkSqlParser";
import { SetConfigurationContext } from "./SparkSqlParser";
import { ResetQuotedConfigurationContext } from "./SparkSqlParser";
import { ResetConfigurationContext } from "./SparkSqlParser";
import { CreateIndexContext } from "./SparkSqlParser";
import { DropIndexContext } from "./SparkSqlParser";
import { ExponentLiteralContext } from "./SparkSqlParser";
import { DecimalLiteralContext } from "./SparkSqlParser";
import { LegacyDecimalLiteralContext } from "./SparkSqlParser";
import { IntegerLiteralContext } from "./SparkSqlParser";
import { BigIntLiteralContext } from "./SparkSqlParser";
import { SmallIntLiteralContext } from "./SparkSqlParser";
import { TinyIntLiteralContext } from "./SparkSqlParser";
import { DoubleLiteralContext } from "./SparkSqlParser";
import { FloatLiteralContext } from "./SparkSqlParser";
import { BigDecimalLiteralContext } from "./SparkSqlParser";
import { QueryTermDefaultContext } from "./SparkSqlParser";
import { SetOperationContext } from "./SparkSqlParser";
import { InsertOverwriteTableContext } from "./SparkSqlParser";
import { InsertIntoTableContext } from "./SparkSqlParser";
import { InsertIntoReplaceWhereContext } from "./SparkSqlParser";
import { InsertOverwriteHiveDirContext } from "./SparkSqlParser";
import { InsertOverwriteDirContext } from "./SparkSqlParser";
import { ValueExpressionDefaultContext } from "./SparkSqlParser";
import { ArithmeticUnaryContext } from "./SparkSqlParser";
import { ArithmeticBinaryContext } from "./SparkSqlParser";
import { ComparisonContext } from "./SparkSqlParser";
import { PartitionTransformContext } from "./SparkSqlParser";
import { PartitionColumnContext } from "./SparkSqlParser";
import { QueryPrimaryDefaultContext } from "./SparkSqlParser";
import { FromStmtContext } from "./SparkSqlParser";
import { TableContext } from "./SparkSqlParser";
import { InlineTableDefault1Context } from "./SparkSqlParser";
import { SubqueryContext } from "./SparkSqlParser";
import { NullLiteralContext } from "./SparkSqlParser";
import { PosParameterLiteralContext } from "./SparkSqlParser";
import { NamedParameterLiteralContext } from "./SparkSqlParser";
import { IntervalLiteralContext } from "./SparkSqlParser";
import { TypeConstructorContext } from "./SparkSqlParser";
import { NumericLiteralContext } from "./SparkSqlParser";
import { BooleanLiteralContext } from "./SparkSqlParser";
import { StringLiteralContext } from "./SparkSqlParser";
import { RowFormatSerdeContext } from "./SparkSqlParser";
import { RowFormatDelimitedContext } from "./SparkSqlParser";
import { IdentityTransformContext } from "./SparkSqlParser";
import { ApplyTransformContext } from "./SparkSqlParser";
import { LogicalNotContext } from "./SparkSqlParser";
import { ExistsContext } from "./SparkSqlParser";
import { PredicatedContext } from "./SparkSqlParser";
import { LogicalBinaryContext } from "./SparkSqlParser";
import { ProgramContext } from "./SparkSqlParser";
import { StatementsContext } from "./SparkSqlParser";
import { StatementEndContext } from "./SparkSqlParser";
import { SingleStatementContext } from "./SparkSqlParser";
import { SingleExpressionContext } from "./SparkSqlParser";
import { SingleTableIdentifierContext } from "./SparkSqlParser";
import { SingleMultipartIdentifierContext } from "./SparkSqlParser";
import { SingleFunctionIdentifierContext } from "./SparkSqlParser";
import { SingleDataTypeContext } from "./SparkSqlParser";
import { SingleTableSchemaContext } from "./SparkSqlParser";
import { AnyNonStringNameContext } from "./SparkSqlParser";
import { CatalogNameDefContext } from "./SparkSqlParser";
import { DatabaseNameDefContext } from "./SparkSqlParser";
import { ColumnNameDefContext } from "./SparkSqlParser";
import { TableNameDefContext } from "./SparkSqlParser";
import { ViewNameDefContext } from "./SparkSqlParser";
import { CatalogDefContext } from "./SparkSqlParser";
import { DatabaseDefContext } from "./SparkSqlParser";
import { TableDefContext } from "./SparkSqlParser";
import { ViewDefContext } from "./SparkSqlParser";
import { ColumnDefContext } from "./SparkSqlParser";
import { DescribeDefContext } from "./SparkSqlParser";
import { DescribeCatalogContext } from "./SparkSqlParser";
import { DescribeDatabaseContext } from "./SparkSqlParser";
import { DescribeTableContext } from "./SparkSqlParser";
import { UseDefContext } from "./SparkSqlParser";
import { DdlStatementDefContext } from "./SparkSqlParser";
import { AlterDatabaseDefContext } from "./SparkSqlParser";
import { CreateDatabaseDefContext } from "./SparkSqlParser";
import { DropDatabaseDefContext } from "./SparkSqlParser";
import { StatementForFoldingContext } from "./SparkSqlParser";
import { StatementContext } from "./SparkSqlParser";
import { TimezoneContext } from "./SparkSqlParser";
import { ConfigKeyContext } from "./SparkSqlParser";
import { ConfigValueContext } from "./SparkSqlParser";
import { UnsupportedHiveNativeCommandsContext } from "./SparkSqlParser";
import { CreateTableHeaderContext } from "./SparkSqlParser";
import { ReplaceTableHeaderContext } from "./SparkSqlParser";
import { BucketSpecContext } from "./SparkSqlParser";
import { SkewSpecContext } from "./SparkSqlParser";
import { LocationSpecContext } from "./SparkSqlParser";
import { CommentSpecContext } from "./SparkSqlParser";
import { QueryContext } from "./SparkSqlParser";
import { InsertIntoContext } from "./SparkSqlParser";
import { PartitionSpecLocationContext } from "./SparkSqlParser";
import { PartitionSpecContext } from "./SparkSqlParser";
import { PartitionValContext } from "./SparkSqlParser";
import { NamespaceContext } from "./SparkSqlParser";
import { NamespacesContext } from "./SparkSqlParser";
import { DescribeFuncNameContext } from "./SparkSqlParser";
import { DescribeColNameContext } from "./SparkSqlParser";
import { CtesContext } from "./SparkSqlParser";
import { NamedQueryContext } from "./SparkSqlParser";
import { TableProviderContext } from "./SparkSqlParser";
import { CreateTableClausesContext } from "./SparkSqlParser";
import { PropertyListContext } from "./SparkSqlParser";
import { PropertyContext } from "./SparkSqlParser";
import { PropertyKeyContext } from "./SparkSqlParser";
import { PropertyValueContext } from "./SparkSqlParser";
import { ExpressionPropertyListContext } from "./SparkSqlParser";
import { ExpressionPropertyContext } from "./SparkSqlParser";
import { ConstantListContext } from "./SparkSqlParser";
import { NestedConstantListContext } from "./SparkSqlParser";
import { CreateFileFormatContext } from "./SparkSqlParser";
import { FileFormatContext } from "./SparkSqlParser";
import { StorageHandlerContext } from "./SparkSqlParser";
import { ResourceContext } from "./SparkSqlParser";
import { DmlStatementNoWithContext } from "./SparkSqlParser";
import { IdentifierReferenceContext } from "./SparkSqlParser";
import { QueryOrganizationContext } from "./SparkSqlParser";
import { MultiInsertQueryBodyContext } from "./SparkSqlParser";
import { QueryTermContext } from "./SparkSqlParser";
import { QueryPrimaryContext } from "./SparkSqlParser";
import { SortItemContext } from "./SparkSqlParser";
import { FromStatementContext } from "./SparkSqlParser";
import { FromStatementBodyContext } from "./SparkSqlParser";
import { QuerySpecificationContext } from "./SparkSqlParser";
import { TransformClauseContext } from "./SparkSqlParser";
import { SelectClauseContext } from "./SparkSqlParser";
import { SetClauseContext } from "./SparkSqlParser";
import { MatchedClauseContext } from "./SparkSqlParser";
import { NotMatchedClauseContext } from "./SparkSqlParser";
import { NotMatchedBySourceClauseContext } from "./SparkSqlParser";
import { MatchedActionContext } from "./SparkSqlParser";
import { NotMatchedActionContext } from "./SparkSqlParser";
import { NotMatchedBySourceActionContext } from "./SparkSqlParser";
import { AssignmentListContext } from "./SparkSqlParser";
import { AssignmentContext } from "./SparkSqlParser";
import { WhereClauseContext } from "./SparkSqlParser";
import { HavingClauseContext } from "./SparkSqlParser";
import { HintContext } from "./SparkSqlParser";
import { HintStatementContext } from "./SparkSqlParser";
import { FromClauseContext } from "./SparkSqlParser";
import { TemporalClauseContext } from "./SparkSqlParser";
import { AggregationClauseContext } from "./SparkSqlParser";
import { GroupByClauseContext } from "./SparkSqlParser";
import { GroupingAnalyticsContext } from "./SparkSqlParser";
import { GroupingElementContext } from "./SparkSqlParser";
import { GroupingSetContext } from "./SparkSqlParser";
import { PivotClauseContext } from "./SparkSqlParser";
import { PivotColumnContext } from "./SparkSqlParser";
import { PivotValueContext } from "./SparkSqlParser";
import { UnpivotClauseContext } from "./SparkSqlParser";
import { UnpivotNullClauseContext } from "./SparkSqlParser";
import { UnpivotOperatorContext } from "./SparkSqlParser";
import { UnpivotSingleValueColumnClauseContext } from "./SparkSqlParser";
import { UnpivotMultiValueColumnClauseContext } from "./SparkSqlParser";
import { UnpivotColumnSetContext } from "./SparkSqlParser";
import { UnpivotValueColumnContext } from "./SparkSqlParser";
import { UnpivotNameColumnContext } from "./SparkSqlParser";
import { UnpivotColumnAndAliasContext } from "./SparkSqlParser";
import { UnpivotColumnContext } from "./SparkSqlParser";
import { UnpivotAliasContext } from "./SparkSqlParser";
import { LateralViewContext } from "./SparkSqlParser";
import { SetQuantifierContext } from "./SparkSqlParser";
import { RelationContext } from "./SparkSqlParser";
import { RelationExtensionContext } from "./SparkSqlParser";
import { JoinRelationContext } from "./SparkSqlParser";
import { JoinTypeContext } from "./SparkSqlParser";
import { JoinCriteriaContext } from "./SparkSqlParser";
import { SampleContext } from "./SparkSqlParser";
import { SampleMethodContext } from "./SparkSqlParser";
import { IdentifierListContext } from "./SparkSqlParser";
import { IdentifierSeqContext } from "./SparkSqlParser";
import { OrderedIdentifierListContext } from "./SparkSqlParser";
import { OrderedIdentifierContext } from "./SparkSqlParser";
import { IdentifierCommentListContext } from "./SparkSqlParser";
import { IdentifierCommentContext } from "./SparkSqlParser";
import { RelationPrimaryContext } from "./SparkSqlParser";
import { InlineTableContext } from "./SparkSqlParser";
import { FunctionTableSubqueryArgumentContext } from "./SparkSqlParser";
import { TableArgumentPartitioningContext } from "./SparkSqlParser";
import { FunctionTableNamedArgumentExpressionContext } from "./SparkSqlParser";
import { FunctionTableReferenceArgumentContext } from "./SparkSqlParser";
import { FunctionTableArgumentContext } from "./SparkSqlParser";
import { FunctionTableContext } from "./SparkSqlParser";
import { TableAliasContext } from "./SparkSqlParser";
import { RowFormatContext } from "./SparkSqlParser";
import { MultipartIdentifierListContext } from "./SparkSqlParser";
import { MultipartIdentifierContext } from "./SparkSqlParser";
import { MultipartIdentifierPropertyListContext } from "./SparkSqlParser";
import { MultipartIdentifierPropertyContext } from "./SparkSqlParser";
import { TableIdentifierContext } from "./SparkSqlParser";
import { FunctionIdentifierContext } from "./SparkSqlParser";
import { NamedExpressionContext } from "./SparkSqlParser";
import { NamedExpressionSeqContext } from "./SparkSqlParser";
import { PartitionFieldListContext } from "./SparkSqlParser";
import { PartitionFieldContext } from "./SparkSqlParser";
import { TransformContext } from "./SparkSqlParser";
import { TransformArgumentContext } from "./SparkSqlParser";
import { ExpressionContext } from "./SparkSqlParser";
import { NamedArgumentExpressionContext } from "./SparkSqlParser";
import { FunctionArgumentContext } from "./SparkSqlParser";
import { ExpressionSeqContext } from "./SparkSqlParser";
import { BooleanExpressionContext } from "./SparkSqlParser";
import { PredicateContext } from "./SparkSqlParser";
import { ValueExpressionContext } from "./SparkSqlParser";
import { DatetimeUnitContext } from "./SparkSqlParser";
import { PrimaryExpressionContext } from "./SparkSqlParser";
import { LiteralTypeContext } from "./SparkSqlParser";
import { ConstantContext } from "./SparkSqlParser";
import { ComparisonOperatorContext } from "./SparkSqlParser";
import { ArithmeticOperatorContext } from "./SparkSqlParser";
import { PredicateOperatorContext } from "./SparkSqlParser";
import { BooleanValueContext } from "./SparkSqlParser";
import { IntervalContext } from "./SparkSqlParser";
import { ErrorCapturingMultiUnitsIntervalContext } from "./SparkSqlParser";
import { MultiUnitsIntervalContext } from "./SparkSqlParser";
import { ErrorCapturingUnitToUnitIntervalContext } from "./SparkSqlParser";
import { UnitToUnitIntervalContext } from "./SparkSqlParser";
import { IntervalValueContext } from "./SparkSqlParser";
import { UnitInMultiUnitsContext } from "./SparkSqlParser";
import { UnitInUnitToUnitContext } from "./SparkSqlParser";
import { ColPositionContext } from "./SparkSqlParser";
import { TypeContext } from "./SparkSqlParser";
import { DataTypeContext } from "./SparkSqlParser";
import { QualifiedColTypeWithPositionListContext } from "./SparkSqlParser";
import { QualifiedColTypeWithPositionContext } from "./SparkSqlParser";
import { ColDefinitionDescriptorWithPositionContext } from "./SparkSqlParser";
import { DefaultExpressionContext } from "./SparkSqlParser";
import { ColTypeListContext } from "./SparkSqlParser";
import { ColTypeContext } from "./SparkSqlParser";
import { CreateOrReplaceTableColTypeListContext } from "./SparkSqlParser";
import { CreateOrReplaceTableColTypeContext } from "./SparkSqlParser";
import { ColDefinitionOptionContext } from "./SparkSqlParser";
import { GenerationExpressionContext } from "./SparkSqlParser";
import { ComplexColTypeListContext } from "./SparkSqlParser";
import { ComplexColTypeContext } from "./SparkSqlParser";
import { WhenClauseContext } from "./SparkSqlParser";
import { WindowClauseContext } from "./SparkSqlParser";
import { NamedWindowContext } from "./SparkSqlParser";
import { WindowSpecContext } from "./SparkSqlParser";
import { WindowFrameContext } from "./SparkSqlParser";
import { FrameBoundContext } from "./SparkSqlParser";
import { QualifiedNameListContext } from "./SparkSqlParser";
import { FunctionNameContext } from "./SparkSqlParser";
import { QualifiedNameContext } from "./SparkSqlParser";
import { ErrorCapturingIdentifierContext } from "./SparkSqlParser";
import { ErrorCapturingIdentifierExtraContext } from "./SparkSqlParser";
import { IdentifierContext } from "./SparkSqlParser";
import { StrictIdentifierContext } from "./SparkSqlParser";
import { QuotedIdentifierContext } from "./SparkSqlParser";
import { BackQuotedIdentifierContext } from "./SparkSqlParser";
import { NumberContext } from "./SparkSqlParser";
import { AlterColumnActionContext } from "./SparkSqlParser";
import { StringLitContext } from "./SparkSqlParser";
import { CommentContext } from "./SparkSqlParser";
import { VersionContext } from "./SparkSqlParser";
import { AnsiNonReservedContext } from "./SparkSqlParser";
import { StrictNonReservedContext } from "./SparkSqlParser";
import { NonReservedContext } from "./SparkSqlParser";
export interface SparkSqlParserVisitor<Result> extends ParseTreeVisitor<Result> {
    visitTableName?: (ctx: TableNameContext) => Result;
    visitAliasedQuery?: (ctx: AliasedQueryContext) => Result;
    visitAliasedRelation?: (ctx: AliasedRelationContext) => Result;
    visitInlineTableDefault2?: (ctx: InlineTableDefault2Context) => Result;
    visitTableValuedFunction?: (ctx: TableValuedFunctionContext) => Result;
    visitSingleInsertQuery?: (ctx: SingleInsertQueryContext) => Result;
    visitMultiInsertQuery?: (ctx: MultiInsertQueryContext) => Result;
    visitDeleteFromTable?: (ctx: DeleteFromTableContext) => Result;
    visitUpdateTable?: (ctx: UpdateTableContext) => Result;
    visitMergeIntoTable?: (ctx: MergeIntoTableContext) => Result;
    visitCurrentLike?: (ctx: CurrentLikeContext) => Result;
    visitTimestampadd?: (ctx: TimestampaddContext) => Result;
    visitTimestampdiff?: (ctx: TimestampdiffContext) => Result;
    visitSearchedCase?: (ctx: SearchedCaseContext) => Result;
    visitSimpleCase?: (ctx: SimpleCaseContext) => Result;
    visitCast?: (ctx: CastContext) => Result;
    visitStruct?: (ctx: StructContext) => Result;
    visitFirst?: (ctx: FirstContext) => Result;
    visitAny_value?: (ctx: Any_valueContext) => Result;
    visitLast?: (ctx: LastContext) => Result;
    visitPosition?: (ctx: PositionContext) => Result;
    visitConstantDefault?: (ctx: ConstantDefaultContext) => Result;
    visitStar?: (ctx: StarContext) => Result;
    visitRowConstructor?: (ctx: RowConstructorContext) => Result;
    visitSubqueryExpression?: (ctx: SubqueryExpressionContext) => Result;
    visitIdentifierClause?: (ctx: IdentifierClauseContext) => Result;
    visitFunctionCall?: (ctx: FunctionCallContext) => Result;
    visitLambda?: (ctx: LambdaContext) => Result;
    visitSubscript?: (ctx: SubscriptContext) => Result;
    visitColumnReference?: (ctx: ColumnReferenceContext) => Result;
    visitDereference?: (ctx: DereferenceContext) => Result;
    visitParenthesizedExpression?: (ctx: ParenthesizedExpressionContext) => Result;
    visitExtract?: (ctx: ExtractContext) => Result;
    visitSubstring?: (ctx: SubstringContext) => Result;
    visitTrim?: (ctx: TrimContext) => Result;
    visitOverlay?: (ctx: OverlayContext) => Result;
    visitPercentile?: (ctx: PercentileContext) => Result;
    visitUnquotedIdentifier?: (ctx: UnquotedIdentifierContext) => Result;
    visitQuotedIdentifierAlternative?: (ctx: QuotedIdentifierAlternativeContext) => Result;
    visitTableFileFormat?: (ctx: TableFileFormatContext) => Result;
    visitGenericFileFormat?: (ctx: GenericFileFormatContext) => Result;
    visitSampleByPercentile?: (ctx: SampleByPercentileContext) => Result;
    visitSampleByRows?: (ctx: SampleByRowsContext) => Result;
    visitSampleByBucket?: (ctx: SampleByBucketContext) => Result;
    visitSampleByBytes?: (ctx: SampleByBytesContext) => Result;
    visitComplexDataType?: (ctx: ComplexDataTypeContext) => Result;
    visitYearMonthIntervalDataType?: (ctx: YearMonthIntervalDataTypeContext) => Result;
    visitDayTimeIntervalDataType?: (ctx: DayTimeIntervalDataTypeContext) => Result;
    visitPrimitiveDataType?: (ctx: PrimitiveDataTypeContext) => Result;
    visitTransformQuerySpecification?: (ctx: TransformQuerySpecificationContext) => Result;
    visitRegularQuerySpecification?: (ctx: RegularQuerySpecificationContext) => Result;
    visitErrorIdent?: (ctx: ErrorIdentContext) => Result;
    visitRealIdent?: (ctx: RealIdentContext) => Result;
    visitWindowRef?: (ctx: WindowRefContext) => Result;
    visitWindowDef?: (ctx: WindowDefContext) => Result;
    visitStatementDefault?: (ctx: StatementDefaultContext) => Result;
    visitDescribeStatement?: (ctx: DescribeStatementContext) => Result;
    visitUseStatement?: (ctx: UseStatementContext) => Result;
    visitDdlStatement?: (ctx: DdlStatementContext) => Result;
    visitDmlStatement?: (ctx: DmlStatementContext) => Result;
    visitUse?: (ctx: UseContext) => Result;
    visitUseNamespace?: (ctx: UseNamespaceContext) => Result;
    visitSetCatalog?: (ctx: SetCatalogContext) => Result;
    visitCreateNamespace?: (ctx: CreateNamespaceContext) => Result;
    visitSetNamespaceProperties?: (ctx: SetNamespacePropertiesContext) => Result;
    visitSetNamespaceLocation?: (ctx: SetNamespaceLocationContext) => Result;
    visitDropNamespace?: (ctx: DropNamespaceContext) => Result;
    visitShowNamespaces?: (ctx: ShowNamespacesContext) => Result;
    visitCreateTable?: (ctx: CreateTableContext) => Result;
    visitCreateTableLike?: (ctx: CreateTableLikeContext) => Result;
    visitReplaceTable?: (ctx: ReplaceTableContext) => Result;
    visitAnalyze?: (ctx: AnalyzeContext) => Result;
    visitAnalyzeTables?: (ctx: AnalyzeTablesContext) => Result;
    visitAddTableColumns?: (ctx: AddTableColumnsContext) => Result;
    visitRenameTableColumn?: (ctx: RenameTableColumnContext) => Result;
    visitDropTableColumns?: (ctx: DropTableColumnsContext) => Result;
    visitRenameTable?: (ctx: RenameTableContext) => Result;
    visitSetTableProperties?: (ctx: SetTablePropertiesContext) => Result;
    visitUnsetTableProperties?: (ctx: UnsetTablePropertiesContext) => Result;
    visitAlterTableAlterColumn?: (ctx: AlterTableAlterColumnContext) => Result;
    visitHiveChangeColumn?: (ctx: HiveChangeColumnContext) => Result;
    visitHiveReplaceColumns?: (ctx: HiveReplaceColumnsContext) => Result;
    visitSetTableSerDe?: (ctx: SetTableSerDeContext) => Result;
    visitAddTablePartition?: (ctx: AddTablePartitionContext) => Result;
    visitRenameTablePartition?: (ctx: RenameTablePartitionContext) => Result;
    visitDropTablePartitions?: (ctx: DropTablePartitionsContext) => Result;
    visitSetTableLocation?: (ctx: SetTableLocationContext) => Result;
    visitRecoverPartitions?: (ctx: RecoverPartitionsContext) => Result;
    visitDropTable?: (ctx: DropTableContext) => Result;
    visitDropView?: (ctx: DropViewContext) => Result;
    visitCreateView?: (ctx: CreateViewContext) => Result;
    visitCreateTempViewUsing?: (ctx: CreateTempViewUsingContext) => Result;
    visitAlterViewQuery?: (ctx: AlterViewQueryContext) => Result;
    visitCreateFunction?: (ctx: CreateFunctionContext) => Result;
    visitDropFunction?: (ctx: DropFunctionContext) => Result;
    visitExplain?: (ctx: ExplainContext) => Result;
    visitShowTables?: (ctx: ShowTablesContext) => Result;
    visitShowTableExtended?: (ctx: ShowTableExtendedContext) => Result;
    visitShowTblProperties?: (ctx: ShowTblPropertiesContext) => Result;
    visitShowColumns?: (ctx: ShowColumnsContext) => Result;
    visitShowViews?: (ctx: ShowViewsContext) => Result;
    visitShowPartitions?: (ctx: ShowPartitionsContext) => Result;
    visitShowFunctions?: (ctx: ShowFunctionsContext) => Result;
    visitShowCreateTable?: (ctx: ShowCreateTableContext) => Result;
    visitShowCurrentNamespace?: (ctx: ShowCurrentNamespaceContext) => Result;
    visitShowCatalogs?: (ctx: ShowCatalogsContext) => Result;
    visitDescribeFunction?: (ctx: DescribeFunctionContext) => Result;
    visitDescribeNamespace?: (ctx: DescribeNamespaceContext) => Result;
    visitDescribeRelation?: (ctx: DescribeRelationContext) => Result;
    visitDescribeQuery?: (ctx: DescribeQueryContext) => Result;
    visitCommentNamespace?: (ctx: CommentNamespaceContext) => Result;
    visitCommentTable?: (ctx: CommentTableContext) => Result;
    visitRefreshTable?: (ctx: RefreshTableContext) => Result;
    visitRefreshFunction?: (ctx: RefreshFunctionContext) => Result;
    visitRefreshResource?: (ctx: RefreshResourceContext) => Result;
    visitCacheTable?: (ctx: CacheTableContext) => Result;
    visitUncacheTable?: (ctx: UncacheTableContext) => Result;
    visitClearCache?: (ctx: ClearCacheContext) => Result;
    visitLoadData?: (ctx: LoadDataContext) => Result;
    visitTruncateTable?: (ctx: TruncateTableContext) => Result;
    visitRepairTable?: (ctx: RepairTableContext) => Result;
    visitManageResource?: (ctx: ManageResourceContext) => Result;
    visitFailNativeCommand?: (ctx: FailNativeCommandContext) => Result;
    visitSetTimeZone?: (ctx: SetTimeZoneContext) => Result;
    visitSetQuotedConfiguration?: (ctx: SetQuotedConfigurationContext) => Result;
    visitSetConfiguration?: (ctx: SetConfigurationContext) => Result;
    visitResetQuotedConfiguration?: (ctx: ResetQuotedConfigurationContext) => Result;
    visitResetConfiguration?: (ctx: ResetConfigurationContext) => Result;
    visitCreateIndex?: (ctx: CreateIndexContext) => Result;
    visitDropIndex?: (ctx: DropIndexContext) => Result;
    visitExponentLiteral?: (ctx: ExponentLiteralContext) => Result;
    visitDecimalLiteral?: (ctx: DecimalLiteralContext) => Result;
    visitLegacyDecimalLiteral?: (ctx: LegacyDecimalLiteralContext) => Result;
    visitIntegerLiteral?: (ctx: IntegerLiteralContext) => Result;
    visitBigIntLiteral?: (ctx: BigIntLiteralContext) => Result;
    visitSmallIntLiteral?: (ctx: SmallIntLiteralContext) => Result;
    visitTinyIntLiteral?: (ctx: TinyIntLiteralContext) => Result;
    visitDoubleLiteral?: (ctx: DoubleLiteralContext) => Result;
    visitFloatLiteral?: (ctx: FloatLiteralContext) => Result;
    visitBigDecimalLiteral?: (ctx: BigDecimalLiteralContext) => Result;
    visitQueryTermDefault?: (ctx: QueryTermDefaultContext) => Result;
    visitSetOperation?: (ctx: SetOperationContext) => Result;
    visitInsertOverwriteTable?: (ctx: InsertOverwriteTableContext) => Result;
    visitInsertIntoTable?: (ctx: InsertIntoTableContext) => Result;
    visitInsertIntoReplaceWhere?: (ctx: InsertIntoReplaceWhereContext) => Result;
    visitInsertOverwriteHiveDir?: (ctx: InsertOverwriteHiveDirContext) => Result;
    visitInsertOverwriteDir?: (ctx: InsertOverwriteDirContext) => Result;
    visitValueExpressionDefault?: (ctx: ValueExpressionDefaultContext) => Result;
    visitArithmeticUnary?: (ctx: ArithmeticUnaryContext) => Result;
    visitArithmeticBinary?: (ctx: ArithmeticBinaryContext) => Result;
    visitComparison?: (ctx: ComparisonContext) => Result;
    visitPartitionTransform?: (ctx: PartitionTransformContext) => Result;
    visitPartitionColumn?: (ctx: PartitionColumnContext) => Result;
    visitQueryPrimaryDefault?: (ctx: QueryPrimaryDefaultContext) => Result;
    visitFromStmt?: (ctx: FromStmtContext) => Result;
    visitTable?: (ctx: TableContext) => Result;
    visitInlineTableDefault1?: (ctx: InlineTableDefault1Context) => Result;
    visitSubquery?: (ctx: SubqueryContext) => Result;
    visitNullLiteral?: (ctx: NullLiteralContext) => Result;
    visitPosParameterLiteral?: (ctx: PosParameterLiteralContext) => Result;
    visitNamedParameterLiteral?: (ctx: NamedParameterLiteralContext) => Result;
    visitIntervalLiteral?: (ctx: IntervalLiteralContext) => Result;
    visitTypeConstructor?: (ctx: TypeConstructorContext) => Result;
    visitNumericLiteral?: (ctx: NumericLiteralContext) => Result;
    visitBooleanLiteral?: (ctx: BooleanLiteralContext) => Result;
    visitStringLiteral?: (ctx: StringLiteralContext) => Result;
    visitRowFormatSerde?: (ctx: RowFormatSerdeContext) => Result;
    visitRowFormatDelimited?: (ctx: RowFormatDelimitedContext) => Result;
    visitIdentityTransform?: (ctx: IdentityTransformContext) => Result;
    visitApplyTransform?: (ctx: ApplyTransformContext) => Result;
    visitLogicalNot?: (ctx: LogicalNotContext) => Result;
    visitExists?: (ctx: ExistsContext) => Result;
    visitPredicated?: (ctx: PredicatedContext) => Result;
    visitLogicalBinary?: (ctx: LogicalBinaryContext) => Result;
    visitProgram?: (ctx: ProgramContext) => Result;
    visitStatements?: (ctx: StatementsContext) => Result;
    visitStatementEnd?: (ctx: StatementEndContext) => Result;
    visitSingleStatement?: (ctx: SingleStatementContext) => Result;
    visitSingleExpression?: (ctx: SingleExpressionContext) => Result;
    visitSingleTableIdentifier?: (ctx: SingleTableIdentifierContext) => Result;
    visitSingleMultipartIdentifier?: (ctx: SingleMultipartIdentifierContext) => Result;
    visitSingleFunctionIdentifier?: (ctx: SingleFunctionIdentifierContext) => Result;
    visitSingleDataType?: (ctx: SingleDataTypeContext) => Result;
    visitSingleTableSchema?: (ctx: SingleTableSchemaContext) => Result;
    visitAnyNonStringName?: (ctx: AnyNonStringNameContext) => Result;
    visitCatalogNameDef?: (ctx: CatalogNameDefContext) => Result;
    visitDatabaseNameDef?: (ctx: DatabaseNameDefContext) => Result;
    visitColumnNameDef?: (ctx: ColumnNameDefContext) => Result;
    visitTableNameDef?: (ctx: TableNameDefContext) => Result;
    visitViewNameDef?: (ctx: ViewNameDefContext) => Result;
    visitCatalogDef?: (ctx: CatalogDefContext) => Result;
    visitDatabaseDef?: (ctx: DatabaseDefContext) => Result;
    visitTableDef?: (ctx: TableDefContext) => Result;
    visitViewDef?: (ctx: ViewDefContext) => Result;
    visitColumnDef?: (ctx: ColumnDefContext) => Result;
    visitDescribeDef?: (ctx: DescribeDefContext) => Result;
    visitDescribeCatalog?: (ctx: DescribeCatalogContext) => Result;
    visitDescribeDatabase?: (ctx: DescribeDatabaseContext) => Result;
    visitDescribeTable?: (ctx: DescribeTableContext) => Result;
    visitUseDef?: (ctx: UseDefContext) => Result;
    visitDdlStatementDef?: (ctx: DdlStatementDefContext) => Result;
    visitAlterDatabaseDef?: (ctx: AlterDatabaseDefContext) => Result;
    visitCreateDatabaseDef?: (ctx: CreateDatabaseDefContext) => Result;
    visitDropDatabaseDef?: (ctx: DropDatabaseDefContext) => Result;
    visitStatementForFolding?: (ctx: StatementForFoldingContext) => Result;
    visitStatement?: (ctx: StatementContext) => Result;
    visitTimezone?: (ctx: TimezoneContext) => Result;
    visitConfigKey?: (ctx: ConfigKeyContext) => Result;
    visitConfigValue?: (ctx: ConfigValueContext) => Result;
    visitUnsupportedHiveNativeCommands?: (ctx: UnsupportedHiveNativeCommandsContext) => Result;
    visitCreateTableHeader?: (ctx: CreateTableHeaderContext) => Result;
    visitReplaceTableHeader?: (ctx: ReplaceTableHeaderContext) => Result;
    visitBucketSpec?: (ctx: BucketSpecContext) => Result;
    visitSkewSpec?: (ctx: SkewSpecContext) => Result;
    visitLocationSpec?: (ctx: LocationSpecContext) => Result;
    visitCommentSpec?: (ctx: CommentSpecContext) => Result;
    visitQuery?: (ctx: QueryContext) => Result;
    visitInsertInto?: (ctx: InsertIntoContext) => Result;
    visitPartitionSpecLocation?: (ctx: PartitionSpecLocationContext) => Result;
    visitPartitionSpec?: (ctx: PartitionSpecContext) => Result;
    visitPartitionVal?: (ctx: PartitionValContext) => Result;
    visitNamespace?: (ctx: NamespaceContext) => Result;
    visitNamespaces?: (ctx: NamespacesContext) => Result;
    visitDescribeFuncName?: (ctx: DescribeFuncNameContext) => Result;
    visitDescribeColName?: (ctx: DescribeColNameContext) => Result;
    visitCtes?: (ctx: CtesContext) => Result;
    visitNamedQuery?: (ctx: NamedQueryContext) => Result;
    visitTableProvider?: (ctx: TableProviderContext) => Result;
    visitCreateTableClauses?: (ctx: CreateTableClausesContext) => Result;
    visitPropertyList?: (ctx: PropertyListContext) => Result;
    visitProperty?: (ctx: PropertyContext) => Result;
    visitPropertyKey?: (ctx: PropertyKeyContext) => Result;
    visitPropertyValue?: (ctx: PropertyValueContext) => Result;
    visitExpressionPropertyList?: (ctx: ExpressionPropertyListContext) => Result;
    visitExpressionProperty?: (ctx: ExpressionPropertyContext) => Result;
    visitConstantList?: (ctx: ConstantListContext) => Result;
    visitNestedConstantList?: (ctx: NestedConstantListContext) => Result;
    visitCreateFileFormat?: (ctx: CreateFileFormatContext) => Result;
    visitFileFormat?: (ctx: FileFormatContext) => Result;
    visitStorageHandler?: (ctx: StorageHandlerContext) => Result;
    visitResource?: (ctx: ResourceContext) => Result;
    visitDmlStatementNoWith?: (ctx: DmlStatementNoWithContext) => Result;
    visitIdentifierReference?: (ctx: IdentifierReferenceContext) => Result;
    visitQueryOrganization?: (ctx: QueryOrganizationContext) => Result;
    visitMultiInsertQueryBody?: (ctx: MultiInsertQueryBodyContext) => Result;
    visitQueryTerm?: (ctx: QueryTermContext) => Result;
    visitQueryPrimary?: (ctx: QueryPrimaryContext) => Result;
    visitSortItem?: (ctx: SortItemContext) => Result;
    visitFromStatement?: (ctx: FromStatementContext) => Result;
    visitFromStatementBody?: (ctx: FromStatementBodyContext) => Result;
    visitQuerySpecification?: (ctx: QuerySpecificationContext) => Result;
    visitTransformClause?: (ctx: TransformClauseContext) => Result;
    visitSelectClause?: (ctx: SelectClauseContext) => Result;
    visitSetClause?: (ctx: SetClauseContext) => Result;
    visitMatchedClause?: (ctx: MatchedClauseContext) => Result;
    visitNotMatchedClause?: (ctx: NotMatchedClauseContext) => Result;
    visitNotMatchedBySourceClause?: (ctx: NotMatchedBySourceClauseContext) => Result;
    visitMatchedAction?: (ctx: MatchedActionContext) => Result;
    visitNotMatchedAction?: (ctx: NotMatchedActionContext) => Result;
    visitNotMatchedBySourceAction?: (ctx: NotMatchedBySourceActionContext) => Result;
    visitAssignmentList?: (ctx: AssignmentListContext) => Result;
    visitAssignment?: (ctx: AssignmentContext) => Result;
    visitWhereClause?: (ctx: WhereClauseContext) => Result;
    visitHavingClause?: (ctx: HavingClauseContext) => Result;
    visitHint?: (ctx: HintContext) => Result;
    visitHintStatement?: (ctx: HintStatementContext) => Result;
    visitFromClause?: (ctx: FromClauseContext) => Result;
    visitTemporalClause?: (ctx: TemporalClauseContext) => Result;
    visitAggregationClause?: (ctx: AggregationClauseContext) => Result;
    visitGroupByClause?: (ctx: GroupByClauseContext) => Result;
    visitGroupingAnalytics?: (ctx: GroupingAnalyticsContext) => Result;
    visitGroupingElement?: (ctx: GroupingElementContext) => Result;
    visitGroupingSet?: (ctx: GroupingSetContext) => Result;
    visitPivotClause?: (ctx: PivotClauseContext) => Result;
    visitPivotColumn?: (ctx: PivotColumnContext) => Result;
    visitPivotValue?: (ctx: PivotValueContext) => Result;
    visitUnpivotClause?: (ctx: UnpivotClauseContext) => Result;
    visitUnpivotNullClause?: (ctx: UnpivotNullClauseContext) => Result;
    visitUnpivotOperator?: (ctx: UnpivotOperatorContext) => Result;
    visitUnpivotSingleValueColumnClause?: (ctx: UnpivotSingleValueColumnClauseContext) => Result;
    visitUnpivotMultiValueColumnClause?: (ctx: UnpivotMultiValueColumnClauseContext) => Result;
    visitUnpivotColumnSet?: (ctx: UnpivotColumnSetContext) => Result;
    visitUnpivotValueColumn?: (ctx: UnpivotValueColumnContext) => Result;
    visitUnpivotNameColumn?: (ctx: UnpivotNameColumnContext) => Result;
    visitUnpivotColumnAndAlias?: (ctx: UnpivotColumnAndAliasContext) => Result;
    visitUnpivotColumn?: (ctx: UnpivotColumnContext) => Result;
    visitUnpivotAlias?: (ctx: UnpivotAliasContext) => Result;
    visitLateralView?: (ctx: LateralViewContext) => Result;
    visitSetQuantifier?: (ctx: SetQuantifierContext) => Result;
    visitRelation?: (ctx: RelationContext) => Result;
    visitRelationExtension?: (ctx: RelationExtensionContext) => Result;
    visitJoinRelation?: (ctx: JoinRelationContext) => Result;
    visitJoinType?: (ctx: JoinTypeContext) => Result;
    visitJoinCriteria?: (ctx: JoinCriteriaContext) => Result;
    visitSample?: (ctx: SampleContext) => Result;
    visitSampleMethod?: (ctx: SampleMethodContext) => Result;
    visitIdentifierList?: (ctx: IdentifierListContext) => Result;
    visitIdentifierSeq?: (ctx: IdentifierSeqContext) => Result;
    visitOrderedIdentifierList?: (ctx: OrderedIdentifierListContext) => Result;
    visitOrderedIdentifier?: (ctx: OrderedIdentifierContext) => Result;
    visitIdentifierCommentList?: (ctx: IdentifierCommentListContext) => Result;
    visitIdentifierComment?: (ctx: IdentifierCommentContext) => Result;
    visitRelationPrimary?: (ctx: RelationPrimaryContext) => Result;
    visitInlineTable?: (ctx: InlineTableContext) => Result;
    visitFunctionTableSubqueryArgument?: (ctx: FunctionTableSubqueryArgumentContext) => Result;
    visitTableArgumentPartitioning?: (ctx: TableArgumentPartitioningContext) => Result;
    visitFunctionTableNamedArgumentExpression?: (ctx: FunctionTableNamedArgumentExpressionContext) => Result;
    visitFunctionTableReferenceArgument?: (ctx: FunctionTableReferenceArgumentContext) => Result;
    visitFunctionTableArgument?: (ctx: FunctionTableArgumentContext) => Result;
    visitFunctionTable?: (ctx: FunctionTableContext) => Result;
    visitTableAlias?: (ctx: TableAliasContext) => Result;
    visitRowFormat?: (ctx: RowFormatContext) => Result;
    visitMultipartIdentifierList?: (ctx: MultipartIdentifierListContext) => Result;
    visitMultipartIdentifier?: (ctx: MultipartIdentifierContext) => Result;
    visitMultipartIdentifierPropertyList?: (ctx: MultipartIdentifierPropertyListContext) => Result;
    visitMultipartIdentifierProperty?: (ctx: MultipartIdentifierPropertyContext) => Result;
    visitTableIdentifier?: (ctx: TableIdentifierContext) => Result;
    visitFunctionIdentifier?: (ctx: FunctionIdentifierContext) => Result;
    visitNamedExpression?: (ctx: NamedExpressionContext) => Result;
    visitNamedExpressionSeq?: (ctx: NamedExpressionSeqContext) => Result;
    visitPartitionFieldList?: (ctx: PartitionFieldListContext) => Result;
    visitPartitionField?: (ctx: PartitionFieldContext) => Result;
    visitTransform?: (ctx: TransformContext) => Result;
    visitTransformArgument?: (ctx: TransformArgumentContext) => Result;
    visitExpression?: (ctx: ExpressionContext) => Result;
    visitNamedArgumentExpression?: (ctx: NamedArgumentExpressionContext) => Result;
    visitFunctionArgument?: (ctx: FunctionArgumentContext) => Result;
    visitExpressionSeq?: (ctx: ExpressionSeqContext) => Result;
    visitBooleanExpression?: (ctx: BooleanExpressionContext) => Result;
    visitPredicate?: (ctx: PredicateContext) => Result;
    visitValueExpression?: (ctx: ValueExpressionContext) => Result;
    visitDatetimeUnit?: (ctx: DatetimeUnitContext) => Result;
    visitPrimaryExpression?: (ctx: PrimaryExpressionContext) => Result;
    visitLiteralType?: (ctx: LiteralTypeContext) => Result;
    visitConstant?: (ctx: ConstantContext) => Result;
    visitComparisonOperator?: (ctx: ComparisonOperatorContext) => Result;
    visitArithmeticOperator?: (ctx: ArithmeticOperatorContext) => Result;
    visitPredicateOperator?: (ctx: PredicateOperatorContext) => Result;
    visitBooleanValue?: (ctx: BooleanValueContext) => Result;
    visitInterval?: (ctx: IntervalContext) => Result;
    visitErrorCapturingMultiUnitsInterval?: (ctx: ErrorCapturingMultiUnitsIntervalContext) => Result;
    visitMultiUnitsInterval?: (ctx: MultiUnitsIntervalContext) => Result;
    visitErrorCapturingUnitToUnitInterval?: (ctx: ErrorCapturingUnitToUnitIntervalContext) => Result;
    visitUnitToUnitInterval?: (ctx: UnitToUnitIntervalContext) => Result;
    visitIntervalValue?: (ctx: IntervalValueContext) => Result;
    visitUnitInMultiUnits?: (ctx: UnitInMultiUnitsContext) => Result;
    visitUnitInUnitToUnit?: (ctx: UnitInUnitToUnitContext) => Result;
    visitColPosition?: (ctx: ColPositionContext) => Result;
    visitType?: (ctx: TypeContext) => Result;
    visitDataType?: (ctx: DataTypeContext) => Result;
    visitQualifiedColTypeWithPositionList?: (ctx: QualifiedColTypeWithPositionListContext) => Result;
    visitQualifiedColTypeWithPosition?: (ctx: QualifiedColTypeWithPositionContext) => Result;
    visitColDefinitionDescriptorWithPosition?: (ctx: ColDefinitionDescriptorWithPositionContext) => Result;
    visitDefaultExpression?: (ctx: DefaultExpressionContext) => Result;
    visitColTypeList?: (ctx: ColTypeListContext) => Result;
    visitColType?: (ctx: ColTypeContext) => Result;
    visitCreateOrReplaceTableColTypeList?: (ctx: CreateOrReplaceTableColTypeListContext) => Result;
    visitCreateOrReplaceTableColType?: (ctx: CreateOrReplaceTableColTypeContext) => Result;
    visitColDefinitionOption?: (ctx: ColDefinitionOptionContext) => Result;
    visitGenerationExpression?: (ctx: GenerationExpressionContext) => Result;
    visitComplexColTypeList?: (ctx: ComplexColTypeListContext) => Result;
    visitComplexColType?: (ctx: ComplexColTypeContext) => Result;
    visitWhenClause?: (ctx: WhenClauseContext) => Result;
    visitWindowClause?: (ctx: WindowClauseContext) => Result;
    visitNamedWindow?: (ctx: NamedWindowContext) => Result;
    visitWindowSpec?: (ctx: WindowSpecContext) => Result;
    visitWindowFrame?: (ctx: WindowFrameContext) => Result;
    visitFrameBound?: (ctx: FrameBoundContext) => Result;
    visitQualifiedNameList?: (ctx: QualifiedNameListContext) => Result;
    visitFunctionName?: (ctx: FunctionNameContext) => Result;
    visitQualifiedName?: (ctx: QualifiedNameContext) => Result;
    visitErrorCapturingIdentifier?: (ctx: ErrorCapturingIdentifierContext) => Result;
    visitErrorCapturingIdentifierExtra?: (ctx: ErrorCapturingIdentifierExtraContext) => Result;
    visitIdentifier?: (ctx: IdentifierContext) => Result;
    visitStrictIdentifier?: (ctx: StrictIdentifierContext) => Result;
    visitQuotedIdentifier?: (ctx: QuotedIdentifierContext) => Result;
    visitBackQuotedIdentifier?: (ctx: BackQuotedIdentifierContext) => Result;
    visitNumber?: (ctx: NumberContext) => Result;
    visitAlterColumnAction?: (ctx: AlterColumnActionContext) => Result;
    visitStringLit?: (ctx: StringLitContext) => Result;
    visitComment?: (ctx: CommentContext) => Result;
    visitVersion?: (ctx: VersionContext) => Result;
    visitAnsiNonReserved?: (ctx: AnsiNonReservedContext) => Result;
    visitStrictNonReserved?: (ctx: StrictNonReservedContext) => Result;
    visitNonReserved?: (ctx: NonReservedContext) => Result;
}
