import { Token } from 'antlr4ts/Token';
import * as lsp from 'vscode-languageserver';
import { CompletionItem, Diagnostic } from 'vscode-languageserver';
import { Position, TextDocument, TextEdit } from 'vscode-languageserver-textdocument';
import { ParsingWarehouse } from './parsing-warehouse';
import { SchemaRegistry } from './schema-registry';
export declare class LSPServer {
    private readonly _warehouse;
    private readonly _schemaRegistry;
    constructor();
    get warehouse(): ParsingWarehouse;
    get schemaRegistry(): SchemaRegistry;
    doValidation(document: TextDocument): Diagnostic[];
    doCompletion(document: TextDocument, position: Position): CompletionItem[];
    doFormatting(document: TextDocument, _options: lsp.FormattingOptions): TextEdit[];
    doFoldingRanges(document: TextDocument): lsp.FoldingRange[];
    getTokenByPosition(document: TextDocument, position: lsp.Position): Token | undefined;
    private getSemicolonRange;
}
