import { CommonTokenStream } from 'antlr4ts';
import * as lsp from 'vscode-languageserver';
import { Range, TextDocument } from 'vscode-languageserver-textdocument';
import { ProgramContext, SparkSqlParser } from './lib/SparkSqlParser';
export interface ParseResult {
    origin: string;
    tokenStream: CommonTokenStream;
    parser: SparkSqlParser;
    tree: ProgramContext;
    errors: lsp.Diagnostic[];
}
export declare class ParsingWarehouse {
    private _warehouse;
    setParsingValue(document: TextDocument): void;
    parseDocument(document: TextDocument, range?: Range): ParseResult;
    hasParsingValue(document: TextDocument): boolean;
    getParsingValue(document: TextDocument): ParseResult;
    removeParsingValue(documentUri: string): void;
}
