"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.toFoldingRange = exports.toCompletionItem = exports.toDiagnosticSeverity = void 0;
const vscode_languageserver_1 = require("vscode-languageserver");
const lsp = __importStar(require("vscode-languageserver"));
function toDiagnosticSeverity(category) {
    switch (category) {
        case 'error':
            return vscode_languageserver_1.DiagnosticSeverity.Error;
        case 'warning':
            return vscode_languageserver_1.DiagnosticSeverity.Warning;
        case 'suggestion':
            return vscode_languageserver_1.DiagnosticSeverity.Hint;
        default:
            return vscode_languageserver_1.DiagnosticSeverity.Error;
    }
}
exports.toDiagnosticSeverity = toDiagnosticSeverity;
function toCompletionItem(type, label, insertText, detail, documentation) {
    switch (type) {
        case 'catalog':
            return {
                kind: lsp.CompletionItemKind.Class,
                label,
                insertText,
                insertTextFormat: lsp.InsertTextFormat.Snippet,
                sortText: `AAA${label}`,
                documentation,
                detail,
                data: 'catalog'
            };
        case 'database':
            return {
                kind: lsp.CompletionItemKind.Enum,
                label,
                insertText,
                insertTextFormat: lsp.InsertTextFormat.Snippet,
                sortText: `BAA${label}`,
                documentation,
                detail,
                data: 'database'
            };
        case 'table':
            return {
                kind: lsp.CompletionItemKind.EnumMember,
                label,
                insertText,
                insertTextFormat: lsp.InsertTextFormat.Snippet,
                sortText: `CBA${label}`,
                documentation,
                detail,
                data: 'table'
            };
        case 'column':
            return {
                kind: lsp.CompletionItemKind.Field,
                label,
                insertText,
                insertTextFormat: lsp.InsertTextFormat.Snippet,
                sortText: `DAA${label}`,
                documentation,
                detail,
                data: 'column'
            };
        case 'view':
            return {
                kind: lsp.CompletionItemKind.EnumMember,
                label,
                insertText,
                insertTextFormat: lsp.InsertTextFormat.Snippet,
                sortText: `CAA${label}`,
                documentation,
                detail,
                data: 'view'
            };
        case 'function':
            return {
                kind: lsp.CompletionItemKind.Property,
                label,
                insertText: `\`${insertText}\``,
                insertTextFormat: lsp.InsertTextFormat.Snippet,
                sortText: `EAA${label}`,
                documentation,
                detail,
                data: 'function'
            };
        case 'built-in':
            return {
                kind: lsp.CompletionItemKind.Function,
                label,
                insertText,
                insertTextFormat: lsp.InsertTextFormat.Snippet,
                sortText: `FAA${label}`,
                documentation,
                detail,
                data: 'function'
            };
    }
}
exports.toCompletionItem = toCompletionItem;
function toFoldingRange(range, kind = lsp.FoldingRangeKind.Region) {
    return lsp.FoldingRange.create(range.start.line, range.end.line, range.start.character, range.end.character, kind);
}
exports.toFoldingRange = toFoldingRange;
//# sourceMappingURL=protocol-translation.js.map