import { ATN } from "antlr4ts/atn/ATN";
import { FailedPredicateException } from "antlr4ts/FailedPredicateException";
import { Parser } from "antlr4ts/Parser";
import { ParserRuleContext } from "antlr4ts/ParserRuleContext";
import { RuleContext } from "antlr4ts/RuleContext";
import { TerminalNode } from "antlr4ts/tree/TerminalNode";
import { Token } from "antlr4ts/Token";
import { TokenStream } from "antlr4ts/TokenStream";
import { Vocabulary } from "antlr4ts/Vocabulary";
import { SparkSqlParserListener } from "./SparkSqlParserListener";
import { SparkSqlParserVisitor } from "./SparkSqlParserVisitor";
export declare class SparkSqlParser extends Parser {
    static readonly SEMICOLON = 1;
    static readonly LEFT_PAREN = 2;
    static readonly RIGHT_PAREN = 3;
    static readonly COMMA = 4;
    static readonly DOT = 5;
    static readonly LEFT_BRACKET = 6;
    static readonly RIGHT_BRACKET = 7;
    static readonly ADD = 8;
    static readonly AFTER = 9;
    static readonly ALL = 10;
    static readonly ALTER = 11;
    static readonly ALWAYS = 12;
    static readonly ANALYZE = 13;
    static readonly AND = 14;
    static readonly ANTI = 15;
    static readonly ANY = 16;
    static readonly ANY_VALUE = 17;
    static readonly ARCHIVE = 18;
    static readonly ARRAY = 19;
    static readonly AS = 20;
    static readonly ASC = 21;
    static readonly AT = 22;
    static readonly AUTHORIZATION = 23;
    static readonly BETWEEN = 24;
    static readonly BIGINT = 25;
    static readonly BINARY = 26;
    static readonly BOOLEAN = 27;
    static readonly BOTH = 28;
    static readonly BUCKET = 29;
    static readonly BUCKETS = 30;
    static readonly BY = 31;
    static readonly BYTE = 32;
    static readonly CACHE = 33;
    static readonly CASCADE = 34;
    static readonly CASE = 35;
    static readonly CAST = 36;
    static readonly CATALOG = 37;
    static readonly CATALOGS = 38;
    static readonly CHANGE = 39;
    static readonly CHAR = 40;
    static readonly CHARACTER = 41;
    static readonly CHECK = 42;
    static readonly CLEAR = 43;
    static readonly CLUSTER = 44;
    static readonly CLUSTERED = 45;
    static readonly CODEGEN = 46;
    static readonly COLLATE = 47;
    static readonly COLLECTION = 48;
    static readonly COLUMN = 49;
    static readonly COLUMNS = 50;
    static readonly COMMENT = 51;
    static readonly COMMIT = 52;
    static readonly COMPACT = 53;
    static readonly COMPACTIONS = 54;
    static readonly COMPUTE = 55;
    static readonly CONCATENATE = 56;
    static readonly CONSTRAINT = 57;
    static readonly COST = 58;
    static readonly CREATE = 59;
    static readonly CROSS = 60;
    static readonly CUBE = 61;
    static readonly CURRENT = 62;
    static readonly CURRENT_DATE = 63;
    static readonly CURRENT_TIME = 64;
    static readonly CURRENT_TIMESTAMP = 65;
    static readonly CURRENT_USER = 66;
    static readonly DAY = 67;
    static readonly DAYS = 68;
    static readonly DAYOFYEAR = 69;
    static readonly DATA = 70;
    static readonly DATE = 71;
    static readonly DATABASE = 72;
    static readonly DATABASES = 73;
    static readonly DATEADD = 74;
    static readonly DATE_ADD = 75;
    static readonly DATEDIFF = 76;
    static readonly DATE_DIFF = 77;
    static readonly DBPROPERTIES = 78;
    static readonly DEC = 79;
    static readonly DECIMAL = 80;
    static readonly DEFAULT = 81;
    static readonly DEFINED = 82;
    static readonly DELETE = 83;
    static readonly DELIMITED = 84;
    static readonly DESC = 85;
    static readonly DESCRIBE = 86;
    static readonly DFS = 87;
    static readonly DIRECTORIES = 88;
    static readonly DIRECTORY = 89;
    static readonly DISTINCT = 90;
    static readonly DISTRIBUTE = 91;
    static readonly DIV = 92;
    static readonly DOUBLE = 93;
    static readonly DROP = 94;
    static readonly ELSE = 95;
    static readonly END = 96;
    static readonly ESCAPE = 97;
    static readonly ESCAPED = 98;
    static readonly EXCEPT = 99;
    static readonly EXCHANGE = 100;
    static readonly EXCLUDE = 101;
    static readonly EXISTS = 102;
    static readonly EXPLAIN = 103;
    static readonly EXPORT = 104;
    static readonly EXTENDED = 105;
    static readonly EXTERNAL = 106;
    static readonly EXTRACT = 107;
    static readonly FALSE = 108;
    static readonly FETCH = 109;
    static readonly FIELDS = 110;
    static readonly FILTER = 111;
    static readonly FILEFORMAT = 112;
    static readonly FIRST = 113;
    static readonly FLOAT = 114;
    static readonly FOLLOWING = 115;
    static readonly FOR = 116;
    static readonly FOREIGN = 117;
    static readonly FORMAT = 118;
    static readonly FORMATTED = 119;
    static readonly FROM = 120;
    static readonly FULL = 121;
    static readonly FUNCTION = 122;
    static readonly FUNCTIONS = 123;
    static readonly GENERATED = 124;
    static readonly GLOBAL = 125;
    static readonly GRANT = 126;
    static readonly GROUP = 127;
    static readonly GROUPING = 128;
    static readonly HAVING = 129;
    static readonly BINARY_HEX = 130;
    static readonly HOUR = 131;
    static readonly HOURS = 132;
    static readonly IDENTIFIER_KW = 133;
    static readonly IF = 134;
    static readonly IGNORE = 135;
    static readonly IMPORT = 136;
    static readonly IN = 137;
    static readonly INCLUDE = 138;
    static readonly INDEX = 139;
    static readonly INDEXES = 140;
    static readonly INNER = 141;
    static readonly INPATH = 142;
    static readonly INPUTFORMAT = 143;
    static readonly INSERT = 144;
    static readonly INTERSECT = 145;
    static readonly INTERVAL = 146;
    static readonly INT = 147;
    static readonly INTEGER = 148;
    static readonly INTO = 149;
    static readonly IS = 150;
    static readonly ITEMS = 151;
    static readonly JOIN = 152;
    static readonly KEYS = 153;
    static readonly LAST = 154;
    static readonly LATERAL = 155;
    static readonly LAZY = 156;
    static readonly LEADING = 157;
    static readonly LEFT = 158;
    static readonly LIKE = 159;
    static readonly ILIKE = 160;
    static readonly LIMIT = 161;
    static readonly LINES = 162;
    static readonly LIST = 163;
    static readonly LOAD = 164;
    static readonly LOCAL = 165;
    static readonly LOCATION = 166;
    static readonly LOCK = 167;
    static readonly LOCKS = 168;
    static readonly LOGICAL = 169;
    static readonly LONG = 170;
    static readonly MACRO = 171;
    static readonly MAP = 172;
    static readonly MATCHED = 173;
    static readonly MERGE = 174;
    static readonly MICROSECOND = 175;
    static readonly MICROSECONDS = 176;
    static readonly MILLISECOND = 177;
    static readonly MILLISECONDS = 178;
    static readonly MINUTE = 179;
    static readonly MINUTES = 180;
    static readonly MONTH = 181;
    static readonly MONTHS = 182;
    static readonly MSCK = 183;
    static readonly NAME = 184;
    static readonly NAMESPACE = 185;
    static readonly NAMESPACES = 186;
    static readonly NANOSECOND = 187;
    static readonly NANOSECONDS = 188;
    static readonly NATURAL = 189;
    static readonly NO = 190;
    static readonly NOT = 191;
    static readonly NULL = 192;
    static readonly NULLS = 193;
    static readonly NUMERIC = 194;
    static readonly OF = 195;
    static readonly OFFSET = 196;
    static readonly ON = 197;
    static readonly ONLY = 198;
    static readonly OPTION = 199;
    static readonly OPTIONS = 200;
    static readonly OR = 201;
    static readonly ORDER = 202;
    static readonly OUT = 203;
    static readonly OUTER = 204;
    static readonly OUTPUTFORMAT = 205;
    static readonly OVER = 206;
    static readonly OVERLAPS = 207;
    static readonly OVERLAY = 208;
    static readonly OVERWRITE = 209;
    static readonly PARTITION = 210;
    static readonly PARTITIONED = 211;
    static readonly PARTITIONS = 212;
    static readonly PERCENTILE_CONT = 213;
    static readonly PERCENTILE_DISC = 214;
    static readonly PERCENTLIT = 215;
    static readonly PIVOT = 216;
    static readonly PLACING = 217;
    static readonly POSITION = 218;
    static readonly PRECEDING = 219;
    static readonly PRIMARY = 220;
    static readonly PRINCIPALS = 221;
    static readonly PROPERTIES = 222;
    static readonly PURGE = 223;
    static readonly QUARTER = 224;
    static readonly QUERY = 225;
    static readonly RANGE = 226;
    static readonly REAL = 227;
    static readonly RECORDREADER = 228;
    static readonly RECORDWRITER = 229;
    static readonly RECOVER = 230;
    static readonly REDUCE = 231;
    static readonly REFERENCES = 232;
    static readonly REFRESH = 233;
    static readonly RENAME = 234;
    static readonly REPAIR = 235;
    static readonly REPEATABLE = 236;
    static readonly REPLACE = 237;
    static readonly RESET = 238;
    static readonly RESPECT = 239;
    static readonly RESTRICT = 240;
    static readonly REVOKE = 241;
    static readonly RIGHT = 242;
    static readonly RLIKE = 243;
    static readonly ROLE = 244;
    static readonly ROLES = 245;
    static readonly ROLLBACK = 246;
    static readonly ROLLUP = 247;
    static readonly ROW = 248;
    static readonly ROWS = 249;
    static readonly SECOND = 250;
    static readonly SECONDS = 251;
    static readonly SCHEMA = 252;
    static readonly SCHEMAS = 253;
    static readonly SELECT = 254;
    static readonly SEMI = 255;
    static readonly SEPARATED = 256;
    static readonly SERDE = 257;
    static readonly SERDEPROPERTIES = 258;
    static readonly SESSION_USER = 259;
    static readonly SET = 260;
    static readonly SETMINUS = 261;
    static readonly SETS = 262;
    static readonly SHORT = 263;
    static readonly SHOW = 264;
    static readonly SKEWED = 265;
    static readonly SMALLINT = 266;
    static readonly SOME = 267;
    static readonly SORT = 268;
    static readonly SORTED = 269;
    static readonly SOURCE = 270;
    static readonly START = 271;
    static readonly STATISTICS = 272;
    static readonly STORED = 273;
    static readonly STRATIFY = 274;
    static readonly STRING = 275;
    static readonly STRUCT = 276;
    static readonly SUBSTR = 277;
    static readonly SUBSTRING = 278;
    static readonly SYNC = 279;
    static readonly SYSTEM_TIME = 280;
    static readonly SYSTEM_VERSION = 281;
    static readonly TABLE = 282;
    static readonly TABLES = 283;
    static readonly TABLESAMPLE = 284;
    static readonly TARGET = 285;
    static readonly TBLPROPERTIES = 286;
    static readonly TEMPORARY = 287;
    static readonly TERMINATED = 288;
    static readonly THEN = 289;
    static readonly TIME = 290;
    static readonly TIMESTAMP = 291;
    static readonly TIMESTAMP_LTZ = 292;
    static readonly TIMESTAMP_NTZ = 293;
    static readonly TIMESTAMPADD = 294;
    static readonly TIMESTAMPDIFF = 295;
    static readonly TINYINT = 296;
    static readonly TO = 297;
    static readonly TOUCH = 298;
    static readonly TRAILING = 299;
    static readonly TRANSACTION = 300;
    static readonly TRANSACTIONS = 301;
    static readonly TRANSFORM = 302;
    static readonly TRIM = 303;
    static readonly TRUE = 304;
    static readonly TRUNCATE = 305;
    static readonly TRY_CAST = 306;
    static readonly TYPE = 307;
    static readonly UNARCHIVE = 308;
    static readonly UNBOUNDED = 309;
    static readonly UNCACHE = 310;
    static readonly UNION = 311;
    static readonly UNIQUE = 312;
    static readonly UNKNOWN = 313;
    static readonly UNLOCK = 314;
    static readonly UNPIVOT = 315;
    static readonly UNSET = 316;
    static readonly UPDATE = 317;
    static readonly USE = 318;
    static readonly USER = 319;
    static readonly USING = 320;
    static readonly VALUES = 321;
    static readonly VARCHAR = 322;
    static readonly VERSION = 323;
    static readonly VIEW = 324;
    static readonly VIEWS = 325;
    static readonly VOID = 326;
    static readonly WEEK = 327;
    static readonly WEEKS = 328;
    static readonly WHEN = 329;
    static readonly WHERE = 330;
    static readonly WINDOW = 331;
    static readonly WITH = 332;
    static readonly WITHIN = 333;
    static readonly YEAR = 334;
    static readonly YEARS = 335;
    static readonly ZONE = 336;
    static readonly EQ = 337;
    static readonly NSEQ = 338;
    static readonly NEQ = 339;
    static readonly NEQJ = 340;
    static readonly LT = 341;
    static readonly LTE = 342;
    static readonly GT = 343;
    static readonly GTE = 344;
    static readonly PLUS = 345;
    static readonly MINUS = 346;
    static readonly ASTERISK = 347;
    static readonly SLASH = 348;
    static readonly PERCENT = 349;
    static readonly TILDE = 350;
    static readonly AMPERSAND = 351;
    static readonly PIPE = 352;
    static readonly CONCAT_PIPE = 353;
    static readonly HAT = 354;
    static readonly COLON = 355;
    static readonly ARROW = 356;
    static readonly FAT_ARROW = 357;
    static readonly HENT_START = 358;
    static readonly HENT_END = 359;
    static readonly QUESTION = 360;
    static readonly STRING_LITERAL = 361;
    static readonly DOUBLEQUOTED_STRING = 362;
    static readonly BIGINT_LITERAL = 363;
    static readonly SMALLINT_LITERAL = 364;
    static readonly TINYINT_LITERAL = 365;
    static readonly INTEGER_VALUE = 366;
    static readonly EXPONENT_VALUE = 367;
    static readonly DECIMAL_VALUE = 368;
    static readonly FLOAT_LITERAL = 369;
    static readonly DOUBLE_LITERAL = 370;
    static readonly BIGDECIMAL_LITERAL = 371;
    static readonly IDENTIFIER = 372;
    static readonly BACKQUOTED_IDENTIFIER = 373;
    static readonly SIMPLE_COMMENT = 374;
    static readonly BRACKETED_COMMENT = 375;
    static readonly WS = 376;
    static readonly UNRECOGNIZED = 377;
    static readonly RULE_program = 0;
    static readonly RULE_statements = 1;
    static readonly RULE_statementEnd = 2;
    static readonly RULE_singleStatement = 3;
    static readonly RULE_singleExpression = 4;
    static readonly RULE_singleTableIdentifier = 5;
    static readonly RULE_singleMultipartIdentifier = 6;
    static readonly RULE_singleFunctionIdentifier = 7;
    static readonly RULE_singleDataType = 8;
    static readonly RULE_singleTableSchema = 9;
    static readonly RULE_anyNonStringName = 10;
    static readonly RULE_catalogNameDef = 11;
    static readonly RULE_databaseNameDef = 12;
    static readonly RULE_columnNameDef = 13;
    static readonly RULE_tableNameDef = 14;
    static readonly RULE_viewNameDef = 15;
    static readonly RULE_catalogDef = 16;
    static readonly RULE_databaseDef = 17;
    static readonly RULE_tableDef = 18;
    static readonly RULE_viewDef = 19;
    static readonly RULE_columnDef = 20;
    static readonly RULE_describeDef = 21;
    static readonly RULE_describeCatalog = 22;
    static readonly RULE_describeDatabase = 23;
    static readonly RULE_describeTable = 24;
    static readonly RULE_useDef = 25;
    static readonly RULE_ddlStatementDef = 26;
    static readonly RULE_alterDatabaseDef = 27;
    static readonly RULE_createDatabaseDef = 28;
    static readonly RULE_dropDatabaseDef = 29;
    static readonly RULE_statementForFolding = 30;
    static readonly RULE_statement = 31;
    static readonly RULE_timezone = 32;
    static readonly RULE_configKey = 33;
    static readonly RULE_configValue = 34;
    static readonly RULE_unsupportedHiveNativeCommands = 35;
    static readonly RULE_createTableHeader = 36;
    static readonly RULE_replaceTableHeader = 37;
    static readonly RULE_bucketSpec = 38;
    static readonly RULE_skewSpec = 39;
    static readonly RULE_locationSpec = 40;
    static readonly RULE_commentSpec = 41;
    static readonly RULE_query = 42;
    static readonly RULE_insertInto = 43;
    static readonly RULE_partitionSpecLocation = 44;
    static readonly RULE_partitionSpec = 45;
    static readonly RULE_partitionVal = 46;
    static readonly RULE_namespace = 47;
    static readonly RULE_namespaces = 48;
    static readonly RULE_describeFuncName = 49;
    static readonly RULE_describeColName = 50;
    static readonly RULE_ctes = 51;
    static readonly RULE_namedQuery = 52;
    static readonly RULE_tableProvider = 53;
    static readonly RULE_createTableClauses = 54;
    static readonly RULE_propertyList = 55;
    static readonly RULE_property = 56;
    static readonly RULE_propertyKey = 57;
    static readonly RULE_propertyValue = 58;
    static readonly RULE_expressionPropertyList = 59;
    static readonly RULE_expressionProperty = 60;
    static readonly RULE_constantList = 61;
    static readonly RULE_nestedConstantList = 62;
    static readonly RULE_createFileFormat = 63;
    static readonly RULE_fileFormat = 64;
    static readonly RULE_storageHandler = 65;
    static readonly RULE_resource = 66;
    static readonly RULE_dmlStatementNoWith = 67;
    static readonly RULE_identifierReference = 68;
    static readonly RULE_queryOrganization = 69;
    static readonly RULE_multiInsertQueryBody = 70;
    static readonly RULE_queryTerm = 71;
    static readonly RULE_queryPrimary = 72;
    static readonly RULE_sortItem = 73;
    static readonly RULE_fromStatement = 74;
    static readonly RULE_fromStatementBody = 75;
    static readonly RULE_querySpecification = 76;
    static readonly RULE_transformClause = 77;
    static readonly RULE_selectClause = 78;
    static readonly RULE_setClause = 79;
    static readonly RULE_matchedClause = 80;
    static readonly RULE_notMatchedClause = 81;
    static readonly RULE_notMatchedBySourceClause = 82;
    static readonly RULE_matchedAction = 83;
    static readonly RULE_notMatchedAction = 84;
    static readonly RULE_notMatchedBySourceAction = 85;
    static readonly RULE_assignmentList = 86;
    static readonly RULE_assignment = 87;
    static readonly RULE_whereClause = 88;
    static readonly RULE_havingClause = 89;
    static readonly RULE_hint = 90;
    static readonly RULE_hintStatement = 91;
    static readonly RULE_fromClause = 92;
    static readonly RULE_temporalClause = 93;
    static readonly RULE_aggregationClause = 94;
    static readonly RULE_groupByClause = 95;
    static readonly RULE_groupingAnalytics = 96;
    static readonly RULE_groupingElement = 97;
    static readonly RULE_groupingSet = 98;
    static readonly RULE_pivotClause = 99;
    static readonly RULE_pivotColumn = 100;
    static readonly RULE_pivotValue = 101;
    static readonly RULE_unpivotClause = 102;
    static readonly RULE_unpivotNullClause = 103;
    static readonly RULE_unpivotOperator = 104;
    static readonly RULE_unpivotSingleValueColumnClause = 105;
    static readonly RULE_unpivotMultiValueColumnClause = 106;
    static readonly RULE_unpivotColumnSet = 107;
    static readonly RULE_unpivotValueColumn = 108;
    static readonly RULE_unpivotNameColumn = 109;
    static readonly RULE_unpivotColumnAndAlias = 110;
    static readonly RULE_unpivotColumn = 111;
    static readonly RULE_unpivotAlias = 112;
    static readonly RULE_lateralView = 113;
    static readonly RULE_setQuantifier = 114;
    static readonly RULE_relation = 115;
    static readonly RULE_relationExtension = 116;
    static readonly RULE_joinRelation = 117;
    static readonly RULE_joinType = 118;
    static readonly RULE_joinCriteria = 119;
    static readonly RULE_sample = 120;
    static readonly RULE_sampleMethod = 121;
    static readonly RULE_identifierList = 122;
    static readonly RULE_identifierSeq = 123;
    static readonly RULE_orderedIdentifierList = 124;
    static readonly RULE_orderedIdentifier = 125;
    static readonly RULE_identifierCommentList = 126;
    static readonly RULE_identifierComment = 127;
    static readonly RULE_relationPrimary = 128;
    static readonly RULE_inlineTable = 129;
    static readonly RULE_functionTableSubqueryArgument = 130;
    static readonly RULE_tableArgumentPartitioning = 131;
    static readonly RULE_functionTableNamedArgumentExpression = 132;
    static readonly RULE_functionTableReferenceArgument = 133;
    static readonly RULE_functionTableArgument = 134;
    static readonly RULE_functionTable = 135;
    static readonly RULE_tableAlias = 136;
    static readonly RULE_rowFormat = 137;
    static readonly RULE_multipartIdentifierList = 138;
    static readonly RULE_multipartIdentifier = 139;
    static readonly RULE_multipartIdentifierPropertyList = 140;
    static readonly RULE_multipartIdentifierProperty = 141;
    static readonly RULE_tableIdentifier = 142;
    static readonly RULE_functionIdentifier = 143;
    static readonly RULE_namedExpression = 144;
    static readonly RULE_namedExpressionSeq = 145;
    static readonly RULE_partitionFieldList = 146;
    static readonly RULE_partitionField = 147;
    static readonly RULE_transform = 148;
    static readonly RULE_transformArgument = 149;
    static readonly RULE_expression = 150;
    static readonly RULE_namedArgumentExpression = 151;
    static readonly RULE_functionArgument = 152;
    static readonly RULE_expressionSeq = 153;
    static readonly RULE_booleanExpression = 154;
    static readonly RULE_predicate = 155;
    static readonly RULE_valueExpression = 156;
    static readonly RULE_datetimeUnit = 157;
    static readonly RULE_primaryExpression = 158;
    static readonly RULE_literalType = 159;
    static readonly RULE_constant = 160;
    static readonly RULE_comparisonOperator = 161;
    static readonly RULE_arithmeticOperator = 162;
    static readonly RULE_predicateOperator = 163;
    static readonly RULE_booleanValue = 164;
    static readonly RULE_interval = 165;
    static readonly RULE_errorCapturingMultiUnitsInterval = 166;
    static readonly RULE_multiUnitsInterval = 167;
    static readonly RULE_errorCapturingUnitToUnitInterval = 168;
    static readonly RULE_unitToUnitInterval = 169;
    static readonly RULE_intervalValue = 170;
    static readonly RULE_unitInMultiUnits = 171;
    static readonly RULE_unitInUnitToUnit = 172;
    static readonly RULE_colPosition = 173;
    static readonly RULE_type = 174;
    static readonly RULE_dataType = 175;
    static readonly RULE_qualifiedColTypeWithPositionList = 176;
    static readonly RULE_qualifiedColTypeWithPosition = 177;
    static readonly RULE_colDefinitionDescriptorWithPosition = 178;
    static readonly RULE_defaultExpression = 179;
    static readonly RULE_colTypeList = 180;
    static readonly RULE_colType = 181;
    static readonly RULE_createOrReplaceTableColTypeList = 182;
    static readonly RULE_createOrReplaceTableColType = 183;
    static readonly RULE_colDefinitionOption = 184;
    static readonly RULE_generationExpression = 185;
    static readonly RULE_complexColTypeList = 186;
    static readonly RULE_complexColType = 187;
    static readonly RULE_whenClause = 188;
    static readonly RULE_windowClause = 189;
    static readonly RULE_namedWindow = 190;
    static readonly RULE_windowSpec = 191;
    static readonly RULE_windowFrame = 192;
    static readonly RULE_frameBound = 193;
    static readonly RULE_qualifiedNameList = 194;
    static readonly RULE_functionName = 195;
    static readonly RULE_qualifiedName = 196;
    static readonly RULE_errorCapturingIdentifier = 197;
    static readonly RULE_errorCapturingIdentifierExtra = 198;
    static readonly RULE_identifier = 199;
    static readonly RULE_strictIdentifier = 200;
    static readonly RULE_quotedIdentifier = 201;
    static readonly RULE_backQuotedIdentifier = 202;
    static readonly RULE_number = 203;
    static readonly RULE_alterColumnAction = 204;
    static readonly RULE_stringLit = 205;
    static readonly RULE_comment = 206;
    static readonly RULE_version = 207;
    static readonly RULE_ansiNonReserved = 208;
    static readonly RULE_strictNonReserved = 209;
    static readonly RULE_nonReserved = 210;
    static readonly ruleNames: string[];
    private static readonly _LITERAL_NAMES;
    private static readonly _SYMBOLIC_NAMES;
    static readonly VOCABULARY: Vocabulary;
    get vocabulary(): Vocabulary;
    get grammarFileName(): string;
    get ruleNames(): string[];
    get serializedATN(): string;
    protected createFailedPredicateException(predicate?: string, message?: string): FailedPredicateException;
    legacy_setops_precedence_enabled: boolean;
    legacy_exponent_literal_as_decimal_enabled: boolean;
    SQL_standard_keyword_behavior: boolean;
    double_quoted_identifiers: boolean;
    constructor(input: TokenStream);
    program(): ProgramContext;
    statements(): StatementsContext;
    statementEnd(): StatementEndContext;
    singleStatement(): SingleStatementContext;
    singleExpression(): SingleExpressionContext;
    singleTableIdentifier(): SingleTableIdentifierContext;
    singleMultipartIdentifier(): SingleMultipartIdentifierContext;
    singleFunctionIdentifier(): SingleFunctionIdentifierContext;
    singleDataType(): SingleDataTypeContext;
    singleTableSchema(): SingleTableSchemaContext;
    anyNonStringName(): AnyNonStringNameContext;
    catalogNameDef(): CatalogNameDefContext;
    databaseNameDef(): DatabaseNameDefContext;
    columnNameDef(): ColumnNameDefContext;
    tableNameDef(): TableNameDefContext;
    viewNameDef(): ViewNameDefContext;
    catalogDef(): CatalogDefContext;
    databaseDef(): DatabaseDefContext;
    tableDef(): TableDefContext;
    viewDef(): ViewDefContext;
    columnDef(): ColumnDefContext;
    describeDef(): DescribeDefContext;
    describeCatalog(): DescribeCatalogContext;
    describeDatabase(): DescribeDatabaseContext;
    describeTable(): DescribeTableContext;
    useDef(): UseDefContext;
    ddlStatementDef(): DdlStatementDefContext;
    alterDatabaseDef(): AlterDatabaseDefContext;
    createDatabaseDef(): CreateDatabaseDefContext;
    dropDatabaseDef(): DropDatabaseDefContext;
    statementForFolding(): StatementForFoldingContext;
    statement(): StatementContext;
    timezone(): TimezoneContext;
    configKey(): ConfigKeyContext;
    configValue(): ConfigValueContext;
    unsupportedHiveNativeCommands(): UnsupportedHiveNativeCommandsContext;
    createTableHeader(): CreateTableHeaderContext;
    replaceTableHeader(): ReplaceTableHeaderContext;
    bucketSpec(): BucketSpecContext;
    skewSpec(): SkewSpecContext;
    locationSpec(): LocationSpecContext;
    commentSpec(): CommentSpecContext;
    query(): QueryContext;
    insertInto(): InsertIntoContext;
    partitionSpecLocation(): PartitionSpecLocationContext;
    partitionSpec(): PartitionSpecContext;
    partitionVal(): PartitionValContext;
    namespace(): NamespaceContext;
    namespaces(): NamespacesContext;
    describeFuncName(): DescribeFuncNameContext;
    describeColName(): DescribeColNameContext;
    ctes(): CtesContext;
    namedQuery(): NamedQueryContext;
    tableProvider(): TableProviderContext;
    createTableClauses(): CreateTableClausesContext;
    propertyList(): PropertyListContext;
    property(): PropertyContext;
    propertyKey(): PropertyKeyContext;
    propertyValue(): PropertyValueContext;
    expressionPropertyList(): ExpressionPropertyListContext;
    expressionProperty(): ExpressionPropertyContext;
    constantList(): ConstantListContext;
    nestedConstantList(): NestedConstantListContext;
    createFileFormat(): CreateFileFormatContext;
    fileFormat(): FileFormatContext;
    storageHandler(): StorageHandlerContext;
    resource(): ResourceContext;
    dmlStatementNoWith(): DmlStatementNoWithContext;
    identifierReference(): IdentifierReferenceContext;
    queryOrganization(): QueryOrganizationContext;
    multiInsertQueryBody(): MultiInsertQueryBodyContext;
    queryTerm(): QueryTermContext;
    queryTerm(_p: number): QueryTermContext;
    queryPrimary(): QueryPrimaryContext;
    sortItem(): SortItemContext;
    fromStatement(): FromStatementContext;
    fromStatementBody(): FromStatementBodyContext;
    querySpecification(): QuerySpecificationContext;
    transformClause(): TransformClauseContext;
    selectClause(): SelectClauseContext;
    setClause(): SetClauseContext;
    matchedClause(): MatchedClauseContext;
    notMatchedClause(): NotMatchedClauseContext;
    notMatchedBySourceClause(): NotMatchedBySourceClauseContext;
    matchedAction(): MatchedActionContext;
    notMatchedAction(): NotMatchedActionContext;
    notMatchedBySourceAction(): NotMatchedBySourceActionContext;
    assignmentList(): AssignmentListContext;
    assignment(): AssignmentContext;
    whereClause(): WhereClauseContext;
    havingClause(): HavingClauseContext;
    hint(): HintContext;
    hintStatement(): HintStatementContext;
    fromClause(): FromClauseContext;
    temporalClause(): TemporalClauseContext;
    aggregationClause(): AggregationClauseContext;
    groupByClause(): GroupByClauseContext;
    groupingAnalytics(): GroupingAnalyticsContext;
    groupingElement(): GroupingElementContext;
    groupingSet(): GroupingSetContext;
    pivotClause(): PivotClauseContext;
    pivotColumn(): PivotColumnContext;
    pivotValue(): PivotValueContext;
    unpivotClause(): UnpivotClauseContext;
    unpivotNullClause(): UnpivotNullClauseContext;
    unpivotOperator(): UnpivotOperatorContext;
    unpivotSingleValueColumnClause(): UnpivotSingleValueColumnClauseContext;
    unpivotMultiValueColumnClause(): UnpivotMultiValueColumnClauseContext;
    unpivotColumnSet(): UnpivotColumnSetContext;
    unpivotValueColumn(): UnpivotValueColumnContext;
    unpivotNameColumn(): UnpivotNameColumnContext;
    unpivotColumnAndAlias(): UnpivotColumnAndAliasContext;
    unpivotColumn(): UnpivotColumnContext;
    unpivotAlias(): UnpivotAliasContext;
    lateralView(): LateralViewContext;
    setQuantifier(): SetQuantifierContext;
    relation(): RelationContext;
    relationExtension(): RelationExtensionContext;
    joinRelation(): JoinRelationContext;
    joinType(): JoinTypeContext;
    joinCriteria(): JoinCriteriaContext;
    sample(): SampleContext;
    sampleMethod(): SampleMethodContext;
    identifierList(): IdentifierListContext;
    identifierSeq(): IdentifierSeqContext;
    orderedIdentifierList(): OrderedIdentifierListContext;
    orderedIdentifier(): OrderedIdentifierContext;
    identifierCommentList(): IdentifierCommentListContext;
    identifierComment(): IdentifierCommentContext;
    relationPrimary(): RelationPrimaryContext;
    inlineTable(): InlineTableContext;
    functionTableSubqueryArgument(): FunctionTableSubqueryArgumentContext;
    tableArgumentPartitioning(): TableArgumentPartitioningContext;
    functionTableNamedArgumentExpression(): FunctionTableNamedArgumentExpressionContext;
    functionTableReferenceArgument(): FunctionTableReferenceArgumentContext;
    functionTableArgument(): FunctionTableArgumentContext;
    functionTable(): FunctionTableContext;
    tableAlias(): TableAliasContext;
    rowFormat(): RowFormatContext;
    multipartIdentifierList(): MultipartIdentifierListContext;
    multipartIdentifier(): MultipartIdentifierContext;
    multipartIdentifierPropertyList(): MultipartIdentifierPropertyListContext;
    multipartIdentifierProperty(): MultipartIdentifierPropertyContext;
    tableIdentifier(): TableIdentifierContext;
    functionIdentifier(): FunctionIdentifierContext;
    namedExpression(): NamedExpressionContext;
    namedExpressionSeq(): NamedExpressionSeqContext;
    partitionFieldList(): PartitionFieldListContext;
    partitionField(): PartitionFieldContext;
    transform(): TransformContext;
    transformArgument(): TransformArgumentContext;
    expression(): ExpressionContext;
    namedArgumentExpression(): NamedArgumentExpressionContext;
    functionArgument(): FunctionArgumentContext;
    expressionSeq(): ExpressionSeqContext;
    booleanExpression(): BooleanExpressionContext;
    booleanExpression(_p: number): BooleanExpressionContext;
    predicate(): PredicateContext;
    valueExpression(): ValueExpressionContext;
    valueExpression(_p: number): ValueExpressionContext;
    datetimeUnit(): DatetimeUnitContext;
    primaryExpression(): PrimaryExpressionContext;
    primaryExpression(_p: number): PrimaryExpressionContext;
    literalType(): LiteralTypeContext;
    constant(): ConstantContext;
    comparisonOperator(): ComparisonOperatorContext;
    arithmeticOperator(): ArithmeticOperatorContext;
    predicateOperator(): PredicateOperatorContext;
    booleanValue(): BooleanValueContext;
    interval(): IntervalContext;
    errorCapturingMultiUnitsInterval(): ErrorCapturingMultiUnitsIntervalContext;
    multiUnitsInterval(): MultiUnitsIntervalContext;
    errorCapturingUnitToUnitInterval(): ErrorCapturingUnitToUnitIntervalContext;
    unitToUnitInterval(): UnitToUnitIntervalContext;
    intervalValue(): IntervalValueContext;
    unitInMultiUnits(): UnitInMultiUnitsContext;
    unitInUnitToUnit(): UnitInUnitToUnitContext;
    colPosition(): ColPositionContext;
    type(): TypeContext;
    dataType(): DataTypeContext;
    qualifiedColTypeWithPositionList(): QualifiedColTypeWithPositionListContext;
    qualifiedColTypeWithPosition(): QualifiedColTypeWithPositionContext;
    colDefinitionDescriptorWithPosition(): ColDefinitionDescriptorWithPositionContext;
    defaultExpression(): DefaultExpressionContext;
    colTypeList(): ColTypeListContext;
    colType(): ColTypeContext;
    createOrReplaceTableColTypeList(): CreateOrReplaceTableColTypeListContext;
    createOrReplaceTableColType(): CreateOrReplaceTableColTypeContext;
    colDefinitionOption(): ColDefinitionOptionContext;
    generationExpression(): GenerationExpressionContext;
    complexColTypeList(): ComplexColTypeListContext;
    complexColType(): ComplexColTypeContext;
    whenClause(): WhenClauseContext;
    windowClause(): WindowClauseContext;
    namedWindow(): NamedWindowContext;
    windowSpec(): WindowSpecContext;
    windowFrame(): WindowFrameContext;
    frameBound(): FrameBoundContext;
    qualifiedNameList(): QualifiedNameListContext;
    functionName(): FunctionNameContext;
    qualifiedName(): QualifiedNameContext;
    errorCapturingIdentifier(): ErrorCapturingIdentifierContext;
    errorCapturingIdentifierExtra(): ErrorCapturingIdentifierExtraContext;
    identifier(): IdentifierContext;
    strictIdentifier(): StrictIdentifierContext;
    quotedIdentifier(): QuotedIdentifierContext;
    backQuotedIdentifier(): BackQuotedIdentifierContext;
    number(): NumberContext;
    alterColumnAction(): AlterColumnActionContext;
    stringLit(): StringLitContext;
    comment(): CommentContext;
    version(): VersionContext;
    ansiNonReserved(): AnsiNonReservedContext;
    strictNonReserved(): StrictNonReservedContext;
    nonReserved(): NonReservedContext;
    sempred(_localctx: RuleContext, ruleIndex: number, predIndex: number): boolean;
    private queryTerm_sempred;
    private booleanExpression_sempred;
    private valueExpression_sempred;
    private primaryExpression_sempred;
    private identifier_sempred;
    private strictIdentifier_sempred;
    private quotedIdentifier_sempred;
    private number_sempred;
    private stringLit_sempred;
    private static readonly _serializedATNSegments;
    private static readonly _serializedATNSegment0;
    private static readonly _serializedATNSegment1;
    private static readonly _serializedATNSegment2;
    private static readonly _serializedATNSegment3;
    private static readonly _serializedATNSegment4;
    private static readonly _serializedATNSegment5;
    private static readonly _serializedATNSegment6;
    private static readonly _serializedATNSegment7;
    static readonly _serializedATN: string;
    static __ATN: ATN;
    static get _ATN(): ATN;
}
export declare class ProgramContext extends ParserRuleContext {
    statements(): StatementsContext | undefined;
    EOF(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class StatementsContext extends ParserRuleContext {
    statementForFolding(): StatementForFoldingContext[];
    statementForFolding(i: number): StatementForFoldingContext;
    statementEnd(): StatementEndContext[];
    statementEnd(i: number): StatementEndContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class StatementEndContext extends ParserRuleContext {
    SEMICOLON(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SingleStatementContext extends ParserRuleContext {
    statement(): StatementContext;
    EOF(): TerminalNode;
    SEMICOLON(): TerminalNode[];
    SEMICOLON(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SingleExpressionContext extends ParserRuleContext {
    namedExpression(): NamedExpressionContext;
    EOF(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SingleTableIdentifierContext extends ParserRuleContext {
    tableIdentifier(): TableIdentifierContext;
    EOF(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SingleMultipartIdentifierContext extends ParserRuleContext {
    multipartIdentifier(): MultipartIdentifierContext;
    EOF(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SingleFunctionIdentifierContext extends ParserRuleContext {
    functionIdentifier(): FunctionIdentifierContext;
    EOF(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SingleDataTypeContext extends ParserRuleContext {
    dataType(): DataTypeContext;
    EOF(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SingleTableSchemaContext extends ParserRuleContext {
    colTypeList(): ColTypeListContext;
    EOF(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class AnyNonStringNameContext extends ParserRuleContext {
    identifierReference(): IdentifierReferenceContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class CatalogNameDefContext extends ParserRuleContext {
    anyNonStringName(): AnyNonStringNameContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DatabaseNameDefContext extends ParserRuleContext {
    anyNonStringName(): AnyNonStringNameContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ColumnNameDefContext extends ParserRuleContext {
    anyNonStringName(): AnyNonStringNameContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class TableNameDefContext extends ParserRuleContext {
    IDENTIFIER(): TerminalNode | undefined;
    LEFT_PAREN(): TerminalNode | undefined;
    tableNameDef(): TableNameDefContext | undefined;
    RIGHT_PAREN(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ViewNameDefContext extends ParserRuleContext {
    anyNonStringName(): AnyNonStringNameContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class CatalogDefContext extends ParserRuleContext {
    catalogNameDef(): CatalogNameDefContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DatabaseDefContext extends ParserRuleContext {
    databaseNameDef(): DatabaseNameDefContext;
    catalogDef(): CatalogDefContext | undefined;
    DOT(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class TableDefContext extends ParserRuleContext {
    tableNameDef(): TableNameDefContext;
    databaseDef(): DatabaseDefContext | undefined;
    DOT(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ViewDefContext extends ParserRuleContext {
    viewNameDef(): ViewNameDefContext;
    databaseDef(): DatabaseDefContext | undefined;
    DOT(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ColumnDefContext extends ParserRuleContext {
    columnNameDef(): ColumnNameDefContext | undefined;
    ASTERISK(): TerminalNode | undefined;
    tableDef(): TableDefContext | undefined;
    DOT(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DescribeDefContext extends ParserRuleContext {
    describeCatalog(): DescribeCatalogContext | undefined;
    describeDatabase(): DescribeDatabaseContext | undefined;
    describeTable(): DescribeTableContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DescribeCatalogContext extends ParserRuleContext {
    CATALOG(): TerminalNode;
    catalogDef(): CatalogDefContext;
    DESCRIBE(): TerminalNode | undefined;
    DESC(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DescribeDatabaseContext extends ParserRuleContext {
    databaseDef(): DatabaseDefContext;
    DESCRIBE(): TerminalNode | undefined;
    DESC(): TerminalNode | undefined;
    DATABASE(): TerminalNode | undefined;
    SCHEMA(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DescribeTableContext extends ParserRuleContext {
    tableDef(): TableDefContext;
    DESCRIBE(): TerminalNode | undefined;
    DESC(): TerminalNode | undefined;
    TABLE(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class UseDefContext extends ParserRuleContext {
    USE(): TerminalNode;
    CATALOG(): TerminalNode | undefined;
    catalogDef(): CatalogDefContext | undefined;
    databaseDef(): DatabaseDefContext | undefined;
    DATABASE(): TerminalNode | undefined;
    SCHEMA(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DdlStatementDefContext extends ParserRuleContext {
    alterDatabaseDef(): AlterDatabaseDefContext | undefined;
    createDatabaseDef(): CreateDatabaseDefContext | undefined;
    dropDatabaseDef(): DropDatabaseDefContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class AlterDatabaseDefContext extends ParserRuleContext {
    ALTER(): TerminalNode;
    databaseDef(): DatabaseDefContext;
    SET(): TerminalNode;
    propertyList(): PropertyListContext | undefined;
    DATABASE(): TerminalNode | undefined;
    SCHEMA(): TerminalNode | undefined;
    DBPROPERTIES(): TerminalNode | undefined;
    PROPERTIES(): TerminalNode | undefined;
    locationSpec(): LocationSpecContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class CreateDatabaseDefContext extends ParserRuleContext {
    CREATE(): TerminalNode;
    databaseDef(): DatabaseDefContext;
    DATABASE(): TerminalNode | undefined;
    SCHEMA(): TerminalNode | undefined;
    IF(): TerminalNode | undefined;
    NOT(): TerminalNode | undefined;
    EXISTS(): TerminalNode | undefined;
    commentSpec(): CommentSpecContext[];
    commentSpec(i: number): CommentSpecContext;
    locationSpec(): LocationSpecContext[];
    locationSpec(i: number): LocationSpecContext;
    WITH(): TerminalNode[];
    WITH(i: number): TerminalNode;
    propertyList(): PropertyListContext[];
    propertyList(i: number): PropertyListContext;
    DBPROPERTIES(): TerminalNode[];
    DBPROPERTIES(i: number): TerminalNode;
    PROPERTIES(): TerminalNode[];
    PROPERTIES(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DropDatabaseDefContext extends ParserRuleContext {
    DROP(): TerminalNode;
    databaseDef(): DatabaseDefContext;
    DATABASE(): TerminalNode | undefined;
    SCHEMA(): TerminalNode | undefined;
    IF(): TerminalNode | undefined;
    EXISTS(): TerminalNode | undefined;
    RESTRICT(): TerminalNode | undefined;
    CASCADE(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class StatementForFoldingContext extends ParserRuleContext {
    statement(): StatementContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class StatementContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: StatementContext): void;
}
export declare class StatementDefaultContext extends StatementContext {
    query(): QueryContext;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DescribeStatementContext extends StatementContext {
    describeDef(): DescribeDefContext;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class UseStatementContext extends StatementContext {
    useDef(): UseDefContext;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DdlStatementContext extends StatementContext {
    ddlStatementDef(): DdlStatementDefContext;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DmlStatementContext extends StatementContext {
    dmlStatementNoWith(): DmlStatementNoWithContext;
    ctes(): CtesContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class UseContext extends StatementContext {
    USE(): TerminalNode;
    catalogDef(): CatalogDefContext | undefined;
    databaseDef(): DatabaseDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class UseNamespaceContext extends StatementContext {
    USE(): TerminalNode;
    namespace(): NamespaceContext;
    identifierReference(): IdentifierReferenceContext;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SetCatalogContext extends StatementContext {
    SET(): TerminalNode;
    CATALOG(): TerminalNode;
    identifier(): IdentifierContext | undefined;
    stringLit(): StringLitContext | undefined;
    catalogDef(): CatalogDefContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class CreateNamespaceContext extends StatementContext {
    CREATE(): TerminalNode;
    namespace(): NamespaceContext;
    identifierReference(): IdentifierReferenceContext;
    IF(): TerminalNode | undefined;
    NOT(): TerminalNode | undefined;
    EXISTS(): TerminalNode | undefined;
    commentSpec(): CommentSpecContext[];
    commentSpec(i: number): CommentSpecContext;
    locationSpec(): LocationSpecContext[];
    locationSpec(i: number): LocationSpecContext;
    WITH(): TerminalNode[];
    WITH(i: number): TerminalNode;
    propertyList(): PropertyListContext[];
    propertyList(i: number): PropertyListContext;
    DBPROPERTIES(): TerminalNode[];
    DBPROPERTIES(i: number): TerminalNode;
    PROPERTIES(): TerminalNode[];
    PROPERTIES(i: number): TerminalNode;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SetNamespacePropertiesContext extends StatementContext {
    ALTER(): TerminalNode;
    namespace(): NamespaceContext;
    identifierReference(): IdentifierReferenceContext;
    SET(): TerminalNode;
    propertyList(): PropertyListContext;
    DBPROPERTIES(): TerminalNode | undefined;
    PROPERTIES(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SetNamespaceLocationContext extends StatementContext {
    ALTER(): TerminalNode;
    namespace(): NamespaceContext;
    identifierReference(): IdentifierReferenceContext;
    SET(): TerminalNode;
    locationSpec(): LocationSpecContext;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DropNamespaceContext extends StatementContext {
    DROP(): TerminalNode;
    namespace(): NamespaceContext;
    identifierReference(): IdentifierReferenceContext;
    IF(): TerminalNode | undefined;
    EXISTS(): TerminalNode | undefined;
    RESTRICT(): TerminalNode | undefined;
    CASCADE(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ShowNamespacesContext extends StatementContext {
    _pattern: StringLitContext;
    SHOW(): TerminalNode;
    namespaces(): NamespacesContext;
    multipartIdentifier(): MultipartIdentifierContext | undefined;
    FROM(): TerminalNode | undefined;
    IN(): TerminalNode | undefined;
    stringLit(): StringLitContext | undefined;
    LIKE(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class CreateTableContext extends StatementContext {
    createTableHeader(): CreateTableHeaderContext;
    createTableClauses(): CreateTableClausesContext;
    LEFT_PAREN(): TerminalNode | undefined;
    createOrReplaceTableColTypeList(): CreateOrReplaceTableColTypeListContext | undefined;
    RIGHT_PAREN(): TerminalNode | undefined;
    tableProvider(): TableProviderContext | undefined;
    query(): QueryContext | undefined;
    AS(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class CreateTableLikeContext extends StatementContext {
    _target: TableIdentifierContext;
    _source: TableIdentifierContext;
    _tableProps: PropertyListContext;
    CREATE(): TerminalNode;
    TABLE(): TerminalNode;
    LIKE(): TerminalNode;
    tableIdentifier(): TableIdentifierContext[];
    tableIdentifier(i: number): TableIdentifierContext;
    IF(): TerminalNode | undefined;
    NOT(): TerminalNode | undefined;
    EXISTS(): TerminalNode | undefined;
    tableProvider(): TableProviderContext[];
    tableProvider(i: number): TableProviderContext;
    rowFormat(): RowFormatContext[];
    rowFormat(i: number): RowFormatContext;
    createFileFormat(): CreateFileFormatContext[];
    createFileFormat(i: number): CreateFileFormatContext;
    locationSpec(): LocationSpecContext[];
    locationSpec(i: number): LocationSpecContext;
    TBLPROPERTIES(): TerminalNode[];
    TBLPROPERTIES(i: number): TerminalNode;
    propertyList(): PropertyListContext[];
    propertyList(i: number): PropertyListContext;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ReplaceTableContext extends StatementContext {
    replaceTableHeader(): ReplaceTableHeaderContext;
    createTableClauses(): CreateTableClausesContext;
    LEFT_PAREN(): TerminalNode | undefined;
    createOrReplaceTableColTypeList(): CreateOrReplaceTableColTypeListContext | undefined;
    RIGHT_PAREN(): TerminalNode | undefined;
    tableProvider(): TableProviderContext | undefined;
    query(): QueryContext | undefined;
    AS(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class AnalyzeContext extends StatementContext {
    ANALYZE(): TerminalNode;
    TABLE(): TerminalNode;
    COMPUTE(): TerminalNode;
    STATISTICS(): TerminalNode;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    partitionSpec(): PartitionSpecContext | undefined;
    identifier(): IdentifierContext | undefined;
    FOR(): TerminalNode | undefined;
    COLUMNS(): TerminalNode | undefined;
    identifierSeq(): IdentifierSeqContext | undefined;
    ALL(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class AnalyzeTablesContext extends StatementContext {
    ANALYZE(): TerminalNode;
    TABLES(): TerminalNode;
    COMPUTE(): TerminalNode;
    STATISTICS(): TerminalNode;
    identifier(): IdentifierContext | undefined;
    FROM(): TerminalNode | undefined;
    IN(): TerminalNode | undefined;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class AddTableColumnsContext extends StatementContext {
    _columns: QualifiedColTypeWithPositionListContext;
    ALTER(): TerminalNode;
    TABLE(): TerminalNode;
    ADD(): TerminalNode;
    COLUMN(): TerminalNode | undefined;
    COLUMNS(): TerminalNode | undefined;
    qualifiedColTypeWithPositionList(): QualifiedColTypeWithPositionListContext;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    LEFT_PAREN(): TerminalNode | undefined;
    RIGHT_PAREN(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class RenameTableColumnContext extends StatementContext {
    _table: IdentifierReferenceContext;
    _from: MultipartIdentifierContext;
    _to: ErrorCapturingIdentifierContext;
    ALTER(): TerminalNode;
    TABLE(): TerminalNode;
    RENAME(): TerminalNode;
    COLUMN(): TerminalNode;
    TO(): TerminalNode;
    identifierReference(): IdentifierReferenceContext;
    multipartIdentifier(): MultipartIdentifierContext;
    errorCapturingIdentifier(): ErrorCapturingIdentifierContext;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DropTableColumnsContext extends StatementContext {
    _columns: MultipartIdentifierListContext;
    ALTER(): TerminalNode;
    TABLE(): TerminalNode;
    DROP(): TerminalNode;
    LEFT_PAREN(): TerminalNode | undefined;
    RIGHT_PAREN(): TerminalNode | undefined;
    COLUMN(): TerminalNode | undefined;
    COLUMNS(): TerminalNode | undefined;
    multipartIdentifierList(): MultipartIdentifierListContext;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    IF(): TerminalNode | undefined;
    EXISTS(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class RenameTableContext extends StatementContext {
    _from: IdentifierReferenceContext;
    _to: MultipartIdentifierContext;
    ALTER(): TerminalNode;
    RENAME(): TerminalNode;
    TO(): TerminalNode;
    TABLE(): TerminalNode | undefined;
    VIEW(): TerminalNode | undefined;
    identifierReference(): IdentifierReferenceContext;
    multipartIdentifier(): MultipartIdentifierContext;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SetTablePropertiesContext extends StatementContext {
    ALTER(): TerminalNode;
    identifierReference(): IdentifierReferenceContext;
    SET(): TerminalNode;
    TBLPROPERTIES(): TerminalNode;
    propertyList(): PropertyListContext;
    TABLE(): TerminalNode | undefined;
    VIEW(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class UnsetTablePropertiesContext extends StatementContext {
    ALTER(): TerminalNode;
    identifierReference(): IdentifierReferenceContext;
    UNSET(): TerminalNode;
    TBLPROPERTIES(): TerminalNode;
    propertyList(): PropertyListContext;
    TABLE(): TerminalNode | undefined;
    VIEW(): TerminalNode | undefined;
    IF(): TerminalNode | undefined;
    EXISTS(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class AlterTableAlterColumnContext extends StatementContext {
    _table: IdentifierReferenceContext;
    _column: MultipartIdentifierContext;
    ALTER(): TerminalNode[];
    ALTER(i: number): TerminalNode;
    TABLE(): TerminalNode;
    identifierReference(): IdentifierReferenceContext;
    CHANGE(): TerminalNode | undefined;
    multipartIdentifier(): MultipartIdentifierContext;
    COLUMN(): TerminalNode | undefined;
    alterColumnAction(): AlterColumnActionContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class HiveChangeColumnContext extends StatementContext {
    _table: IdentifierReferenceContext;
    _colName: MultipartIdentifierContext;
    ALTER(): TerminalNode;
    TABLE(): TerminalNode;
    CHANGE(): TerminalNode;
    colType(): ColTypeContext;
    identifierReference(): IdentifierReferenceContext;
    multipartIdentifier(): MultipartIdentifierContext;
    partitionSpec(): PartitionSpecContext | undefined;
    COLUMN(): TerminalNode | undefined;
    colPosition(): ColPositionContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class HiveReplaceColumnsContext extends StatementContext {
    _table: IdentifierReferenceContext;
    _columns: QualifiedColTypeWithPositionListContext;
    ALTER(): TerminalNode;
    TABLE(): TerminalNode;
    REPLACE(): TerminalNode;
    COLUMNS(): TerminalNode;
    LEFT_PAREN(): TerminalNode;
    RIGHT_PAREN(): TerminalNode;
    identifierReference(): IdentifierReferenceContext;
    qualifiedColTypeWithPositionList(): QualifiedColTypeWithPositionListContext;
    partitionSpec(): PartitionSpecContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SetTableSerDeContext extends StatementContext {
    ALTER(): TerminalNode;
    TABLE(): TerminalNode;
    SET(): TerminalNode;
    SERDE(): TerminalNode | undefined;
    stringLit(): StringLitContext | undefined;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    partitionSpec(): PartitionSpecContext | undefined;
    WITH(): TerminalNode | undefined;
    SERDEPROPERTIES(): TerminalNode | undefined;
    propertyList(): PropertyListContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class AddTablePartitionContext extends StatementContext {
    ALTER(): TerminalNode;
    identifierReference(): IdentifierReferenceContext;
    ADD(): TerminalNode;
    TABLE(): TerminalNode | undefined;
    VIEW(): TerminalNode | undefined;
    IF(): TerminalNode | undefined;
    NOT(): TerminalNode | undefined;
    EXISTS(): TerminalNode | undefined;
    partitionSpecLocation(): PartitionSpecLocationContext[];
    partitionSpecLocation(i: number): PartitionSpecLocationContext;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class RenameTablePartitionContext extends StatementContext {
    _from: PartitionSpecContext;
    _to: PartitionSpecContext;
    ALTER(): TerminalNode;
    TABLE(): TerminalNode;
    RENAME(): TerminalNode;
    TO(): TerminalNode;
    partitionSpec(): PartitionSpecContext[];
    partitionSpec(i: number): PartitionSpecContext;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DropTablePartitionsContext extends StatementContext {
    ALTER(): TerminalNode;
    identifierReference(): IdentifierReferenceContext;
    DROP(): TerminalNode;
    partitionSpec(): PartitionSpecContext[];
    partitionSpec(i: number): PartitionSpecContext;
    TABLE(): TerminalNode | undefined;
    VIEW(): TerminalNode | undefined;
    IF(): TerminalNode | undefined;
    EXISTS(): TerminalNode | undefined;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    PURGE(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SetTableLocationContext extends StatementContext {
    ALTER(): TerminalNode;
    TABLE(): TerminalNode;
    SET(): TerminalNode;
    locationSpec(): LocationSpecContext;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    partitionSpec(): PartitionSpecContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class RecoverPartitionsContext extends StatementContext {
    ALTER(): TerminalNode;
    TABLE(): TerminalNode;
    RECOVER(): TerminalNode;
    PARTITIONS(): TerminalNode;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DropTableContext extends StatementContext {
    DROP(): TerminalNode;
    TABLE(): TerminalNode;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    IF(): TerminalNode | undefined;
    EXISTS(): TerminalNode | undefined;
    PURGE(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DropViewContext extends StatementContext {
    DROP(): TerminalNode;
    VIEW(): TerminalNode;
    identifierReference(): IdentifierReferenceContext;
    IF(): TerminalNode | undefined;
    EXISTS(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class CreateViewContext extends StatementContext {
    CREATE(): TerminalNode;
    VIEW(): TerminalNode;
    identifierReference(): IdentifierReferenceContext;
    AS(): TerminalNode;
    query(): QueryContext;
    OR(): TerminalNode | undefined;
    REPLACE(): TerminalNode | undefined;
    TEMPORARY(): TerminalNode | undefined;
    IF(): TerminalNode | undefined;
    NOT(): TerminalNode | undefined;
    EXISTS(): TerminalNode | undefined;
    identifierCommentList(): IdentifierCommentListContext | undefined;
    commentSpec(): CommentSpecContext[];
    commentSpec(i: number): CommentSpecContext;
    PARTITIONED(): TerminalNode[];
    PARTITIONED(i: number): TerminalNode;
    ON(): TerminalNode[];
    ON(i: number): TerminalNode;
    identifierList(): IdentifierListContext[];
    identifierList(i: number): IdentifierListContext;
    TBLPROPERTIES(): TerminalNode[];
    TBLPROPERTIES(i: number): TerminalNode;
    propertyList(): PropertyListContext[];
    propertyList(i: number): PropertyListContext;
    GLOBAL(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class CreateTempViewUsingContext extends StatementContext {
    CREATE(): TerminalNode;
    TEMPORARY(): TerminalNode;
    VIEW(): TerminalNode;
    tableIdentifier(): TableIdentifierContext;
    tableProvider(): TableProviderContext;
    OR(): TerminalNode | undefined;
    REPLACE(): TerminalNode | undefined;
    GLOBAL(): TerminalNode | undefined;
    LEFT_PAREN(): TerminalNode | undefined;
    colTypeList(): ColTypeListContext | undefined;
    RIGHT_PAREN(): TerminalNode | undefined;
    OPTIONS(): TerminalNode | undefined;
    propertyList(): PropertyListContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class AlterViewQueryContext extends StatementContext {
    ALTER(): TerminalNode;
    VIEW(): TerminalNode;
    identifierReference(): IdentifierReferenceContext;
    query(): QueryContext;
    AS(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class CreateFunctionContext extends StatementContext {
    _className: StringLitContext;
    CREATE(): TerminalNode;
    FUNCTION(): TerminalNode;
    identifierReference(): IdentifierReferenceContext;
    AS(): TerminalNode;
    stringLit(): StringLitContext;
    OR(): TerminalNode | undefined;
    REPLACE(): TerminalNode | undefined;
    TEMPORARY(): TerminalNode | undefined;
    IF(): TerminalNode | undefined;
    NOT(): TerminalNode | undefined;
    EXISTS(): TerminalNode | undefined;
    USING(): TerminalNode | undefined;
    resource(): ResourceContext[];
    resource(i: number): ResourceContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DropFunctionContext extends StatementContext {
    DROP(): TerminalNode;
    FUNCTION(): TerminalNode;
    identifierReference(): IdentifierReferenceContext;
    TEMPORARY(): TerminalNode | undefined;
    IF(): TerminalNode | undefined;
    EXISTS(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ExplainContext extends StatementContext {
    EXPLAIN(): TerminalNode;
    statement(): StatementContext;
    LOGICAL(): TerminalNode | undefined;
    FORMATTED(): TerminalNode | undefined;
    EXTENDED(): TerminalNode | undefined;
    CODEGEN(): TerminalNode | undefined;
    COST(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ShowTablesContext extends StatementContext {
    _pattern: StringLitContext;
    SHOW(): TerminalNode;
    TABLES(): TerminalNode;
    FROM(): TerminalNode | undefined;
    IN(): TerminalNode | undefined;
    stringLit(): StringLitContext | undefined;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    LIKE(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ShowTableExtendedContext extends StatementContext {
    _ns: IdentifierReferenceContext;
    _pattern: StringLitContext;
    SHOW(): TerminalNode;
    TABLE(): TerminalNode;
    EXTENDED(): TerminalNode;
    LIKE(): TerminalNode;
    stringLit(): StringLitContext;
    partitionSpec(): PartitionSpecContext | undefined;
    FROM(): TerminalNode | undefined;
    IN(): TerminalNode | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ShowTblPropertiesContext extends StatementContext {
    _table: IdentifierReferenceContext;
    _key: PropertyKeyContext;
    SHOW(): TerminalNode;
    TBLPROPERTIES(): TerminalNode;
    identifierReference(): IdentifierReferenceContext;
    LEFT_PAREN(): TerminalNode | undefined;
    RIGHT_PAREN(): TerminalNode | undefined;
    propertyKey(): PropertyKeyContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ShowColumnsContext extends StatementContext {
    _table: IdentifierReferenceContext;
    _ns: MultipartIdentifierContext;
    SHOW(): TerminalNode;
    COLUMNS(): TerminalNode;
    FROM(): TerminalNode[];
    FROM(i: number): TerminalNode;
    IN(): TerminalNode[];
    IN(i: number): TerminalNode;
    identifierReference(): IdentifierReferenceContext;
    multipartIdentifier(): MultipartIdentifierContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ShowViewsContext extends StatementContext {
    _pattern: StringLitContext;
    SHOW(): TerminalNode;
    VIEWS(): TerminalNode;
    identifierReference(): IdentifierReferenceContext | undefined;
    FROM(): TerminalNode | undefined;
    IN(): TerminalNode | undefined;
    stringLit(): StringLitContext | undefined;
    LIKE(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ShowPartitionsContext extends StatementContext {
    SHOW(): TerminalNode;
    PARTITIONS(): TerminalNode;
    identifierReference(): IdentifierReferenceContext;
    partitionSpec(): PartitionSpecContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ShowFunctionsContext extends StatementContext {
    _ns: IdentifierReferenceContext;
    _legacy: MultipartIdentifierContext;
    _pattern: StringLitContext;
    SHOW(): TerminalNode;
    FUNCTIONS(): TerminalNode;
    identifier(): IdentifierContext | undefined;
    FROM(): TerminalNode | undefined;
    IN(): TerminalNode | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    LIKE(): TerminalNode | undefined;
    multipartIdentifier(): MultipartIdentifierContext | undefined;
    stringLit(): StringLitContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ShowCreateTableContext extends StatementContext {
    SHOW(): TerminalNode;
    CREATE(): TerminalNode;
    TABLE(): TerminalNode;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    AS(): TerminalNode | undefined;
    SERDE(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ShowCurrentNamespaceContext extends StatementContext {
    SHOW(): TerminalNode;
    CURRENT(): TerminalNode;
    namespace(): NamespaceContext;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ShowCatalogsContext extends StatementContext {
    _pattern: StringLitContext;
    SHOW(): TerminalNode;
    CATALOGS(): TerminalNode;
    stringLit(): StringLitContext | undefined;
    LIKE(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DescribeFunctionContext extends StatementContext {
    FUNCTION(): TerminalNode;
    describeFuncName(): DescribeFuncNameContext;
    DESC(): TerminalNode | undefined;
    DESCRIBE(): TerminalNode | undefined;
    EXTENDED(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DescribeNamespaceContext extends StatementContext {
    namespace(): NamespaceContext;
    identifierReference(): IdentifierReferenceContext;
    DESC(): TerminalNode | undefined;
    DESCRIBE(): TerminalNode | undefined;
    EXTENDED(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DescribeRelationContext extends StatementContext {
    _option: Token;
    identifierReference(): IdentifierReferenceContext;
    DESC(): TerminalNode | undefined;
    DESCRIBE(): TerminalNode | undefined;
    TABLE(): TerminalNode | undefined;
    partitionSpec(): PartitionSpecContext | undefined;
    describeColName(): DescribeColNameContext | undefined;
    EXTENDED(): TerminalNode | undefined;
    FORMATTED(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DescribeQueryContext extends StatementContext {
    query(): QueryContext;
    DESC(): TerminalNode | undefined;
    DESCRIBE(): TerminalNode | undefined;
    QUERY(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class CommentNamespaceContext extends StatementContext {
    COMMENT(): TerminalNode;
    ON(): TerminalNode;
    namespace(): NamespaceContext;
    identifierReference(): IdentifierReferenceContext;
    IS(): TerminalNode;
    comment(): CommentContext;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class CommentTableContext extends StatementContext {
    COMMENT(): TerminalNode;
    ON(): TerminalNode;
    TABLE(): TerminalNode;
    IS(): TerminalNode;
    comment(): CommentContext;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class RefreshTableContext extends StatementContext {
    REFRESH(): TerminalNode;
    TABLE(): TerminalNode;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class RefreshFunctionContext extends StatementContext {
    REFRESH(): TerminalNode;
    FUNCTION(): TerminalNode;
    identifierReference(): IdentifierReferenceContext;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class RefreshResourceContext extends StatementContext {
    REFRESH(): TerminalNode;
    stringLit(): StringLitContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class CacheTableContext extends StatementContext {
    _options: PropertyListContext;
    CACHE(): TerminalNode;
    TABLE(): TerminalNode;
    identifierReference(): IdentifierReferenceContext;
    LAZY(): TerminalNode | undefined;
    OPTIONS(): TerminalNode | undefined;
    query(): QueryContext | undefined;
    propertyList(): PropertyListContext | undefined;
    AS(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class UncacheTableContext extends StatementContext {
    UNCACHE(): TerminalNode;
    TABLE(): TerminalNode;
    identifierReference(): IdentifierReferenceContext;
    IF(): TerminalNode | undefined;
    EXISTS(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ClearCacheContext extends StatementContext {
    CLEAR(): TerminalNode;
    CACHE(): TerminalNode;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class LoadDataContext extends StatementContext {
    _path: StringLitContext;
    LOAD(): TerminalNode;
    DATA(): TerminalNode;
    INPATH(): TerminalNode;
    INTO(): TerminalNode;
    TABLE(): TerminalNode;
    stringLit(): StringLitContext;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    LOCAL(): TerminalNode | undefined;
    OVERWRITE(): TerminalNode | undefined;
    partitionSpec(): PartitionSpecContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class TruncateTableContext extends StatementContext {
    TRUNCATE(): TerminalNode;
    TABLE(): TerminalNode;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    partitionSpec(): PartitionSpecContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class RepairTableContext extends StatementContext {
    _option: Token;
    REPAIR(): TerminalNode;
    TABLE(): TerminalNode;
    identifierReference(): IdentifierReferenceContext;
    MSCK(): TerminalNode | undefined;
    PARTITIONS(): TerminalNode | undefined;
    ADD(): TerminalNode | undefined;
    DROP(): TerminalNode | undefined;
    SYNC(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ManageResourceContext extends StatementContext {
    _op: Token;
    identifier(): IdentifierContext;
    ADD(): TerminalNode | undefined;
    LIST(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class FailNativeCommandContext extends StatementContext {
    SET(): TerminalNode | undefined;
    ROLE(): TerminalNode | undefined;
    unsupportedHiveNativeCommands(): UnsupportedHiveNativeCommandsContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SetTimeZoneContext extends StatementContext {
    SET(): TerminalNode;
    TIME(): TerminalNode;
    ZONE(): TerminalNode;
    interval(): IntervalContext | undefined;
    timezone(): TimezoneContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SetQuotedConfigurationContext extends StatementContext {
    SET(): TerminalNode;
    configKey(): ConfigKeyContext | undefined;
    EQ(): TerminalNode;
    configValue(): ConfigValueContext;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SetConfigurationContext extends StatementContext {
    SET(): TerminalNode;
    configKey(): ConfigKeyContext | undefined;
    EQ(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ResetQuotedConfigurationContext extends StatementContext {
    RESET(): TerminalNode;
    configKey(): ConfigKeyContext;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ResetConfigurationContext extends StatementContext {
    RESET(): TerminalNode;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class CreateIndexContext extends StatementContext {
    _indexType: IdentifierContext;
    _columns: MultipartIdentifierPropertyListContext;
    _options: PropertyListContext;
    CREATE(): TerminalNode;
    INDEX(): TerminalNode;
    identifier(): IdentifierContext[];
    identifier(i: number): IdentifierContext;
    ON(): TerminalNode;
    LEFT_PAREN(): TerminalNode;
    RIGHT_PAREN(): TerminalNode;
    multipartIdentifierPropertyList(): MultipartIdentifierPropertyListContext;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    IF(): TerminalNode | undefined;
    NOT(): TerminalNode | undefined;
    EXISTS(): TerminalNode | undefined;
    TABLE(): TerminalNode | undefined;
    USING(): TerminalNode | undefined;
    OPTIONS(): TerminalNode | undefined;
    propertyList(): PropertyListContext | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DropIndexContext extends StatementContext {
    DROP(): TerminalNode;
    INDEX(): TerminalNode;
    identifier(): IdentifierContext;
    ON(): TerminalNode;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    IF(): TerminalNode | undefined;
    EXISTS(): TerminalNode | undefined;
    TABLE(): TerminalNode | undefined;
    constructor(ctx: StatementContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class TimezoneContext extends ParserRuleContext {
    stringLit(): StringLitContext | undefined;
    LOCAL(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ConfigKeyContext extends ParserRuleContext {
    quotedIdentifier(): QuotedIdentifierContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ConfigValueContext extends ParserRuleContext {
    backQuotedIdentifier(): BackQuotedIdentifierContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class UnsupportedHiveNativeCommandsContext extends ParserRuleContext {
    _kw1: Token;
    _kw2: Token;
    _kw3: Token;
    _kw4: Token;
    _kw5: Token;
    _kw6: Token;
    CREATE(): TerminalNode | undefined;
    ROLE(): TerminalNode | undefined;
    DROP(): TerminalNode | undefined;
    GRANT(): TerminalNode | undefined;
    REVOKE(): TerminalNode | undefined;
    SHOW(): TerminalNode | undefined;
    PRINCIPALS(): TerminalNode | undefined;
    ROLES(): TerminalNode | undefined;
    CURRENT(): TerminalNode | undefined;
    EXPORT(): TerminalNode | undefined;
    TABLE(): TerminalNode | undefined;
    IMPORT(): TerminalNode | undefined;
    COMPACTIONS(): TerminalNode | undefined;
    TRANSACTIONS(): TerminalNode | undefined;
    INDEXES(): TerminalNode | undefined;
    LOCKS(): TerminalNode | undefined;
    INDEX(): TerminalNode | undefined;
    ALTER(): TerminalNode | undefined;
    LOCK(): TerminalNode | undefined;
    DATABASE(): TerminalNode | undefined;
    UNLOCK(): TerminalNode | undefined;
    TEMPORARY(): TerminalNode | undefined;
    MACRO(): TerminalNode | undefined;
    tableIdentifier(): TableIdentifierContext | undefined;
    NOT(): TerminalNode | undefined;
    CLUSTERED(): TerminalNode | undefined;
    BY(): TerminalNode | undefined;
    SORTED(): TerminalNode | undefined;
    SKEWED(): TerminalNode | undefined;
    STORED(): TerminalNode | undefined;
    AS(): TerminalNode | undefined;
    DIRECTORIES(): TerminalNode | undefined;
    SET(): TerminalNode | undefined;
    LOCATION(): TerminalNode | undefined;
    EXCHANGE(): TerminalNode | undefined;
    PARTITION(): TerminalNode | undefined;
    ARCHIVE(): TerminalNode | undefined;
    UNARCHIVE(): TerminalNode | undefined;
    TOUCH(): TerminalNode | undefined;
    COMPACT(): TerminalNode | undefined;
    partitionSpec(): PartitionSpecContext | undefined;
    CONCATENATE(): TerminalNode | undefined;
    FILEFORMAT(): TerminalNode | undefined;
    REPLACE(): TerminalNode | undefined;
    COLUMNS(): TerminalNode | undefined;
    START(): TerminalNode | undefined;
    TRANSACTION(): TerminalNode | undefined;
    COMMIT(): TerminalNode | undefined;
    ROLLBACK(): TerminalNode | undefined;
    DFS(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class CreateTableHeaderContext extends ParserRuleContext {
    CREATE(): TerminalNode;
    TABLE(): TerminalNode;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    TEMPORARY(): TerminalNode | undefined;
    EXTERNAL(): TerminalNode | undefined;
    IF(): TerminalNode | undefined;
    NOT(): TerminalNode | undefined;
    EXISTS(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ReplaceTableHeaderContext extends ParserRuleContext {
    REPLACE(): TerminalNode;
    TABLE(): TerminalNode;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    CREATE(): TerminalNode | undefined;
    OR(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class BucketSpecContext extends ParserRuleContext {
    CLUSTERED(): TerminalNode;
    BY(): TerminalNode[];
    BY(i: number): TerminalNode;
    identifierList(): IdentifierListContext;
    INTO(): TerminalNode;
    INTEGER_VALUE(): TerminalNode;
    BUCKETS(): TerminalNode;
    SORTED(): TerminalNode | undefined;
    orderedIdentifierList(): OrderedIdentifierListContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SkewSpecContext extends ParserRuleContext {
    SKEWED(): TerminalNode;
    BY(): TerminalNode;
    identifierList(): IdentifierListContext;
    ON(): TerminalNode;
    constantList(): ConstantListContext | undefined;
    nestedConstantList(): NestedConstantListContext | undefined;
    STORED(): TerminalNode | undefined;
    AS(): TerminalNode | undefined;
    DIRECTORIES(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class LocationSpecContext extends ParserRuleContext {
    LOCATION(): TerminalNode;
    stringLit(): StringLitContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class CommentSpecContext extends ParserRuleContext {
    COMMENT(): TerminalNode;
    stringLit(): StringLitContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class QueryContext extends ParserRuleContext {
    queryTerm(): QueryTermContext;
    queryOrganization(): QueryOrganizationContext;
    ctes(): CtesContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class InsertIntoContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: InsertIntoContext): void;
}
export declare class InsertOverwriteTableContext extends InsertIntoContext {
    INSERT(): TerminalNode;
    OVERWRITE(): TerminalNode;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    TABLE(): TerminalNode | undefined;
    partitionSpec(): PartitionSpecContext | undefined;
    identifierList(): IdentifierListContext | undefined;
    BY(): TerminalNode | undefined;
    NAME(): TerminalNode | undefined;
    IF(): TerminalNode | undefined;
    NOT(): TerminalNode | undefined;
    EXISTS(): TerminalNode | undefined;
    constructor(ctx: InsertIntoContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class InsertIntoTableContext extends InsertIntoContext {
    INSERT(): TerminalNode;
    INTO(): TerminalNode;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    TABLE(): TerminalNode | undefined;
    partitionSpec(): PartitionSpecContext | undefined;
    IF(): TerminalNode | undefined;
    NOT(): TerminalNode | undefined;
    EXISTS(): TerminalNode | undefined;
    identifierList(): IdentifierListContext | undefined;
    BY(): TerminalNode | undefined;
    NAME(): TerminalNode | undefined;
    constructor(ctx: InsertIntoContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class InsertIntoReplaceWhereContext extends InsertIntoContext {
    INSERT(): TerminalNode;
    INTO(): TerminalNode;
    REPLACE(): TerminalNode;
    whereClause(): WhereClauseContext;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    TABLE(): TerminalNode | undefined;
    constructor(ctx: InsertIntoContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class InsertOverwriteHiveDirContext extends InsertIntoContext {
    _path: StringLitContext;
    INSERT(): TerminalNode;
    OVERWRITE(): TerminalNode;
    DIRECTORY(): TerminalNode;
    stringLit(): StringLitContext;
    LOCAL(): TerminalNode | undefined;
    rowFormat(): RowFormatContext | undefined;
    createFileFormat(): CreateFileFormatContext | undefined;
    constructor(ctx: InsertIntoContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class InsertOverwriteDirContext extends InsertIntoContext {
    _path: StringLitContext;
    _options: PropertyListContext;
    INSERT(): TerminalNode;
    OVERWRITE(): TerminalNode;
    DIRECTORY(): TerminalNode;
    tableProvider(): TableProviderContext;
    LOCAL(): TerminalNode | undefined;
    OPTIONS(): TerminalNode | undefined;
    stringLit(): StringLitContext | undefined;
    propertyList(): PropertyListContext | undefined;
    constructor(ctx: InsertIntoContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class PartitionSpecLocationContext extends ParserRuleContext {
    partitionSpec(): PartitionSpecContext;
    locationSpec(): LocationSpecContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class PartitionSpecContext extends ParserRuleContext {
    PARTITION(): TerminalNode;
    LEFT_PAREN(): TerminalNode;
    partitionVal(): PartitionValContext[];
    partitionVal(i: number): PartitionValContext;
    RIGHT_PAREN(): TerminalNode;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class PartitionValContext extends ParserRuleContext {
    identifier(): IdentifierContext;
    EQ(): TerminalNode | undefined;
    constant(): ConstantContext | undefined;
    DEFAULT(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class NamespaceContext extends ParserRuleContext {
    NAMESPACE(): TerminalNode | undefined;
    DATABASE(): TerminalNode | undefined;
    SCHEMA(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class NamespacesContext extends ParserRuleContext {
    NAMESPACES(): TerminalNode | undefined;
    DATABASES(): TerminalNode | undefined;
    SCHEMAS(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DescribeFuncNameContext extends ParserRuleContext {
    identifierReference(): IdentifierReferenceContext | undefined;
    stringLit(): StringLitContext | undefined;
    comparisonOperator(): ComparisonOperatorContext | undefined;
    arithmeticOperator(): ArithmeticOperatorContext | undefined;
    predicateOperator(): PredicateOperatorContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DescribeColNameContext extends ParserRuleContext {
    _identifier: IdentifierContext;
    _nameParts: IdentifierContext[];
    identifier(): IdentifierContext[];
    identifier(i: number): IdentifierContext;
    DOT(): TerminalNode[];
    DOT(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class CtesContext extends ParserRuleContext {
    WITH(): TerminalNode;
    namedQuery(): NamedQueryContext[];
    namedQuery(i: number): NamedQueryContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class NamedQueryContext extends ParserRuleContext {
    _name: ErrorCapturingIdentifierContext;
    _columnAliases: IdentifierListContext;
    LEFT_PAREN(): TerminalNode;
    query(): QueryContext;
    RIGHT_PAREN(): TerminalNode;
    errorCapturingIdentifier(): ErrorCapturingIdentifierContext;
    AS(): TerminalNode | undefined;
    identifierList(): IdentifierListContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class TableProviderContext extends ParserRuleContext {
    USING(): TerminalNode;
    multipartIdentifier(): MultipartIdentifierContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class CreateTableClausesContext extends ParserRuleContext {
    _options: ExpressionPropertyListContext;
    _partitioning: PartitionFieldListContext;
    _tableProps: PropertyListContext;
    skewSpec(): SkewSpecContext[];
    skewSpec(i: number): SkewSpecContext;
    bucketSpec(): BucketSpecContext[];
    bucketSpec(i: number): BucketSpecContext;
    rowFormat(): RowFormatContext[];
    rowFormat(i: number): RowFormatContext;
    createFileFormat(): CreateFileFormatContext[];
    createFileFormat(i: number): CreateFileFormatContext;
    locationSpec(): LocationSpecContext[];
    locationSpec(i: number): LocationSpecContext;
    commentSpec(): CommentSpecContext[];
    commentSpec(i: number): CommentSpecContext;
    OPTIONS(): TerminalNode[];
    OPTIONS(i: number): TerminalNode;
    PARTITIONED(): TerminalNode[];
    PARTITIONED(i: number): TerminalNode;
    BY(): TerminalNode[];
    BY(i: number): TerminalNode;
    TBLPROPERTIES(): TerminalNode[];
    TBLPROPERTIES(i: number): TerminalNode;
    expressionPropertyList(): ExpressionPropertyListContext[];
    expressionPropertyList(i: number): ExpressionPropertyListContext;
    partitionFieldList(): PartitionFieldListContext[];
    partitionFieldList(i: number): PartitionFieldListContext;
    propertyList(): PropertyListContext[];
    propertyList(i: number): PropertyListContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class PropertyListContext extends ParserRuleContext {
    LEFT_PAREN(): TerminalNode;
    property(): PropertyContext[];
    property(i: number): PropertyContext;
    RIGHT_PAREN(): TerminalNode;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class PropertyContext extends ParserRuleContext {
    _key: PropertyKeyContext;
    _value: PropertyValueContext;
    propertyKey(): PropertyKeyContext;
    propertyValue(): PropertyValueContext | undefined;
    EQ(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class PropertyKeyContext extends ParserRuleContext {
    identifier(): IdentifierContext[];
    identifier(i: number): IdentifierContext;
    DOT(): TerminalNode[];
    DOT(i: number): TerminalNode;
    stringLit(): StringLitContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class PropertyValueContext extends ParserRuleContext {
    INTEGER_VALUE(): TerminalNode | undefined;
    DECIMAL_VALUE(): TerminalNode | undefined;
    booleanValue(): BooleanValueContext | undefined;
    stringLit(): StringLitContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ExpressionPropertyListContext extends ParserRuleContext {
    LEFT_PAREN(): TerminalNode;
    expressionProperty(): ExpressionPropertyContext[];
    expressionProperty(i: number): ExpressionPropertyContext;
    RIGHT_PAREN(): TerminalNode;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ExpressionPropertyContext extends ParserRuleContext {
    _key: PropertyKeyContext;
    _value: ExpressionContext;
    propertyKey(): PropertyKeyContext;
    expression(): ExpressionContext | undefined;
    EQ(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ConstantListContext extends ParserRuleContext {
    LEFT_PAREN(): TerminalNode;
    constant(): ConstantContext[];
    constant(i: number): ConstantContext;
    RIGHT_PAREN(): TerminalNode;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class NestedConstantListContext extends ParserRuleContext {
    LEFT_PAREN(): TerminalNode;
    constantList(): ConstantListContext[];
    constantList(i: number): ConstantListContext;
    RIGHT_PAREN(): TerminalNode;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class CreateFileFormatContext extends ParserRuleContext {
    STORED(): TerminalNode;
    AS(): TerminalNode | undefined;
    fileFormat(): FileFormatContext | undefined;
    BY(): TerminalNode | undefined;
    storageHandler(): StorageHandlerContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class FileFormatContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: FileFormatContext): void;
}
export declare class TableFileFormatContext extends FileFormatContext {
    _inFmt: StringLitContext;
    _outFmt: StringLitContext;
    INPUTFORMAT(): TerminalNode;
    OUTPUTFORMAT(): TerminalNode;
    stringLit(): StringLitContext[];
    stringLit(i: number): StringLitContext;
    constructor(ctx: FileFormatContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class GenericFileFormatContext extends FileFormatContext {
    identifier(): IdentifierContext;
    constructor(ctx: FileFormatContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class StorageHandlerContext extends ParserRuleContext {
    stringLit(): StringLitContext;
    WITH(): TerminalNode | undefined;
    SERDEPROPERTIES(): TerminalNode | undefined;
    propertyList(): PropertyListContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ResourceContext extends ParserRuleContext {
    identifier(): IdentifierContext;
    stringLit(): StringLitContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DmlStatementNoWithContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: DmlStatementNoWithContext): void;
}
export declare class SingleInsertQueryContext extends DmlStatementNoWithContext {
    insertInto(): InsertIntoContext;
    query(): QueryContext;
    constructor(ctx: DmlStatementNoWithContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class MultiInsertQueryContext extends DmlStatementNoWithContext {
    fromClause(): FromClauseContext;
    multiInsertQueryBody(): MultiInsertQueryBodyContext[];
    multiInsertQueryBody(i: number): MultiInsertQueryBodyContext;
    constructor(ctx: DmlStatementNoWithContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DeleteFromTableContext extends DmlStatementNoWithContext {
    DELETE(): TerminalNode;
    FROM(): TerminalNode;
    identifierReference(): IdentifierReferenceContext;
    tableAlias(): TableAliasContext;
    whereClause(): WhereClauseContext | undefined;
    constructor(ctx: DmlStatementNoWithContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class UpdateTableContext extends DmlStatementNoWithContext {
    UPDATE(): TerminalNode;
    identifierReference(): IdentifierReferenceContext;
    tableAlias(): TableAliasContext;
    setClause(): SetClauseContext;
    whereClause(): WhereClauseContext | undefined;
    constructor(ctx: DmlStatementNoWithContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class MergeIntoTableContext extends DmlStatementNoWithContext {
    _target: IdentifierReferenceContext;
    _targetAlias: TableAliasContext;
    _source: IdentifierReferenceContext;
    _sourceQuery: QueryContext;
    _sourceAlias: TableAliasContext;
    _mergeCondition: BooleanExpressionContext;
    MERGE(): TerminalNode;
    INTO(): TerminalNode;
    USING(): TerminalNode;
    ON(): TerminalNode;
    identifierReference(): IdentifierReferenceContext[];
    identifierReference(i: number): IdentifierReferenceContext;
    tableAlias(): TableAliasContext[];
    tableAlias(i: number): TableAliasContext;
    booleanExpression(): BooleanExpressionContext;
    LEFT_PAREN(): TerminalNode | undefined;
    RIGHT_PAREN(): TerminalNode | undefined;
    query(): QueryContext | undefined;
    matchedClause(): MatchedClauseContext[];
    matchedClause(i: number): MatchedClauseContext;
    notMatchedClause(): NotMatchedClauseContext[];
    notMatchedClause(i: number): NotMatchedClauseContext;
    notMatchedBySourceClause(): NotMatchedBySourceClauseContext[];
    notMatchedBySourceClause(i: number): NotMatchedBySourceClauseContext;
    constructor(ctx: DmlStatementNoWithContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class IdentifierReferenceContext extends ParserRuleContext {
    IDENTIFIER_KW(): TerminalNode | undefined;
    LEFT_PAREN(): TerminalNode | undefined;
    expression(): ExpressionContext | undefined;
    RIGHT_PAREN(): TerminalNode | undefined;
    multipartIdentifier(): MultipartIdentifierContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class QueryOrganizationContext extends ParserRuleContext {
    _sortItem: SortItemContext;
    _order: SortItemContext[];
    _expression: ExpressionContext;
    _clusterBy: ExpressionContext[];
    _distributeBy: ExpressionContext[];
    _sort: SortItemContext[];
    _limit: ExpressionContext;
    _offset: ExpressionContext;
    ORDER(): TerminalNode | undefined;
    BY(): TerminalNode[];
    BY(i: number): TerminalNode;
    CLUSTER(): TerminalNode | undefined;
    DISTRIBUTE(): TerminalNode | undefined;
    SORT(): TerminalNode | undefined;
    windowClause(): WindowClauseContext | undefined;
    LIMIT(): TerminalNode | undefined;
    OFFSET(): TerminalNode | undefined;
    sortItem(): SortItemContext[];
    sortItem(i: number): SortItemContext;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    ALL(): TerminalNode | undefined;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class MultiInsertQueryBodyContext extends ParserRuleContext {
    insertInto(): InsertIntoContext;
    fromStatementBody(): FromStatementBodyContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class QueryTermContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: QueryTermContext): void;
}
export declare class QueryTermDefaultContext extends QueryTermContext {
    queryPrimary(): QueryPrimaryContext;
    constructor(ctx: QueryTermContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SetOperationContext extends QueryTermContext {
    _left: QueryTermContext;
    _operator: Token;
    _right: QueryTermContext;
    queryTerm(): QueryTermContext[];
    queryTerm(i: number): QueryTermContext;
    INTERSECT(): TerminalNode | undefined;
    UNION(): TerminalNode | undefined;
    EXCEPT(): TerminalNode | undefined;
    SETMINUS(): TerminalNode | undefined;
    setQuantifier(): SetQuantifierContext | undefined;
    constructor(ctx: QueryTermContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class QueryPrimaryContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: QueryPrimaryContext): void;
}
export declare class QueryPrimaryDefaultContext extends QueryPrimaryContext {
    querySpecification(): QuerySpecificationContext;
    constructor(ctx: QueryPrimaryContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class FromStmtContext extends QueryPrimaryContext {
    fromStatement(): FromStatementContext;
    constructor(ctx: QueryPrimaryContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class TableContext extends QueryPrimaryContext {
    TABLE(): TerminalNode;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    constructor(ctx: QueryPrimaryContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class InlineTableDefault1Context extends QueryPrimaryContext {
    inlineTable(): InlineTableContext;
    constructor(ctx: QueryPrimaryContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SubqueryContext extends QueryPrimaryContext {
    LEFT_PAREN(): TerminalNode;
    query(): QueryContext;
    RIGHT_PAREN(): TerminalNode;
    constructor(ctx: QueryPrimaryContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SortItemContext extends ParserRuleContext {
    _ordering: Token;
    _nullOrder: Token;
    expression(): ExpressionContext;
    NULLS(): TerminalNode | undefined;
    ASC(): TerminalNode | undefined;
    DESC(): TerminalNode | undefined;
    LAST(): TerminalNode | undefined;
    FIRST(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class FromStatementContext extends ParserRuleContext {
    fromClause(): FromClauseContext;
    fromStatementBody(): FromStatementBodyContext[];
    fromStatementBody(i: number): FromStatementBodyContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class FromStatementBodyContext extends ParserRuleContext {
    transformClause(): TransformClauseContext | undefined;
    queryOrganization(): QueryOrganizationContext;
    whereClause(): WhereClauseContext | undefined;
    selectClause(): SelectClauseContext | undefined;
    lateralView(): LateralViewContext[];
    lateralView(i: number): LateralViewContext;
    aggregationClause(): AggregationClauseContext | undefined;
    havingClause(): HavingClauseContext | undefined;
    windowClause(): WindowClauseContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class QuerySpecificationContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: QuerySpecificationContext): void;
}
export declare class TransformQuerySpecificationContext extends QuerySpecificationContext {
    transformClause(): TransformClauseContext;
    fromClause(): FromClauseContext | undefined;
    lateralView(): LateralViewContext[];
    lateralView(i: number): LateralViewContext;
    whereClause(): WhereClauseContext | undefined;
    aggregationClause(): AggregationClauseContext | undefined;
    havingClause(): HavingClauseContext | undefined;
    windowClause(): WindowClauseContext | undefined;
    constructor(ctx: QuerySpecificationContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class RegularQuerySpecificationContext extends QuerySpecificationContext {
    selectClause(): SelectClauseContext;
    fromClause(): FromClauseContext | undefined;
    lateralView(): LateralViewContext[];
    lateralView(i: number): LateralViewContext;
    whereClause(): WhereClauseContext | undefined;
    aggregationClause(): AggregationClauseContext | undefined;
    havingClause(): HavingClauseContext | undefined;
    windowClause(): WindowClauseContext | undefined;
    constructor(ctx: QuerySpecificationContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class TransformClauseContext extends ParserRuleContext {
    _kind: Token;
    _inRowFormat: RowFormatContext;
    _recordWriter: StringLitContext;
    _script: StringLitContext;
    _outRowFormat: RowFormatContext;
    _recordReader: StringLitContext;
    USING(): TerminalNode;
    stringLit(): StringLitContext[];
    stringLit(i: number): StringLitContext;
    SELECT(): TerminalNode | undefined;
    LEFT_PAREN(): TerminalNode[];
    LEFT_PAREN(i: number): TerminalNode;
    expressionSeq(): ExpressionSeqContext | undefined;
    RIGHT_PAREN(): TerminalNode[];
    RIGHT_PAREN(i: number): TerminalNode;
    TRANSFORM(): TerminalNode | undefined;
    MAP(): TerminalNode | undefined;
    REDUCE(): TerminalNode | undefined;
    RECORDWRITER(): TerminalNode | undefined;
    AS(): TerminalNode | undefined;
    RECORDREADER(): TerminalNode | undefined;
    rowFormat(): RowFormatContext[];
    rowFormat(i: number): RowFormatContext;
    setQuantifier(): SetQuantifierContext | undefined;
    identifierSeq(): IdentifierSeqContext | undefined;
    colTypeList(): ColTypeListContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SelectClauseContext extends ParserRuleContext {
    _hint: HintContext;
    _hints: HintContext[];
    SELECT(): TerminalNode;
    namedExpressionSeq(): NamedExpressionSeqContext;
    setQuantifier(): SetQuantifierContext | undefined;
    hint(): HintContext[];
    hint(i: number): HintContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SetClauseContext extends ParserRuleContext {
    SET(): TerminalNode;
    assignmentList(): AssignmentListContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class MatchedClauseContext extends ParserRuleContext {
    _matchedCond: BooleanExpressionContext;
    WHEN(): TerminalNode;
    MATCHED(): TerminalNode;
    THEN(): TerminalNode;
    matchedAction(): MatchedActionContext;
    AND(): TerminalNode | undefined;
    booleanExpression(): BooleanExpressionContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class NotMatchedClauseContext extends ParserRuleContext {
    _notMatchedCond: BooleanExpressionContext;
    WHEN(): TerminalNode;
    NOT(): TerminalNode;
    MATCHED(): TerminalNode;
    THEN(): TerminalNode;
    notMatchedAction(): NotMatchedActionContext;
    BY(): TerminalNode | undefined;
    TARGET(): TerminalNode | undefined;
    AND(): TerminalNode | undefined;
    booleanExpression(): BooleanExpressionContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class NotMatchedBySourceClauseContext extends ParserRuleContext {
    _notMatchedBySourceCond: BooleanExpressionContext;
    WHEN(): TerminalNode;
    NOT(): TerminalNode;
    MATCHED(): TerminalNode;
    BY(): TerminalNode;
    SOURCE(): TerminalNode;
    THEN(): TerminalNode;
    notMatchedBySourceAction(): NotMatchedBySourceActionContext;
    AND(): TerminalNode | undefined;
    booleanExpression(): BooleanExpressionContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class MatchedActionContext extends ParserRuleContext {
    DELETE(): TerminalNode | undefined;
    UPDATE(): TerminalNode | undefined;
    SET(): TerminalNode | undefined;
    ASTERISK(): TerminalNode | undefined;
    assignmentList(): AssignmentListContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class NotMatchedActionContext extends ParserRuleContext {
    _columns: MultipartIdentifierListContext;
    INSERT(): TerminalNode;
    ASTERISK(): TerminalNode | undefined;
    LEFT_PAREN(): TerminalNode[];
    LEFT_PAREN(i: number): TerminalNode;
    RIGHT_PAREN(): TerminalNode[];
    RIGHT_PAREN(i: number): TerminalNode;
    VALUES(): TerminalNode | undefined;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    multipartIdentifierList(): MultipartIdentifierListContext | undefined;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class NotMatchedBySourceActionContext extends ParserRuleContext {
    DELETE(): TerminalNode | undefined;
    UPDATE(): TerminalNode | undefined;
    SET(): TerminalNode | undefined;
    assignmentList(): AssignmentListContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class AssignmentListContext extends ParserRuleContext {
    assignment(): AssignmentContext[];
    assignment(i: number): AssignmentContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class AssignmentContext extends ParserRuleContext {
    _key: MultipartIdentifierContext;
    _value: ExpressionContext;
    EQ(): TerminalNode;
    multipartIdentifier(): MultipartIdentifierContext;
    expression(): ExpressionContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class WhereClauseContext extends ParserRuleContext {
    WHERE(): TerminalNode;
    booleanExpression(): BooleanExpressionContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class HavingClauseContext extends ParserRuleContext {
    HAVING(): TerminalNode;
    booleanExpression(): BooleanExpressionContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class HintContext extends ParserRuleContext {
    _hintStatement: HintStatementContext;
    _hintStatements: HintStatementContext[];
    HENT_START(): TerminalNode;
    HENT_END(): TerminalNode;
    hintStatement(): HintStatementContext[];
    hintStatement(i: number): HintStatementContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class HintStatementContext extends ParserRuleContext {
    _hintName: IdentifierContext;
    _primaryExpression: PrimaryExpressionContext;
    _parameters: PrimaryExpressionContext[];
    identifier(): IdentifierContext;
    LEFT_PAREN(): TerminalNode | undefined;
    RIGHT_PAREN(): TerminalNode | undefined;
    primaryExpression(): PrimaryExpressionContext[];
    primaryExpression(i: number): PrimaryExpressionContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class FromClauseContext extends ParserRuleContext {
    FROM(): TerminalNode;
    relation(): RelationContext[];
    relation(i: number): RelationContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    lateralView(): LateralViewContext[];
    lateralView(i: number): LateralViewContext;
    pivotClause(): PivotClauseContext | undefined;
    unpivotClause(): UnpivotClauseContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class TemporalClauseContext extends ParserRuleContext {
    _timestamp: ValueExpressionContext;
    AS(): TerminalNode;
    OF(): TerminalNode;
    version(): VersionContext | undefined;
    SYSTEM_VERSION(): TerminalNode | undefined;
    VERSION(): TerminalNode | undefined;
    FOR(): TerminalNode | undefined;
    SYSTEM_TIME(): TerminalNode | undefined;
    TIMESTAMP(): TerminalNode | undefined;
    valueExpression(): ValueExpressionContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class AggregationClauseContext extends ParserRuleContext {
    _groupByClause: GroupByClauseContext;
    _groupingExpressionsWithGroupingAnalytics: GroupByClauseContext[];
    _expression: ExpressionContext;
    _groupingExpressions: ExpressionContext[];
    _kind: Token;
    GROUP(): TerminalNode;
    BY(): TerminalNode;
    groupByClause(): GroupByClauseContext[];
    groupByClause(i: number): GroupByClauseContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    WITH(): TerminalNode | undefined;
    SETS(): TerminalNode | undefined;
    LEFT_PAREN(): TerminalNode | undefined;
    groupingSet(): GroupingSetContext[];
    groupingSet(i: number): GroupingSetContext;
    RIGHT_PAREN(): TerminalNode | undefined;
    ROLLUP(): TerminalNode | undefined;
    CUBE(): TerminalNode | undefined;
    GROUPING(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class GroupByClauseContext extends ParserRuleContext {
    groupingAnalytics(): GroupingAnalyticsContext | undefined;
    expression(): ExpressionContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class GroupingAnalyticsContext extends ParserRuleContext {
    LEFT_PAREN(): TerminalNode;
    groupingSet(): GroupingSetContext[];
    groupingSet(i: number): GroupingSetContext;
    RIGHT_PAREN(): TerminalNode;
    ROLLUP(): TerminalNode | undefined;
    CUBE(): TerminalNode | undefined;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    GROUPING(): TerminalNode | undefined;
    SETS(): TerminalNode | undefined;
    groupingElement(): GroupingElementContext[];
    groupingElement(i: number): GroupingElementContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class GroupingElementContext extends ParserRuleContext {
    groupingAnalytics(): GroupingAnalyticsContext | undefined;
    groupingSet(): GroupingSetContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class GroupingSetContext extends ParserRuleContext {
    LEFT_PAREN(): TerminalNode | undefined;
    RIGHT_PAREN(): TerminalNode | undefined;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class PivotClauseContext extends ParserRuleContext {
    _aggregates: NamedExpressionSeqContext;
    _pivotValue: PivotValueContext;
    _pivotValues: PivotValueContext[];
    PIVOT(): TerminalNode;
    LEFT_PAREN(): TerminalNode[];
    LEFT_PAREN(i: number): TerminalNode;
    FOR(): TerminalNode;
    pivotColumn(): PivotColumnContext;
    IN(): TerminalNode;
    RIGHT_PAREN(): TerminalNode[];
    RIGHT_PAREN(i: number): TerminalNode;
    namedExpressionSeq(): NamedExpressionSeqContext;
    pivotValue(): PivotValueContext[];
    pivotValue(i: number): PivotValueContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class PivotColumnContext extends ParserRuleContext {
    _identifier: IdentifierContext;
    _identifiers: IdentifierContext[];
    identifier(): IdentifierContext[];
    identifier(i: number): IdentifierContext;
    LEFT_PAREN(): TerminalNode | undefined;
    RIGHT_PAREN(): TerminalNode | undefined;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class PivotValueContext extends ParserRuleContext {
    expression(): ExpressionContext;
    identifier(): IdentifierContext | undefined;
    AS(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class UnpivotClauseContext extends ParserRuleContext {
    _nullOperator: UnpivotNullClauseContext;
    _operator: UnpivotOperatorContext;
    UNPIVOT(): TerminalNode;
    LEFT_PAREN(): TerminalNode;
    RIGHT_PAREN(): TerminalNode;
    unpivotOperator(): UnpivotOperatorContext;
    identifier(): IdentifierContext | undefined;
    unpivotNullClause(): UnpivotNullClauseContext | undefined;
    AS(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class UnpivotNullClauseContext extends ParserRuleContext {
    NULLS(): TerminalNode;
    INCLUDE(): TerminalNode | undefined;
    EXCLUDE(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class UnpivotOperatorContext extends ParserRuleContext {
    unpivotSingleValueColumnClause(): UnpivotSingleValueColumnClauseContext | undefined;
    unpivotMultiValueColumnClause(): UnpivotMultiValueColumnClauseContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class UnpivotSingleValueColumnClauseContext extends ParserRuleContext {
    _unpivotColumnAndAlias: UnpivotColumnAndAliasContext;
    _unpivotColumns: UnpivotColumnAndAliasContext[];
    unpivotValueColumn(): UnpivotValueColumnContext;
    FOR(): TerminalNode;
    unpivotNameColumn(): UnpivotNameColumnContext;
    IN(): TerminalNode;
    LEFT_PAREN(): TerminalNode;
    RIGHT_PAREN(): TerminalNode;
    unpivotColumnAndAlias(): UnpivotColumnAndAliasContext[];
    unpivotColumnAndAlias(i: number): UnpivotColumnAndAliasContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class UnpivotMultiValueColumnClauseContext extends ParserRuleContext {
    _unpivotValueColumn: UnpivotValueColumnContext;
    _unpivotValueColumns: UnpivotValueColumnContext[];
    _unpivotColumnSet: UnpivotColumnSetContext;
    _unpivotColumnSets: UnpivotColumnSetContext[];
    LEFT_PAREN(): TerminalNode[];
    LEFT_PAREN(i: number): TerminalNode;
    RIGHT_PAREN(): TerminalNode[];
    RIGHT_PAREN(i: number): TerminalNode;
    FOR(): TerminalNode;
    unpivotNameColumn(): UnpivotNameColumnContext;
    IN(): TerminalNode;
    unpivotValueColumn(): UnpivotValueColumnContext[];
    unpivotValueColumn(i: number): UnpivotValueColumnContext;
    unpivotColumnSet(): UnpivotColumnSetContext[];
    unpivotColumnSet(i: number): UnpivotColumnSetContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class UnpivotColumnSetContext extends ParserRuleContext {
    _unpivotColumn: UnpivotColumnContext;
    _unpivotColumns: UnpivotColumnContext[];
    LEFT_PAREN(): TerminalNode;
    RIGHT_PAREN(): TerminalNode;
    unpivotColumn(): UnpivotColumnContext[];
    unpivotColumn(i: number): UnpivotColumnContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    unpivotAlias(): UnpivotAliasContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class UnpivotValueColumnContext extends ParserRuleContext {
    identifier(): IdentifierContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class UnpivotNameColumnContext extends ParserRuleContext {
    identifier(): IdentifierContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class UnpivotColumnAndAliasContext extends ParserRuleContext {
    unpivotColumn(): UnpivotColumnContext;
    unpivotAlias(): UnpivotAliasContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class UnpivotColumnContext extends ParserRuleContext {
    multipartIdentifier(): MultipartIdentifierContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class UnpivotAliasContext extends ParserRuleContext {
    identifier(): IdentifierContext;
    AS(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class LateralViewContext extends ParserRuleContext {
    _tblName: IdentifierContext;
    _identifier: IdentifierContext;
    _colName: IdentifierContext[];
    LATERAL(): TerminalNode;
    VIEW(): TerminalNode;
    qualifiedName(): QualifiedNameContext;
    LEFT_PAREN(): TerminalNode;
    RIGHT_PAREN(): TerminalNode;
    identifier(): IdentifierContext[];
    identifier(i: number): IdentifierContext;
    OUTER(): TerminalNode | undefined;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    AS(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SetQuantifierContext extends ParserRuleContext {
    DISTINCT(): TerminalNode | undefined;
    ALL(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class RelationContext extends ParserRuleContext {
    relationPrimary(): RelationPrimaryContext;
    LATERAL(): TerminalNode | undefined;
    relationExtension(): RelationExtensionContext[];
    relationExtension(i: number): RelationExtensionContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class RelationExtensionContext extends ParserRuleContext {
    joinRelation(): JoinRelationContext | undefined;
    pivotClause(): PivotClauseContext | undefined;
    unpivotClause(): UnpivotClauseContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class JoinRelationContext extends ParserRuleContext {
    _right: RelationPrimaryContext;
    JOIN(): TerminalNode;
    relationPrimary(): RelationPrimaryContext;
    joinType(): JoinTypeContext | undefined;
    LATERAL(): TerminalNode | undefined;
    joinCriteria(): JoinCriteriaContext | undefined;
    NATURAL(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class JoinTypeContext extends ParserRuleContext {
    INNER(): TerminalNode | undefined;
    CROSS(): TerminalNode | undefined;
    LEFT(): TerminalNode | undefined;
    OUTER(): TerminalNode | undefined;
    SEMI(): TerminalNode | undefined;
    RIGHT(): TerminalNode | undefined;
    FULL(): TerminalNode | undefined;
    ANTI(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class JoinCriteriaContext extends ParserRuleContext {
    ON(): TerminalNode | undefined;
    booleanExpression(): BooleanExpressionContext | undefined;
    USING(): TerminalNode | undefined;
    identifierList(): IdentifierListContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SampleContext extends ParserRuleContext {
    _seed: Token;
    TABLESAMPLE(): TerminalNode;
    LEFT_PAREN(): TerminalNode[];
    LEFT_PAREN(i: number): TerminalNode;
    RIGHT_PAREN(): TerminalNode[];
    RIGHT_PAREN(i: number): TerminalNode;
    sampleMethod(): SampleMethodContext | undefined;
    REPEATABLE(): TerminalNode | undefined;
    INTEGER_VALUE(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SampleMethodContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: SampleMethodContext): void;
}
export declare class SampleByPercentileContext extends SampleMethodContext {
    _negativeSign: Token;
    _percentage: Token;
    PERCENTLIT(): TerminalNode;
    INTEGER_VALUE(): TerminalNode | undefined;
    DECIMAL_VALUE(): TerminalNode | undefined;
    MINUS(): TerminalNode | undefined;
    constructor(ctx: SampleMethodContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SampleByRowsContext extends SampleMethodContext {
    expression(): ExpressionContext;
    ROWS(): TerminalNode;
    constructor(ctx: SampleMethodContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SampleByBucketContext extends SampleMethodContext {
    _sampleType: Token;
    _numerator: Token;
    _denominator: Token;
    OUT(): TerminalNode;
    OF(): TerminalNode;
    BUCKET(): TerminalNode;
    INTEGER_VALUE(): TerminalNode[];
    INTEGER_VALUE(i: number): TerminalNode;
    ON(): TerminalNode | undefined;
    identifier(): IdentifierContext | undefined;
    qualifiedName(): QualifiedNameContext | undefined;
    LEFT_PAREN(): TerminalNode | undefined;
    RIGHT_PAREN(): TerminalNode | undefined;
    constructor(ctx: SampleMethodContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SampleByBytesContext extends SampleMethodContext {
    _bytes: ExpressionContext;
    expression(): ExpressionContext;
    constructor(ctx: SampleMethodContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class IdentifierListContext extends ParserRuleContext {
    LEFT_PAREN(): TerminalNode;
    identifierSeq(): IdentifierSeqContext;
    RIGHT_PAREN(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class IdentifierSeqContext extends ParserRuleContext {
    _errorCapturingIdentifier: ErrorCapturingIdentifierContext;
    _ident: ErrorCapturingIdentifierContext[];
    errorCapturingIdentifier(): ErrorCapturingIdentifierContext[];
    errorCapturingIdentifier(i: number): ErrorCapturingIdentifierContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class OrderedIdentifierListContext extends ParserRuleContext {
    LEFT_PAREN(): TerminalNode;
    orderedIdentifier(): OrderedIdentifierContext[];
    orderedIdentifier(i: number): OrderedIdentifierContext;
    RIGHT_PAREN(): TerminalNode;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class OrderedIdentifierContext extends ParserRuleContext {
    _ident: ErrorCapturingIdentifierContext;
    _ordering: Token;
    errorCapturingIdentifier(): ErrorCapturingIdentifierContext;
    ASC(): TerminalNode | undefined;
    DESC(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class IdentifierCommentListContext extends ParserRuleContext {
    LEFT_PAREN(): TerminalNode;
    identifierComment(): IdentifierCommentContext[];
    identifierComment(i: number): IdentifierCommentContext;
    RIGHT_PAREN(): TerminalNode;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class IdentifierCommentContext extends ParserRuleContext {
    identifier(): IdentifierContext;
    commentSpec(): CommentSpecContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class RelationPrimaryContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: RelationPrimaryContext): void;
}
export declare class TableNameContext extends RelationPrimaryContext {
    tableAlias(): TableAliasContext;
    tableDef(): TableDefContext | undefined;
    identifierReference(): IdentifierReferenceContext | undefined;
    temporalClause(): TemporalClauseContext | undefined;
    sample(): SampleContext | undefined;
    constructor(ctx: RelationPrimaryContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class AliasedQueryContext extends RelationPrimaryContext {
    LEFT_PAREN(): TerminalNode;
    query(): QueryContext;
    RIGHT_PAREN(): TerminalNode;
    tableAlias(): TableAliasContext;
    sample(): SampleContext | undefined;
    constructor(ctx: RelationPrimaryContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class AliasedRelationContext extends RelationPrimaryContext {
    LEFT_PAREN(): TerminalNode;
    relation(): RelationContext;
    RIGHT_PAREN(): TerminalNode;
    tableAlias(): TableAliasContext;
    sample(): SampleContext | undefined;
    constructor(ctx: RelationPrimaryContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class InlineTableDefault2Context extends RelationPrimaryContext {
    inlineTable(): InlineTableContext;
    constructor(ctx: RelationPrimaryContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class TableValuedFunctionContext extends RelationPrimaryContext {
    functionTable(): FunctionTableContext;
    constructor(ctx: RelationPrimaryContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class InlineTableContext extends ParserRuleContext {
    VALUES(): TerminalNode;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    tableAlias(): TableAliasContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class FunctionTableSubqueryArgumentContext extends ParserRuleContext {
    TABLE(): TerminalNode;
    identifierReference(): IdentifierReferenceContext | undefined;
    tableArgumentPartitioning(): TableArgumentPartitioningContext | undefined;
    LEFT_PAREN(): TerminalNode | undefined;
    RIGHT_PAREN(): TerminalNode | undefined;
    query(): QueryContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class TableArgumentPartitioningContext extends ParserRuleContext {
    BY(): TerminalNode[];
    BY(i: number): TerminalNode;
    expressionSeq(): ExpressionSeqContext;
    PARTITION(): TerminalNode | undefined;
    DISTRIBUTE(): TerminalNode | undefined;
    sortItem(): SortItemContext[];
    sortItem(i: number): SortItemContext;
    ORDER(): TerminalNode | undefined;
    SORT(): TerminalNode | undefined;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class FunctionTableNamedArgumentExpressionContext extends ParserRuleContext {
    _key: IdentifierContext;
    _table: FunctionTableSubqueryArgumentContext;
    FAT_ARROW(): TerminalNode;
    identifier(): IdentifierContext;
    functionTableSubqueryArgument(): FunctionTableSubqueryArgumentContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class FunctionTableReferenceArgumentContext extends ParserRuleContext {
    functionTableSubqueryArgument(): FunctionTableSubqueryArgumentContext | undefined;
    functionTableNamedArgumentExpression(): FunctionTableNamedArgumentExpressionContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class FunctionTableArgumentContext extends ParserRuleContext {
    functionTableReferenceArgument(): FunctionTableReferenceArgumentContext | undefined;
    functionArgument(): FunctionArgumentContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class FunctionTableContext extends ParserRuleContext {
    _funcName: FunctionNameContext;
    LEFT_PAREN(): TerminalNode;
    RIGHT_PAREN(): TerminalNode;
    tableAlias(): TableAliasContext;
    functionName(): FunctionNameContext;
    functionTableArgument(): FunctionTableArgumentContext[];
    functionTableArgument(i: number): FunctionTableArgumentContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class TableAliasContext extends ParserRuleContext {
    strictIdentifier(): StrictIdentifierContext | undefined;
    AS(): TerminalNode | undefined;
    identifierList(): IdentifierListContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class RowFormatContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: RowFormatContext): void;
}
export declare class RowFormatSerdeContext extends RowFormatContext {
    _name: StringLitContext;
    _props: PropertyListContext;
    ROW(): TerminalNode;
    FORMAT(): TerminalNode;
    SERDE(): TerminalNode;
    stringLit(): StringLitContext;
    WITH(): TerminalNode | undefined;
    SERDEPROPERTIES(): TerminalNode | undefined;
    propertyList(): PropertyListContext | undefined;
    constructor(ctx: RowFormatContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class RowFormatDelimitedContext extends RowFormatContext {
    _fieldsTerminatedBy: StringLitContext;
    _escapedBy: StringLitContext;
    _collectionItemsTerminatedBy: StringLitContext;
    _keysTerminatedBy: StringLitContext;
    _linesSeparatedBy: StringLitContext;
    _nullDefinedAs: StringLitContext;
    ROW(): TerminalNode;
    FORMAT(): TerminalNode;
    DELIMITED(): TerminalNode;
    FIELDS(): TerminalNode | undefined;
    TERMINATED(): TerminalNode[];
    TERMINATED(i: number): TerminalNode;
    BY(): TerminalNode[];
    BY(i: number): TerminalNode;
    COLLECTION(): TerminalNode | undefined;
    ITEMS(): TerminalNode | undefined;
    MAP(): TerminalNode | undefined;
    KEYS(): TerminalNode | undefined;
    LINES(): TerminalNode | undefined;
    NULL(): TerminalNode | undefined;
    DEFINED(): TerminalNode | undefined;
    AS(): TerminalNode | undefined;
    stringLit(): StringLitContext[];
    stringLit(i: number): StringLitContext;
    ESCAPED(): TerminalNode | undefined;
    constructor(ctx: RowFormatContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class MultipartIdentifierListContext extends ParserRuleContext {
    multipartIdentifier(): MultipartIdentifierContext[];
    multipartIdentifier(i: number): MultipartIdentifierContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class MultipartIdentifierContext extends ParserRuleContext {
    _errorCapturingIdentifier: ErrorCapturingIdentifierContext;
    _parts: ErrorCapturingIdentifierContext[];
    errorCapturingIdentifier(): ErrorCapturingIdentifierContext[];
    errorCapturingIdentifier(i: number): ErrorCapturingIdentifierContext;
    DOT(): TerminalNode[];
    DOT(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class MultipartIdentifierPropertyListContext extends ParserRuleContext {
    multipartIdentifierProperty(): MultipartIdentifierPropertyContext[];
    multipartIdentifierProperty(i: number): MultipartIdentifierPropertyContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class MultipartIdentifierPropertyContext extends ParserRuleContext {
    _options: PropertyListContext;
    multipartIdentifier(): MultipartIdentifierContext;
    OPTIONS(): TerminalNode | undefined;
    propertyList(): PropertyListContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class TableIdentifierContext extends ParserRuleContext {
    _db: ErrorCapturingIdentifierContext;
    _table: ErrorCapturingIdentifierContext;
    errorCapturingIdentifier(): ErrorCapturingIdentifierContext[];
    errorCapturingIdentifier(i: number): ErrorCapturingIdentifierContext;
    DOT(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class FunctionIdentifierContext extends ParserRuleContext {
    _db: ErrorCapturingIdentifierContext;
    _function: ErrorCapturingIdentifierContext;
    errorCapturingIdentifier(): ErrorCapturingIdentifierContext[];
    errorCapturingIdentifier(i: number): ErrorCapturingIdentifierContext;
    DOT(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class NamedExpressionContext extends ParserRuleContext {
    _name: ErrorCapturingIdentifierContext;
    expression(): ExpressionContext;
    identifierList(): IdentifierListContext | undefined;
    AS(): TerminalNode | undefined;
    errorCapturingIdentifier(): ErrorCapturingIdentifierContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class NamedExpressionSeqContext extends ParserRuleContext {
    namedExpression(): NamedExpressionContext[];
    namedExpression(i: number): NamedExpressionContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class PartitionFieldListContext extends ParserRuleContext {
    _partitionField: PartitionFieldContext;
    _fields: PartitionFieldContext[];
    LEFT_PAREN(): TerminalNode;
    RIGHT_PAREN(): TerminalNode;
    partitionField(): PartitionFieldContext[];
    partitionField(i: number): PartitionFieldContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class PartitionFieldContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: PartitionFieldContext): void;
}
export declare class PartitionTransformContext extends PartitionFieldContext {
    transform(): TransformContext;
    constructor(ctx: PartitionFieldContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class PartitionColumnContext extends PartitionFieldContext {
    colType(): ColTypeContext;
    constructor(ctx: PartitionFieldContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class TransformContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: TransformContext): void;
}
export declare class IdentityTransformContext extends TransformContext {
    qualifiedName(): QualifiedNameContext;
    constructor(ctx: TransformContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ApplyTransformContext extends TransformContext {
    _transformName: IdentifierContext;
    _transformArgument: TransformArgumentContext;
    _argument: TransformArgumentContext[];
    LEFT_PAREN(): TerminalNode;
    RIGHT_PAREN(): TerminalNode;
    identifier(): IdentifierContext;
    transformArgument(): TransformArgumentContext[];
    transformArgument(i: number): TransformArgumentContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(ctx: TransformContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class TransformArgumentContext extends ParserRuleContext {
    qualifiedName(): QualifiedNameContext | undefined;
    constant(): ConstantContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ExpressionContext extends ParserRuleContext {
    booleanExpression(): BooleanExpressionContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class NamedArgumentExpressionContext extends ParserRuleContext {
    _key: IdentifierContext;
    _value: ExpressionContext;
    FAT_ARROW(): TerminalNode;
    identifier(): IdentifierContext;
    expression(): ExpressionContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class FunctionArgumentContext extends ParserRuleContext {
    expression(): ExpressionContext | undefined;
    namedArgumentExpression(): NamedArgumentExpressionContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ExpressionSeqContext extends ParserRuleContext {
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class BooleanExpressionContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: BooleanExpressionContext): void;
}
export declare class LogicalNotContext extends BooleanExpressionContext {
    NOT(): TerminalNode;
    booleanExpression(): BooleanExpressionContext;
    constructor(ctx: BooleanExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ExistsContext extends BooleanExpressionContext {
    EXISTS(): TerminalNode;
    LEFT_PAREN(): TerminalNode;
    query(): QueryContext;
    RIGHT_PAREN(): TerminalNode;
    constructor(ctx: BooleanExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class PredicatedContext extends BooleanExpressionContext {
    valueExpression(): ValueExpressionContext;
    predicate(): PredicateContext | undefined;
    constructor(ctx: BooleanExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class LogicalBinaryContext extends BooleanExpressionContext {
    _left: BooleanExpressionContext;
    _operator: Token;
    _right: BooleanExpressionContext;
    booleanExpression(): BooleanExpressionContext[];
    booleanExpression(i: number): BooleanExpressionContext;
    AND(): TerminalNode | undefined;
    OR(): TerminalNode | undefined;
    constructor(ctx: BooleanExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class PredicateContext extends ParserRuleContext {
    _kind: Token;
    _lower: ValueExpressionContext;
    _upper: ValueExpressionContext;
    _pattern: ValueExpressionContext;
    _quantifier: Token;
    _escapeChar: StringLitContext;
    _right: ValueExpressionContext;
    AND(): TerminalNode | undefined;
    BETWEEN(): TerminalNode | undefined;
    valueExpression(): ValueExpressionContext[];
    valueExpression(i: number): ValueExpressionContext;
    NOT(): TerminalNode | undefined;
    LEFT_PAREN(): TerminalNode | undefined;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    RIGHT_PAREN(): TerminalNode | undefined;
    IN(): TerminalNode | undefined;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    query(): QueryContext | undefined;
    RLIKE(): TerminalNode | undefined;
    LIKE(): TerminalNode | undefined;
    ILIKE(): TerminalNode | undefined;
    ANY(): TerminalNode | undefined;
    SOME(): TerminalNode | undefined;
    ALL(): TerminalNode | undefined;
    ESCAPE(): TerminalNode | undefined;
    stringLit(): StringLitContext | undefined;
    IS(): TerminalNode | undefined;
    NULL(): TerminalNode | undefined;
    TRUE(): TerminalNode | undefined;
    FALSE(): TerminalNode | undefined;
    UNKNOWN(): TerminalNode | undefined;
    FROM(): TerminalNode | undefined;
    DISTINCT(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ValueExpressionContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: ValueExpressionContext): void;
}
export declare class ValueExpressionDefaultContext extends ValueExpressionContext {
    primaryExpression(): PrimaryExpressionContext;
    constructor(ctx: ValueExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ArithmeticUnaryContext extends ValueExpressionContext {
    _operator: Token;
    valueExpression(): ValueExpressionContext;
    MINUS(): TerminalNode | undefined;
    PLUS(): TerminalNode | undefined;
    TILDE(): TerminalNode | undefined;
    constructor(ctx: ValueExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ArithmeticBinaryContext extends ValueExpressionContext {
    _left: ValueExpressionContext;
    _operator: Token;
    _right: ValueExpressionContext;
    valueExpression(): ValueExpressionContext[];
    valueExpression(i: number): ValueExpressionContext;
    ASTERISK(): TerminalNode | undefined;
    SLASH(): TerminalNode | undefined;
    PERCENT(): TerminalNode | undefined;
    DIV(): TerminalNode | undefined;
    PLUS(): TerminalNode | undefined;
    MINUS(): TerminalNode | undefined;
    CONCAT_PIPE(): TerminalNode | undefined;
    AMPERSAND(): TerminalNode | undefined;
    HAT(): TerminalNode | undefined;
    PIPE(): TerminalNode | undefined;
    constructor(ctx: ValueExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ComparisonContext extends ValueExpressionContext {
    _left: ValueExpressionContext;
    _right: ValueExpressionContext;
    comparisonOperator(): ComparisonOperatorContext;
    valueExpression(): ValueExpressionContext[];
    valueExpression(i: number): ValueExpressionContext;
    constructor(ctx: ValueExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DatetimeUnitContext extends ParserRuleContext {
    YEAR(): TerminalNode | undefined;
    QUARTER(): TerminalNode | undefined;
    MONTH(): TerminalNode | undefined;
    WEEK(): TerminalNode | undefined;
    DAY(): TerminalNode | undefined;
    DAYOFYEAR(): TerminalNode | undefined;
    HOUR(): TerminalNode | undefined;
    MINUTE(): TerminalNode | undefined;
    SECOND(): TerminalNode | undefined;
    MILLISECOND(): TerminalNode | undefined;
    MICROSECOND(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class PrimaryExpressionContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: PrimaryExpressionContext): void;
}
export declare class CurrentLikeContext extends PrimaryExpressionContext {
    _name: Token;
    CURRENT_DATE(): TerminalNode | undefined;
    CURRENT_TIMESTAMP(): TerminalNode | undefined;
    CURRENT_USER(): TerminalNode | undefined;
    USER(): TerminalNode | undefined;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class TimestampaddContext extends PrimaryExpressionContext {
    _name: Token;
    _unit: DatetimeUnitContext;
    _invalidUnit: StringLitContext;
    _unitsAmount: ValueExpressionContext;
    _timestamp: ValueExpressionContext;
    LEFT_PAREN(): TerminalNode;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    RIGHT_PAREN(): TerminalNode;
    valueExpression(): ValueExpressionContext[];
    valueExpression(i: number): ValueExpressionContext;
    TIMESTAMPADD(): TerminalNode | undefined;
    DATEADD(): TerminalNode | undefined;
    DATE_ADD(): TerminalNode | undefined;
    datetimeUnit(): DatetimeUnitContext | undefined;
    stringLit(): StringLitContext | undefined;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class TimestampdiffContext extends PrimaryExpressionContext {
    _name: Token;
    _unit: DatetimeUnitContext;
    _invalidUnit: StringLitContext;
    _startTimestamp: ValueExpressionContext;
    _endTimestamp: ValueExpressionContext;
    LEFT_PAREN(): TerminalNode;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    RIGHT_PAREN(): TerminalNode;
    valueExpression(): ValueExpressionContext[];
    valueExpression(i: number): ValueExpressionContext;
    TIMESTAMPDIFF(): TerminalNode | undefined;
    DATEDIFF(): TerminalNode | undefined;
    DATE_DIFF(): TerminalNode | undefined;
    datetimeUnit(): DatetimeUnitContext | undefined;
    stringLit(): StringLitContext | undefined;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SearchedCaseContext extends PrimaryExpressionContext {
    _elseExpression: ExpressionContext;
    CASE(): TerminalNode;
    END(): TerminalNode;
    whenClause(): WhenClauseContext[];
    whenClause(i: number): WhenClauseContext;
    ELSE(): TerminalNode | undefined;
    expression(): ExpressionContext | undefined;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SimpleCaseContext extends PrimaryExpressionContext {
    _value: ExpressionContext;
    _elseExpression: ExpressionContext;
    CASE(): TerminalNode;
    END(): TerminalNode;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    whenClause(): WhenClauseContext[];
    whenClause(i: number): WhenClauseContext;
    ELSE(): TerminalNode | undefined;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class CastContext extends PrimaryExpressionContext {
    _name: Token;
    LEFT_PAREN(): TerminalNode;
    expression(): ExpressionContext;
    AS(): TerminalNode;
    dataType(): DataTypeContext;
    RIGHT_PAREN(): TerminalNode;
    CAST(): TerminalNode | undefined;
    TRY_CAST(): TerminalNode | undefined;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class StructContext extends PrimaryExpressionContext {
    _namedExpression: NamedExpressionContext;
    _argument: NamedExpressionContext[];
    STRUCT(): TerminalNode;
    LEFT_PAREN(): TerminalNode;
    RIGHT_PAREN(): TerminalNode;
    namedExpression(): NamedExpressionContext[];
    namedExpression(i: number): NamedExpressionContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class FirstContext extends PrimaryExpressionContext {
    FIRST(): TerminalNode;
    LEFT_PAREN(): TerminalNode;
    expression(): ExpressionContext;
    RIGHT_PAREN(): TerminalNode;
    IGNORE(): TerminalNode | undefined;
    NULLS(): TerminalNode | undefined;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class Any_valueContext extends PrimaryExpressionContext {
    ANY_VALUE(): TerminalNode;
    LEFT_PAREN(): TerminalNode;
    expression(): ExpressionContext;
    RIGHT_PAREN(): TerminalNode;
    IGNORE(): TerminalNode | undefined;
    NULLS(): TerminalNode | undefined;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class LastContext extends PrimaryExpressionContext {
    LAST(): TerminalNode;
    LEFT_PAREN(): TerminalNode;
    expression(): ExpressionContext;
    RIGHT_PAREN(): TerminalNode;
    IGNORE(): TerminalNode | undefined;
    NULLS(): TerminalNode | undefined;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class PositionContext extends PrimaryExpressionContext {
    _substr: ValueExpressionContext;
    _str: ValueExpressionContext;
    POSITION(): TerminalNode;
    LEFT_PAREN(): TerminalNode;
    IN(): TerminalNode;
    RIGHT_PAREN(): TerminalNode;
    valueExpression(): ValueExpressionContext[];
    valueExpression(i: number): ValueExpressionContext;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ConstantDefaultContext extends PrimaryExpressionContext {
    constant(): ConstantContext;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class StarContext extends PrimaryExpressionContext {
    ASTERISK(): TerminalNode;
    qualifiedName(): QualifiedNameContext | undefined;
    DOT(): TerminalNode | undefined;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class RowConstructorContext extends PrimaryExpressionContext {
    LEFT_PAREN(): TerminalNode;
    namedExpression(): NamedExpressionContext[];
    namedExpression(i: number): NamedExpressionContext;
    RIGHT_PAREN(): TerminalNode;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SubqueryExpressionContext extends PrimaryExpressionContext {
    LEFT_PAREN(): TerminalNode;
    query(): QueryContext;
    RIGHT_PAREN(): TerminalNode;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class IdentifierClauseContext extends PrimaryExpressionContext {
    IDENTIFIER_KW(): TerminalNode;
    LEFT_PAREN(): TerminalNode;
    expression(): ExpressionContext;
    RIGHT_PAREN(): TerminalNode;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class FunctionCallContext extends PrimaryExpressionContext {
    _functionArgument: FunctionArgumentContext;
    _argument: FunctionArgumentContext[];
    _where: BooleanExpressionContext;
    _nullsOption: Token;
    functionName(): FunctionNameContext;
    LEFT_PAREN(): TerminalNode[];
    LEFT_PAREN(i: number): TerminalNode;
    RIGHT_PAREN(): TerminalNode[];
    RIGHT_PAREN(i: number): TerminalNode;
    FILTER(): TerminalNode | undefined;
    WHERE(): TerminalNode | undefined;
    NULLS(): TerminalNode | undefined;
    OVER(): TerminalNode | undefined;
    windowSpec(): WindowSpecContext | undefined;
    functionArgument(): FunctionArgumentContext[];
    functionArgument(i: number): FunctionArgumentContext;
    booleanExpression(): BooleanExpressionContext | undefined;
    IGNORE(): TerminalNode | undefined;
    RESPECT(): TerminalNode | undefined;
    setQuantifier(): SetQuantifierContext | undefined;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class LambdaContext extends PrimaryExpressionContext {
    identifier(): IdentifierContext[];
    identifier(i: number): IdentifierContext;
    ARROW(): TerminalNode;
    expression(): ExpressionContext;
    LEFT_PAREN(): TerminalNode | undefined;
    RIGHT_PAREN(): TerminalNode | undefined;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SubscriptContext extends PrimaryExpressionContext {
    _value: PrimaryExpressionContext;
    _index: ValueExpressionContext;
    LEFT_BRACKET(): TerminalNode;
    RIGHT_BRACKET(): TerminalNode;
    primaryExpression(): PrimaryExpressionContext;
    valueExpression(): ValueExpressionContext;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ColumnReferenceContext extends PrimaryExpressionContext {
    columnDef(): ColumnDefContext | undefined;
    identifier(): IdentifierContext | undefined;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DereferenceContext extends PrimaryExpressionContext {
    _base: PrimaryExpressionContext;
    _fieldName: IdentifierContext;
    DOT(): TerminalNode;
    primaryExpression(): PrimaryExpressionContext;
    columnDef(): ColumnDefContext | undefined;
    identifier(): IdentifierContext | undefined;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ParenthesizedExpressionContext extends PrimaryExpressionContext {
    LEFT_PAREN(): TerminalNode;
    expression(): ExpressionContext;
    RIGHT_PAREN(): TerminalNode;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ExtractContext extends PrimaryExpressionContext {
    _field: IdentifierContext;
    _source: ValueExpressionContext;
    EXTRACT(): TerminalNode;
    LEFT_PAREN(): TerminalNode;
    FROM(): TerminalNode;
    RIGHT_PAREN(): TerminalNode;
    valueExpression(): ValueExpressionContext;
    columnDef(): ColumnDefContext | undefined;
    identifier(): IdentifierContext | undefined;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SubstringContext extends PrimaryExpressionContext {
    _str: ValueExpressionContext;
    _pos: ValueExpressionContext;
    _len: ValueExpressionContext;
    LEFT_PAREN(): TerminalNode;
    RIGHT_PAREN(): TerminalNode;
    SUBSTR(): TerminalNode | undefined;
    SUBSTRING(): TerminalNode | undefined;
    valueExpression(): ValueExpressionContext[];
    valueExpression(i: number): ValueExpressionContext;
    FROM(): TerminalNode | undefined;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    FOR(): TerminalNode | undefined;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class TrimContext extends PrimaryExpressionContext {
    _trimOption: Token;
    _trimStr: ValueExpressionContext;
    _srcStr: ValueExpressionContext;
    TRIM(): TerminalNode;
    LEFT_PAREN(): TerminalNode;
    FROM(): TerminalNode;
    RIGHT_PAREN(): TerminalNode;
    valueExpression(): ValueExpressionContext[];
    valueExpression(i: number): ValueExpressionContext;
    BOTH(): TerminalNode | undefined;
    LEADING(): TerminalNode | undefined;
    TRAILING(): TerminalNode | undefined;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class OverlayContext extends PrimaryExpressionContext {
    _input: ValueExpressionContext;
    _replace: ValueExpressionContext;
    _position: ValueExpressionContext;
    _length: ValueExpressionContext;
    OVERLAY(): TerminalNode;
    LEFT_PAREN(): TerminalNode;
    PLACING(): TerminalNode;
    FROM(): TerminalNode;
    RIGHT_PAREN(): TerminalNode;
    valueExpression(): ValueExpressionContext[];
    valueExpression(i: number): ValueExpressionContext;
    FOR(): TerminalNode | undefined;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class PercentileContext extends PrimaryExpressionContext {
    _name: Token;
    _percentage: ValueExpressionContext;
    _where: BooleanExpressionContext;
    LEFT_PAREN(): TerminalNode[];
    LEFT_PAREN(i: number): TerminalNode;
    RIGHT_PAREN(): TerminalNode[];
    RIGHT_PAREN(i: number): TerminalNode;
    WITHIN(): TerminalNode;
    GROUP(): TerminalNode;
    ORDER(): TerminalNode;
    BY(): TerminalNode;
    sortItem(): SortItemContext;
    valueExpression(): ValueExpressionContext;
    PERCENTILE_CONT(): TerminalNode | undefined;
    PERCENTILE_DISC(): TerminalNode | undefined;
    FILTER(): TerminalNode | undefined;
    WHERE(): TerminalNode | undefined;
    OVER(): TerminalNode | undefined;
    windowSpec(): WindowSpecContext | undefined;
    booleanExpression(): BooleanExpressionContext | undefined;
    constructor(ctx: PrimaryExpressionContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class LiteralTypeContext extends ParserRuleContext {
    _unsupportedType: IdentifierContext;
    DATE(): TerminalNode | undefined;
    TIMESTAMP(): TerminalNode | undefined;
    TIMESTAMP_LTZ(): TerminalNode | undefined;
    TIMESTAMP_NTZ(): TerminalNode | undefined;
    INTERVAL(): TerminalNode | undefined;
    BINARY_HEX(): TerminalNode | undefined;
    identifier(): IdentifierContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ConstantContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: ConstantContext): void;
}
export declare class NullLiteralContext extends ConstantContext {
    NULL(): TerminalNode;
    constructor(ctx: ConstantContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class PosParameterLiteralContext extends ConstantContext {
    QUESTION(): TerminalNode;
    constructor(ctx: ConstantContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class NamedParameterLiteralContext extends ConstantContext {
    COLON(): TerminalNode;
    identifier(): IdentifierContext;
    constructor(ctx: ConstantContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class IntervalLiteralContext extends ConstantContext {
    interval(): IntervalContext;
    constructor(ctx: ConstantContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class TypeConstructorContext extends ConstantContext {
    literalType(): LiteralTypeContext;
    stringLit(): StringLitContext;
    constructor(ctx: ConstantContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class NumericLiteralContext extends ConstantContext {
    number(): NumberContext;
    constructor(ctx: ConstantContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class BooleanLiteralContext extends ConstantContext {
    booleanValue(): BooleanValueContext;
    constructor(ctx: ConstantContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class StringLiteralContext extends ConstantContext {
    stringLit(): StringLitContext[];
    stringLit(i: number): StringLitContext;
    constructor(ctx: ConstantContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ComparisonOperatorContext extends ParserRuleContext {
    EQ(): TerminalNode | undefined;
    NEQ(): TerminalNode | undefined;
    NEQJ(): TerminalNode | undefined;
    LT(): TerminalNode | undefined;
    LTE(): TerminalNode | undefined;
    GT(): TerminalNode | undefined;
    GTE(): TerminalNode | undefined;
    NSEQ(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ArithmeticOperatorContext extends ParserRuleContext {
    PLUS(): TerminalNode | undefined;
    MINUS(): TerminalNode | undefined;
    ASTERISK(): TerminalNode | undefined;
    SLASH(): TerminalNode | undefined;
    PERCENT(): TerminalNode | undefined;
    DIV(): TerminalNode | undefined;
    TILDE(): TerminalNode | undefined;
    AMPERSAND(): TerminalNode | undefined;
    PIPE(): TerminalNode | undefined;
    CONCAT_PIPE(): TerminalNode | undefined;
    HAT(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class PredicateOperatorContext extends ParserRuleContext {
    OR(): TerminalNode | undefined;
    AND(): TerminalNode | undefined;
    IN(): TerminalNode | undefined;
    NOT(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class BooleanValueContext extends ParserRuleContext {
    TRUE(): TerminalNode | undefined;
    FALSE(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class IntervalContext extends ParserRuleContext {
    INTERVAL(): TerminalNode;
    errorCapturingMultiUnitsInterval(): ErrorCapturingMultiUnitsIntervalContext | undefined;
    errorCapturingUnitToUnitInterval(): ErrorCapturingUnitToUnitIntervalContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ErrorCapturingMultiUnitsIntervalContext extends ParserRuleContext {
    _body: MultiUnitsIntervalContext;
    multiUnitsInterval(): MultiUnitsIntervalContext;
    unitToUnitInterval(): UnitToUnitIntervalContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class MultiUnitsIntervalContext extends ParserRuleContext {
    _unitInMultiUnits: UnitInMultiUnitsContext;
    _unit: UnitInMultiUnitsContext[];
    intervalValue(): IntervalValueContext[];
    intervalValue(i: number): IntervalValueContext;
    unitInMultiUnits(): UnitInMultiUnitsContext[];
    unitInMultiUnits(i: number): UnitInMultiUnitsContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ErrorCapturingUnitToUnitIntervalContext extends ParserRuleContext {
    _body: UnitToUnitIntervalContext;
    _error1: MultiUnitsIntervalContext;
    _error2: UnitToUnitIntervalContext;
    unitToUnitInterval(): UnitToUnitIntervalContext[];
    unitToUnitInterval(i: number): UnitToUnitIntervalContext;
    multiUnitsInterval(): MultiUnitsIntervalContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class UnitToUnitIntervalContext extends ParserRuleContext {
    _value: IntervalValueContext;
    _from: UnitInUnitToUnitContext;
    _to: UnitInUnitToUnitContext;
    TO(): TerminalNode;
    intervalValue(): IntervalValueContext;
    unitInUnitToUnit(): UnitInUnitToUnitContext[];
    unitInUnitToUnit(i: number): UnitInUnitToUnitContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class IntervalValueContext extends ParserRuleContext {
    INTEGER_VALUE(): TerminalNode | undefined;
    DECIMAL_VALUE(): TerminalNode | undefined;
    stringLit(): StringLitContext | undefined;
    PLUS(): TerminalNode | undefined;
    MINUS(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class UnitInMultiUnitsContext extends ParserRuleContext {
    NANOSECOND(): TerminalNode | undefined;
    NANOSECONDS(): TerminalNode | undefined;
    MICROSECOND(): TerminalNode | undefined;
    MICROSECONDS(): TerminalNode | undefined;
    MILLISECOND(): TerminalNode | undefined;
    MILLISECONDS(): TerminalNode | undefined;
    SECOND(): TerminalNode | undefined;
    SECONDS(): TerminalNode | undefined;
    MINUTE(): TerminalNode | undefined;
    MINUTES(): TerminalNode | undefined;
    HOUR(): TerminalNode | undefined;
    HOURS(): TerminalNode | undefined;
    DAY(): TerminalNode | undefined;
    DAYS(): TerminalNode | undefined;
    WEEK(): TerminalNode | undefined;
    WEEKS(): TerminalNode | undefined;
    MONTH(): TerminalNode | undefined;
    MONTHS(): TerminalNode | undefined;
    YEAR(): TerminalNode | undefined;
    YEARS(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class UnitInUnitToUnitContext extends ParserRuleContext {
    SECOND(): TerminalNode | undefined;
    MINUTE(): TerminalNode | undefined;
    HOUR(): TerminalNode | undefined;
    DAY(): TerminalNode | undefined;
    MONTH(): TerminalNode | undefined;
    YEAR(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ColPositionContext extends ParserRuleContext {
    _position: Token;
    _afterCol: ErrorCapturingIdentifierContext;
    FIRST(): TerminalNode | undefined;
    AFTER(): TerminalNode | undefined;
    errorCapturingIdentifier(): ErrorCapturingIdentifierContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class TypeContext extends ParserRuleContext {
    _unsupportedType: IdentifierContext;
    BOOLEAN(): TerminalNode | undefined;
    TINYINT(): TerminalNode | undefined;
    BYTE(): TerminalNode | undefined;
    SMALLINT(): TerminalNode | undefined;
    SHORT(): TerminalNode | undefined;
    INT(): TerminalNode | undefined;
    INTEGER(): TerminalNode | undefined;
    BIGINT(): TerminalNode | undefined;
    LONG(): TerminalNode | undefined;
    FLOAT(): TerminalNode | undefined;
    REAL(): TerminalNode | undefined;
    DOUBLE(): TerminalNode | undefined;
    DATE(): TerminalNode | undefined;
    TIMESTAMP(): TerminalNode | undefined;
    TIMESTAMP_NTZ(): TerminalNode | undefined;
    TIMESTAMP_LTZ(): TerminalNode | undefined;
    STRING(): TerminalNode | undefined;
    CHARACTER(): TerminalNode | undefined;
    CHAR(): TerminalNode | undefined;
    VARCHAR(): TerminalNode | undefined;
    BINARY(): TerminalNode | undefined;
    DECIMAL(): TerminalNode | undefined;
    DEC(): TerminalNode | undefined;
    NUMERIC(): TerminalNode | undefined;
    VOID(): TerminalNode | undefined;
    INTERVAL(): TerminalNode | undefined;
    ARRAY(): TerminalNode | undefined;
    STRUCT(): TerminalNode | undefined;
    MAP(): TerminalNode | undefined;
    identifier(): IdentifierContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DataTypeContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: DataTypeContext): void;
}
export declare class ComplexDataTypeContext extends DataTypeContext {
    _complex: Token;
    LT(): TerminalNode | undefined;
    dataType(): DataTypeContext[];
    dataType(i: number): DataTypeContext;
    GT(): TerminalNode | undefined;
    ARRAY(): TerminalNode | undefined;
    COMMA(): TerminalNode | undefined;
    MAP(): TerminalNode | undefined;
    STRUCT(): TerminalNode | undefined;
    NEQ(): TerminalNode | undefined;
    complexColTypeList(): ComplexColTypeListContext | undefined;
    constructor(ctx: DataTypeContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class YearMonthIntervalDataTypeContext extends DataTypeContext {
    _from: Token;
    _to: Token;
    INTERVAL(): TerminalNode;
    YEAR(): TerminalNode | undefined;
    MONTH(): TerminalNode[];
    MONTH(i: number): TerminalNode;
    TO(): TerminalNode | undefined;
    constructor(ctx: DataTypeContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DayTimeIntervalDataTypeContext extends DataTypeContext {
    _from: Token;
    _to: Token;
    INTERVAL(): TerminalNode;
    DAY(): TerminalNode | undefined;
    HOUR(): TerminalNode[];
    HOUR(i: number): TerminalNode;
    MINUTE(): TerminalNode[];
    MINUTE(i: number): TerminalNode;
    SECOND(): TerminalNode[];
    SECOND(i: number): TerminalNode;
    TO(): TerminalNode | undefined;
    constructor(ctx: DataTypeContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class PrimitiveDataTypeContext extends DataTypeContext {
    type(): TypeContext;
    LEFT_PAREN(): TerminalNode | undefined;
    INTEGER_VALUE(): TerminalNode[];
    INTEGER_VALUE(i: number): TerminalNode;
    RIGHT_PAREN(): TerminalNode | undefined;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(ctx: DataTypeContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class QualifiedColTypeWithPositionListContext extends ParserRuleContext {
    qualifiedColTypeWithPosition(): QualifiedColTypeWithPositionContext[];
    qualifiedColTypeWithPosition(i: number): QualifiedColTypeWithPositionContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class QualifiedColTypeWithPositionContext extends ParserRuleContext {
    _name: MultipartIdentifierContext;
    dataType(): DataTypeContext;
    multipartIdentifier(): MultipartIdentifierContext;
    colDefinitionDescriptorWithPosition(): ColDefinitionDescriptorWithPositionContext[];
    colDefinitionDescriptorWithPosition(i: number): ColDefinitionDescriptorWithPositionContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ColDefinitionDescriptorWithPositionContext extends ParserRuleContext {
    NOT(): TerminalNode | undefined;
    NULL(): TerminalNode | undefined;
    defaultExpression(): DefaultExpressionContext | undefined;
    commentSpec(): CommentSpecContext | undefined;
    colPosition(): ColPositionContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DefaultExpressionContext extends ParserRuleContext {
    DEFAULT(): TerminalNode;
    expression(): ExpressionContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ColTypeListContext extends ParserRuleContext {
    colType(): ColTypeContext[];
    colType(i: number): ColTypeContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ColTypeContext extends ParserRuleContext {
    _colName: ErrorCapturingIdentifierContext;
    dataType(): DataTypeContext;
    errorCapturingIdentifier(): ErrorCapturingIdentifierContext;
    NOT(): TerminalNode | undefined;
    NULL(): TerminalNode | undefined;
    commentSpec(): CommentSpecContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class CreateOrReplaceTableColTypeListContext extends ParserRuleContext {
    createOrReplaceTableColType(): CreateOrReplaceTableColTypeContext[];
    createOrReplaceTableColType(i: number): CreateOrReplaceTableColTypeContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class CreateOrReplaceTableColTypeContext extends ParserRuleContext {
    _colName: ErrorCapturingIdentifierContext;
    dataType(): DataTypeContext;
    errorCapturingIdentifier(): ErrorCapturingIdentifierContext;
    colDefinitionOption(): ColDefinitionOptionContext[];
    colDefinitionOption(i: number): ColDefinitionOptionContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ColDefinitionOptionContext extends ParserRuleContext {
    NOT(): TerminalNode | undefined;
    NULL(): TerminalNode | undefined;
    defaultExpression(): DefaultExpressionContext | undefined;
    generationExpression(): GenerationExpressionContext | undefined;
    commentSpec(): CommentSpecContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class GenerationExpressionContext extends ParserRuleContext {
    GENERATED(): TerminalNode;
    ALWAYS(): TerminalNode;
    AS(): TerminalNode;
    LEFT_PAREN(): TerminalNode;
    expression(): ExpressionContext;
    RIGHT_PAREN(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ComplexColTypeListContext extends ParserRuleContext {
    complexColType(): ComplexColTypeContext[];
    complexColType(i: number): ComplexColTypeContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ComplexColTypeContext extends ParserRuleContext {
    identifier(): IdentifierContext;
    dataType(): DataTypeContext;
    COLON(): TerminalNode | undefined;
    NOT(): TerminalNode | undefined;
    NULL(): TerminalNode | undefined;
    commentSpec(): CommentSpecContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class WhenClauseContext extends ParserRuleContext {
    _condition: ExpressionContext;
    _result: ExpressionContext;
    WHEN(): TerminalNode;
    THEN(): TerminalNode;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class WindowClauseContext extends ParserRuleContext {
    WINDOW(): TerminalNode;
    namedWindow(): NamedWindowContext[];
    namedWindow(i: number): NamedWindowContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class NamedWindowContext extends ParserRuleContext {
    _name: ErrorCapturingIdentifierContext;
    AS(): TerminalNode;
    windowSpec(): WindowSpecContext;
    errorCapturingIdentifier(): ErrorCapturingIdentifierContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class WindowSpecContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: WindowSpecContext): void;
}
export declare class WindowRefContext extends WindowSpecContext {
    _name: ErrorCapturingIdentifierContext;
    errorCapturingIdentifier(): ErrorCapturingIdentifierContext;
    LEFT_PAREN(): TerminalNode | undefined;
    RIGHT_PAREN(): TerminalNode | undefined;
    constructor(ctx: WindowSpecContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class WindowDefContext extends WindowSpecContext {
    _expression: ExpressionContext;
    _partition: ExpressionContext[];
    LEFT_PAREN(): TerminalNode;
    RIGHT_PAREN(): TerminalNode;
    CLUSTER(): TerminalNode | undefined;
    BY(): TerminalNode[];
    BY(i: number): TerminalNode;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    windowFrame(): WindowFrameContext | undefined;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    sortItem(): SortItemContext[];
    sortItem(i: number): SortItemContext;
    PARTITION(): TerminalNode | undefined;
    DISTRIBUTE(): TerminalNode | undefined;
    ORDER(): TerminalNode | undefined;
    SORT(): TerminalNode | undefined;
    constructor(ctx: WindowSpecContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class WindowFrameContext extends ParserRuleContext {
    _frameType: Token;
    _startPoint: FrameBoundContext;
    _endPoint: FrameBoundContext;
    RANGE(): TerminalNode | undefined;
    frameBound(): FrameBoundContext[];
    frameBound(i: number): FrameBoundContext;
    ROWS(): TerminalNode | undefined;
    BETWEEN(): TerminalNode | undefined;
    AND(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class FrameBoundContext extends ParserRuleContext {
    _boundType: Token;
    UNBOUNDED(): TerminalNode | undefined;
    PRECEDING(): TerminalNode | undefined;
    FOLLOWING(): TerminalNode | undefined;
    ROW(): TerminalNode | undefined;
    CURRENT(): TerminalNode | undefined;
    expression(): ExpressionContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class QualifiedNameListContext extends ParserRuleContext {
    qualifiedName(): QualifiedNameContext[];
    qualifiedName(i: number): QualifiedNameContext;
    COMMA(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class FunctionNameContext extends ParserRuleContext {
    IDENTIFIER_KW(): TerminalNode | undefined;
    LEFT_PAREN(): TerminalNode | undefined;
    expression(): ExpressionContext | undefined;
    RIGHT_PAREN(): TerminalNode | undefined;
    qualifiedName(): QualifiedNameContext | undefined;
    FILTER(): TerminalNode | undefined;
    LEFT(): TerminalNode | undefined;
    RIGHT(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class QualifiedNameContext extends ParserRuleContext {
    identifier(): IdentifierContext[];
    identifier(i: number): IdentifierContext;
    DOT(): TerminalNode[];
    DOT(i: number): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ErrorCapturingIdentifierContext extends ParserRuleContext {
    identifier(): IdentifierContext;
    errorCapturingIdentifierExtra(): ErrorCapturingIdentifierExtraContext;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class ErrorCapturingIdentifierExtraContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: ErrorCapturingIdentifierExtraContext): void;
}
export declare class ErrorIdentContext extends ErrorCapturingIdentifierExtraContext {
    MINUS(): TerminalNode[];
    MINUS(i: number): TerminalNode;
    identifier(): IdentifierContext[];
    identifier(i: number): IdentifierContext;
    constructor(ctx: ErrorCapturingIdentifierExtraContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class RealIdentContext extends ErrorCapturingIdentifierExtraContext {
    constructor(ctx: ErrorCapturingIdentifierExtraContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class IdentifierContext extends ParserRuleContext {
    strictIdentifier(): StrictIdentifierContext | undefined;
    strictNonReserved(): StrictNonReservedContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class StrictIdentifierContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: StrictIdentifierContext): void;
}
export declare class UnquotedIdentifierContext extends StrictIdentifierContext {
    IDENTIFIER(): TerminalNode | undefined;
    ansiNonReserved(): AnsiNonReservedContext | undefined;
    nonReserved(): NonReservedContext | undefined;
    constructor(ctx: StrictIdentifierContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class QuotedIdentifierAlternativeContext extends StrictIdentifierContext {
    quotedIdentifier(): QuotedIdentifierContext;
    constructor(ctx: StrictIdentifierContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class QuotedIdentifierContext extends ParserRuleContext {
    BACKQUOTED_IDENTIFIER(): TerminalNode | undefined;
    DOUBLEQUOTED_STRING(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class BackQuotedIdentifierContext extends ParserRuleContext {
    BACKQUOTED_IDENTIFIER(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class NumberContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: NumberContext): void;
}
export declare class ExponentLiteralContext extends NumberContext {
    EXPONENT_VALUE(): TerminalNode;
    MINUS(): TerminalNode | undefined;
    constructor(ctx: NumberContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DecimalLiteralContext extends NumberContext {
    DECIMAL_VALUE(): TerminalNode;
    MINUS(): TerminalNode | undefined;
    constructor(ctx: NumberContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class LegacyDecimalLiteralContext extends NumberContext {
    EXPONENT_VALUE(): TerminalNode | undefined;
    DECIMAL_VALUE(): TerminalNode | undefined;
    MINUS(): TerminalNode | undefined;
    constructor(ctx: NumberContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class IntegerLiteralContext extends NumberContext {
    INTEGER_VALUE(): TerminalNode;
    MINUS(): TerminalNode | undefined;
    constructor(ctx: NumberContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class BigIntLiteralContext extends NumberContext {
    BIGINT_LITERAL(): TerminalNode;
    MINUS(): TerminalNode | undefined;
    constructor(ctx: NumberContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class SmallIntLiteralContext extends NumberContext {
    SMALLINT_LITERAL(): TerminalNode;
    MINUS(): TerminalNode | undefined;
    constructor(ctx: NumberContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class TinyIntLiteralContext extends NumberContext {
    TINYINT_LITERAL(): TerminalNode;
    MINUS(): TerminalNode | undefined;
    constructor(ctx: NumberContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class DoubleLiteralContext extends NumberContext {
    DOUBLE_LITERAL(): TerminalNode;
    MINUS(): TerminalNode | undefined;
    constructor(ctx: NumberContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class FloatLiteralContext extends NumberContext {
    FLOAT_LITERAL(): TerminalNode;
    MINUS(): TerminalNode | undefined;
    constructor(ctx: NumberContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class BigDecimalLiteralContext extends NumberContext {
    BIGDECIMAL_LITERAL(): TerminalNode;
    MINUS(): TerminalNode | undefined;
    constructor(ctx: NumberContext);
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class AlterColumnActionContext extends ParserRuleContext {
    _setOrDrop: Token;
    _dropDefault: Token;
    TYPE(): TerminalNode | undefined;
    dataType(): DataTypeContext | undefined;
    commentSpec(): CommentSpecContext | undefined;
    colPosition(): ColPositionContext | undefined;
    NOT(): TerminalNode | undefined;
    NULL(): TerminalNode | undefined;
    SET(): TerminalNode | undefined;
    DROP(): TerminalNode | undefined;
    defaultExpression(): DefaultExpressionContext | undefined;
    DEFAULT(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class StringLitContext extends ParserRuleContext {
    STRING_LITERAL(): TerminalNode | undefined;
    DOUBLEQUOTED_STRING(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class CommentContext extends ParserRuleContext {
    stringLit(): StringLitContext | undefined;
    NULL(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class VersionContext extends ParserRuleContext {
    INTEGER_VALUE(): TerminalNode | undefined;
    stringLit(): StringLitContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class AnsiNonReservedContext extends ParserRuleContext {
    ADD(): TerminalNode | undefined;
    AFTER(): TerminalNode | undefined;
    ALTER(): TerminalNode | undefined;
    ALWAYS(): TerminalNode | undefined;
    ANALYZE(): TerminalNode | undefined;
    ANTI(): TerminalNode | undefined;
    ANY_VALUE(): TerminalNode | undefined;
    ARCHIVE(): TerminalNode | undefined;
    ARRAY(): TerminalNode | undefined;
    ASC(): TerminalNode | undefined;
    AT(): TerminalNode | undefined;
    BETWEEN(): TerminalNode | undefined;
    BIGINT(): TerminalNode | undefined;
    BINARY(): TerminalNode | undefined;
    BINARY_HEX(): TerminalNode | undefined;
    BOOLEAN(): TerminalNode | undefined;
    BUCKET(): TerminalNode | undefined;
    BUCKETS(): TerminalNode | undefined;
    BY(): TerminalNode | undefined;
    BYTE(): TerminalNode | undefined;
    CACHE(): TerminalNode | undefined;
    CASCADE(): TerminalNode | undefined;
    CATALOG(): TerminalNode | undefined;
    CATALOGS(): TerminalNode | undefined;
    CHANGE(): TerminalNode | undefined;
    CHAR(): TerminalNode | undefined;
    CHARACTER(): TerminalNode | undefined;
    CLEAR(): TerminalNode | undefined;
    CLUSTER(): TerminalNode | undefined;
    CLUSTERED(): TerminalNode | undefined;
    CODEGEN(): TerminalNode | undefined;
    COLLECTION(): TerminalNode | undefined;
    COLUMNS(): TerminalNode | undefined;
    COMMENT(): TerminalNode | undefined;
    COMMIT(): TerminalNode | undefined;
    COMPACT(): TerminalNode | undefined;
    COMPACTIONS(): TerminalNode | undefined;
    COMPUTE(): TerminalNode | undefined;
    CONCATENATE(): TerminalNode | undefined;
    COST(): TerminalNode | undefined;
    CUBE(): TerminalNode | undefined;
    CURRENT(): TerminalNode | undefined;
    DATA(): TerminalNode | undefined;
    DATABASE(): TerminalNode | undefined;
    DATABASES(): TerminalNode | undefined;
    DATE(): TerminalNode | undefined;
    DATEADD(): TerminalNode | undefined;
    DATE_ADD(): TerminalNode | undefined;
    DATEDIFF(): TerminalNode | undefined;
    DATE_DIFF(): TerminalNode | undefined;
    DAY(): TerminalNode | undefined;
    DAYS(): TerminalNode | undefined;
    DAYOFYEAR(): TerminalNode | undefined;
    DBPROPERTIES(): TerminalNode | undefined;
    DEC(): TerminalNode | undefined;
    DECIMAL(): TerminalNode | undefined;
    DEFAULT(): TerminalNode | undefined;
    DEFINED(): TerminalNode | undefined;
    DELETE(): TerminalNode | undefined;
    DELIMITED(): TerminalNode | undefined;
    DESC(): TerminalNode | undefined;
    DESCRIBE(): TerminalNode | undefined;
    DFS(): TerminalNode | undefined;
    DIRECTORIES(): TerminalNode | undefined;
    DIRECTORY(): TerminalNode | undefined;
    DISTRIBUTE(): TerminalNode | undefined;
    DIV(): TerminalNode | undefined;
    DOUBLE(): TerminalNode | undefined;
    DROP(): TerminalNode | undefined;
    ESCAPED(): TerminalNode | undefined;
    EXCHANGE(): TerminalNode | undefined;
    EXCLUDE(): TerminalNode | undefined;
    EXISTS(): TerminalNode | undefined;
    EXPLAIN(): TerminalNode | undefined;
    EXPORT(): TerminalNode | undefined;
    EXTENDED(): TerminalNode | undefined;
    EXTERNAL(): TerminalNode | undefined;
    EXTRACT(): TerminalNode | undefined;
    FIELDS(): TerminalNode | undefined;
    FILEFORMAT(): TerminalNode | undefined;
    FIRST(): TerminalNode | undefined;
    FLOAT(): TerminalNode | undefined;
    FOLLOWING(): TerminalNode | undefined;
    FORMAT(): TerminalNode | undefined;
    FORMATTED(): TerminalNode | undefined;
    FUNCTION(): TerminalNode | undefined;
    FUNCTIONS(): TerminalNode | undefined;
    GENERATED(): TerminalNode | undefined;
    GLOBAL(): TerminalNode | undefined;
    GROUPING(): TerminalNode | undefined;
    HOUR(): TerminalNode | undefined;
    HOURS(): TerminalNode | undefined;
    IDENTIFIER_KW(): TerminalNode | undefined;
    IF(): TerminalNode | undefined;
    IGNORE(): TerminalNode | undefined;
    IMPORT(): TerminalNode | undefined;
    INCLUDE(): TerminalNode | undefined;
    INDEX(): TerminalNode | undefined;
    INDEXES(): TerminalNode | undefined;
    INPATH(): TerminalNode | undefined;
    INPUTFORMAT(): TerminalNode | undefined;
    INSERT(): TerminalNode | undefined;
    INT(): TerminalNode | undefined;
    INTEGER(): TerminalNode | undefined;
    INTERVAL(): TerminalNode | undefined;
    ITEMS(): TerminalNode | undefined;
    KEYS(): TerminalNode | undefined;
    LAST(): TerminalNode | undefined;
    LAZY(): TerminalNode | undefined;
    LIKE(): TerminalNode | undefined;
    ILIKE(): TerminalNode | undefined;
    LIMIT(): TerminalNode | undefined;
    LINES(): TerminalNode | undefined;
    LIST(): TerminalNode | undefined;
    LOAD(): TerminalNode | undefined;
    LOCAL(): TerminalNode | undefined;
    LOCATION(): TerminalNode | undefined;
    LOCK(): TerminalNode | undefined;
    LOCKS(): TerminalNode | undefined;
    LOGICAL(): TerminalNode | undefined;
    LONG(): TerminalNode | undefined;
    MACRO(): TerminalNode | undefined;
    MAP(): TerminalNode | undefined;
    MATCHED(): TerminalNode | undefined;
    MERGE(): TerminalNode | undefined;
    MICROSECOND(): TerminalNode | undefined;
    MICROSECONDS(): TerminalNode | undefined;
    MILLISECOND(): TerminalNode | undefined;
    MILLISECONDS(): TerminalNode | undefined;
    MINUTE(): TerminalNode | undefined;
    MINUTES(): TerminalNode | undefined;
    MONTH(): TerminalNode | undefined;
    MONTHS(): TerminalNode | undefined;
    MSCK(): TerminalNode | undefined;
    NAME(): TerminalNode | undefined;
    NAMESPACE(): TerminalNode | undefined;
    NAMESPACES(): TerminalNode | undefined;
    NANOSECOND(): TerminalNode | undefined;
    NANOSECONDS(): TerminalNode | undefined;
    NO(): TerminalNode | undefined;
    NULLS(): TerminalNode | undefined;
    NUMERIC(): TerminalNode | undefined;
    OF(): TerminalNode | undefined;
    OPTION(): TerminalNode | undefined;
    OPTIONS(): TerminalNode | undefined;
    OUT(): TerminalNode | undefined;
    OUTPUTFORMAT(): TerminalNode | undefined;
    OVER(): TerminalNode | undefined;
    OVERLAY(): TerminalNode | undefined;
    OVERWRITE(): TerminalNode | undefined;
    PARTITION(): TerminalNode | undefined;
    PARTITIONED(): TerminalNode | undefined;
    PARTITIONS(): TerminalNode | undefined;
    PERCENTLIT(): TerminalNode | undefined;
    PIVOT(): TerminalNode | undefined;
    PLACING(): TerminalNode | undefined;
    POSITION(): TerminalNode | undefined;
    PRECEDING(): TerminalNode | undefined;
    PRINCIPALS(): TerminalNode | undefined;
    PROPERTIES(): TerminalNode | undefined;
    PURGE(): TerminalNode | undefined;
    QUARTER(): TerminalNode | undefined;
    QUERY(): TerminalNode | undefined;
    RANGE(): TerminalNode | undefined;
    REAL(): TerminalNode | undefined;
    RECORDREADER(): TerminalNode | undefined;
    RECORDWRITER(): TerminalNode | undefined;
    RECOVER(): TerminalNode | undefined;
    REDUCE(): TerminalNode | undefined;
    REFRESH(): TerminalNode | undefined;
    RENAME(): TerminalNode | undefined;
    REPAIR(): TerminalNode | undefined;
    REPEATABLE(): TerminalNode | undefined;
    REPLACE(): TerminalNode | undefined;
    RESET(): TerminalNode | undefined;
    RESPECT(): TerminalNode | undefined;
    RESTRICT(): TerminalNode | undefined;
    REVOKE(): TerminalNode | undefined;
    RLIKE(): TerminalNode | undefined;
    ROLE(): TerminalNode | undefined;
    ROLES(): TerminalNode | undefined;
    ROLLBACK(): TerminalNode | undefined;
    ROLLUP(): TerminalNode | undefined;
    ROW(): TerminalNode | undefined;
    ROWS(): TerminalNode | undefined;
    SCHEMA(): TerminalNode | undefined;
    SCHEMAS(): TerminalNode | undefined;
    SECOND(): TerminalNode | undefined;
    SECONDS(): TerminalNode | undefined;
    SEMI(): TerminalNode | undefined;
    SEPARATED(): TerminalNode | undefined;
    SERDE(): TerminalNode | undefined;
    SERDEPROPERTIES(): TerminalNode | undefined;
    SET(): TerminalNode | undefined;
    SETMINUS(): TerminalNode | undefined;
    SETS(): TerminalNode | undefined;
    SHORT(): TerminalNode | undefined;
    SHOW(): TerminalNode | undefined;
    SKEWED(): TerminalNode | undefined;
    SMALLINT(): TerminalNode | undefined;
    SORT(): TerminalNode | undefined;
    SORTED(): TerminalNode | undefined;
    SOURCE(): TerminalNode | undefined;
    START(): TerminalNode | undefined;
    STATISTICS(): TerminalNode | undefined;
    STORED(): TerminalNode | undefined;
    STRATIFY(): TerminalNode | undefined;
    STRING(): TerminalNode | undefined;
    STRUCT(): TerminalNode | undefined;
    SUBSTR(): TerminalNode | undefined;
    SUBSTRING(): TerminalNode | undefined;
    SYNC(): TerminalNode | undefined;
    SYSTEM_TIME(): TerminalNode | undefined;
    SYSTEM_VERSION(): TerminalNode | undefined;
    TABLES(): TerminalNode | undefined;
    TABLESAMPLE(): TerminalNode | undefined;
    TARGET(): TerminalNode | undefined;
    TBLPROPERTIES(): TerminalNode | undefined;
    TEMPORARY(): TerminalNode | undefined;
    TERMINATED(): TerminalNode | undefined;
    TIMESTAMP(): TerminalNode | undefined;
    TIMESTAMP_LTZ(): TerminalNode | undefined;
    TIMESTAMP_NTZ(): TerminalNode | undefined;
    TIMESTAMPADD(): TerminalNode | undefined;
    TIMESTAMPDIFF(): TerminalNode | undefined;
    TINYINT(): TerminalNode | undefined;
    TOUCH(): TerminalNode | undefined;
    TRANSACTION(): TerminalNode | undefined;
    TRANSACTIONS(): TerminalNode | undefined;
    TRANSFORM(): TerminalNode | undefined;
    TRIM(): TerminalNode | undefined;
    TRUE(): TerminalNode | undefined;
    TRUNCATE(): TerminalNode | undefined;
    TRY_CAST(): TerminalNode | undefined;
    TYPE(): TerminalNode | undefined;
    UNARCHIVE(): TerminalNode | undefined;
    UNBOUNDED(): TerminalNode | undefined;
    UNCACHE(): TerminalNode | undefined;
    UNLOCK(): TerminalNode | undefined;
    UNPIVOT(): TerminalNode | undefined;
    UNSET(): TerminalNode | undefined;
    UPDATE(): TerminalNode | undefined;
    USE(): TerminalNode | undefined;
    VALUES(): TerminalNode | undefined;
    VARCHAR(): TerminalNode | undefined;
    VERSION(): TerminalNode | undefined;
    VIEW(): TerminalNode | undefined;
    VIEWS(): TerminalNode | undefined;
    VOID(): TerminalNode | undefined;
    WEEK(): TerminalNode | undefined;
    WEEKS(): TerminalNode | undefined;
    WINDOW(): TerminalNode | undefined;
    YEAR(): TerminalNode | undefined;
    YEARS(): TerminalNode | undefined;
    ZONE(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class StrictNonReservedContext extends ParserRuleContext {
    ANTI(): TerminalNode | undefined;
    CROSS(): TerminalNode | undefined;
    EXCEPT(): TerminalNode | undefined;
    FULL(): TerminalNode | undefined;
    INNER(): TerminalNode | undefined;
    INTERSECT(): TerminalNode | undefined;
    JOIN(): TerminalNode | undefined;
    LATERAL(): TerminalNode | undefined;
    LEFT(): TerminalNode | undefined;
    NATURAL(): TerminalNode | undefined;
    ON(): TerminalNode | undefined;
    RIGHT(): TerminalNode | undefined;
    SEMI(): TerminalNode | undefined;
    SETMINUS(): TerminalNode | undefined;
    UNION(): TerminalNode | undefined;
    USING(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
export declare class NonReservedContext extends ParserRuleContext {
    ADD(): TerminalNode | undefined;
    AFTER(): TerminalNode | undefined;
    ALL(): TerminalNode | undefined;
    ALTER(): TerminalNode | undefined;
    ALWAYS(): TerminalNode | undefined;
    ANALYZE(): TerminalNode | undefined;
    AND(): TerminalNode | undefined;
    ANY(): TerminalNode | undefined;
    ANY_VALUE(): TerminalNode | undefined;
    ARCHIVE(): TerminalNode | undefined;
    ARRAY(): TerminalNode | undefined;
    AS(): TerminalNode | undefined;
    ASC(): TerminalNode | undefined;
    AT(): TerminalNode | undefined;
    AUTHORIZATION(): TerminalNode | undefined;
    BETWEEN(): TerminalNode | undefined;
    BIGINT(): TerminalNode | undefined;
    BINARY(): TerminalNode | undefined;
    BINARY_HEX(): TerminalNode | undefined;
    BOOLEAN(): TerminalNode | undefined;
    BOTH(): TerminalNode | undefined;
    BUCKET(): TerminalNode | undefined;
    BUCKETS(): TerminalNode | undefined;
    BY(): TerminalNode | undefined;
    BYTE(): TerminalNode | undefined;
    CACHE(): TerminalNode | undefined;
    CASCADE(): TerminalNode | undefined;
    CASE(): TerminalNode | undefined;
    CAST(): TerminalNode | undefined;
    CATALOG(): TerminalNode | undefined;
    CATALOGS(): TerminalNode | undefined;
    CHANGE(): TerminalNode | undefined;
    CHAR(): TerminalNode | undefined;
    CHARACTER(): TerminalNode | undefined;
    CHECK(): TerminalNode | undefined;
    CLEAR(): TerminalNode | undefined;
    CLUSTER(): TerminalNode | undefined;
    CLUSTERED(): TerminalNode | undefined;
    CODEGEN(): TerminalNode | undefined;
    COLLATE(): TerminalNode | undefined;
    COLLECTION(): TerminalNode | undefined;
    COLUMN(): TerminalNode | undefined;
    COLUMNS(): TerminalNode | undefined;
    COMMENT(): TerminalNode | undefined;
    COMMIT(): TerminalNode | undefined;
    COMPACT(): TerminalNode | undefined;
    COMPACTIONS(): TerminalNode | undefined;
    COMPUTE(): TerminalNode | undefined;
    CONCATENATE(): TerminalNode | undefined;
    CONSTRAINT(): TerminalNode | undefined;
    COST(): TerminalNode | undefined;
    CREATE(): TerminalNode | undefined;
    CUBE(): TerminalNode | undefined;
    CURRENT(): TerminalNode | undefined;
    CURRENT_DATE(): TerminalNode | undefined;
    CURRENT_TIME(): TerminalNode | undefined;
    CURRENT_TIMESTAMP(): TerminalNode | undefined;
    CURRENT_USER(): TerminalNode | undefined;
    DATA(): TerminalNode | undefined;
    DATABASE(): TerminalNode | undefined;
    DATABASES(): TerminalNode | undefined;
    DATE(): TerminalNode | undefined;
    DATEADD(): TerminalNode | undefined;
    DATE_ADD(): TerminalNode | undefined;
    DATEDIFF(): TerminalNode | undefined;
    DATE_DIFF(): TerminalNode | undefined;
    DAY(): TerminalNode | undefined;
    DAYS(): TerminalNode | undefined;
    DAYOFYEAR(): TerminalNode | undefined;
    DBPROPERTIES(): TerminalNode | undefined;
    DEC(): TerminalNode | undefined;
    DECIMAL(): TerminalNode | undefined;
    DEFAULT(): TerminalNode | undefined;
    DEFINED(): TerminalNode | undefined;
    DELETE(): TerminalNode | undefined;
    DELIMITED(): TerminalNode | undefined;
    DESC(): TerminalNode | undefined;
    DESCRIBE(): TerminalNode | undefined;
    DFS(): TerminalNode | undefined;
    DIRECTORIES(): TerminalNode | undefined;
    DIRECTORY(): TerminalNode | undefined;
    DISTINCT(): TerminalNode | undefined;
    DISTRIBUTE(): TerminalNode | undefined;
    DIV(): TerminalNode | undefined;
    DOUBLE(): TerminalNode | undefined;
    DROP(): TerminalNode | undefined;
    ELSE(): TerminalNode | undefined;
    END(): TerminalNode | undefined;
    ESCAPE(): TerminalNode | undefined;
    ESCAPED(): TerminalNode | undefined;
    EXCHANGE(): TerminalNode | undefined;
    EXCLUDE(): TerminalNode | undefined;
    EXISTS(): TerminalNode | undefined;
    EXPLAIN(): TerminalNode | undefined;
    EXPORT(): TerminalNode | undefined;
    EXTENDED(): TerminalNode | undefined;
    EXTERNAL(): TerminalNode | undefined;
    EXTRACT(): TerminalNode | undefined;
    FALSE(): TerminalNode | undefined;
    FETCH(): TerminalNode | undefined;
    FILTER(): TerminalNode | undefined;
    FIELDS(): TerminalNode | undefined;
    FILEFORMAT(): TerminalNode | undefined;
    FIRST(): TerminalNode | undefined;
    FLOAT(): TerminalNode | undefined;
    FOLLOWING(): TerminalNode | undefined;
    FOR(): TerminalNode | undefined;
    FOREIGN(): TerminalNode | undefined;
    FORMAT(): TerminalNode | undefined;
    FORMATTED(): TerminalNode | undefined;
    FROM(): TerminalNode | undefined;
    FUNCTION(): TerminalNode | undefined;
    FUNCTIONS(): TerminalNode | undefined;
    GENERATED(): TerminalNode | undefined;
    GLOBAL(): TerminalNode | undefined;
    GRANT(): TerminalNode | undefined;
    GROUP(): TerminalNode | undefined;
    GROUPING(): TerminalNode | undefined;
    HAVING(): TerminalNode | undefined;
    HOUR(): TerminalNode | undefined;
    HOURS(): TerminalNode | undefined;
    IDENTIFIER_KW(): TerminalNode | undefined;
    IF(): TerminalNode | undefined;
    IGNORE(): TerminalNode | undefined;
    IMPORT(): TerminalNode | undefined;
    IN(): TerminalNode | undefined;
    INCLUDE(): TerminalNode | undefined;
    INDEX(): TerminalNode | undefined;
    INDEXES(): TerminalNode | undefined;
    INPATH(): TerminalNode | undefined;
    INPUTFORMAT(): TerminalNode | undefined;
    INSERT(): TerminalNode | undefined;
    INT(): TerminalNode | undefined;
    INTEGER(): TerminalNode | undefined;
    INTERVAL(): TerminalNode | undefined;
    INTO(): TerminalNode | undefined;
    IS(): TerminalNode | undefined;
    ITEMS(): TerminalNode | undefined;
    KEYS(): TerminalNode | undefined;
    LAST(): TerminalNode | undefined;
    LAZY(): TerminalNode | undefined;
    LEADING(): TerminalNode | undefined;
    LIKE(): TerminalNode | undefined;
    LONG(): TerminalNode | undefined;
    ILIKE(): TerminalNode | undefined;
    LIMIT(): TerminalNode | undefined;
    LINES(): TerminalNode | undefined;
    LIST(): TerminalNode | undefined;
    LOAD(): TerminalNode | undefined;
    LOCAL(): TerminalNode | undefined;
    LOCATION(): TerminalNode | undefined;
    LOCK(): TerminalNode | undefined;
    LOCKS(): TerminalNode | undefined;
    LOGICAL(): TerminalNode | undefined;
    MACRO(): TerminalNode | undefined;
    MAP(): TerminalNode | undefined;
    MATCHED(): TerminalNode | undefined;
    MERGE(): TerminalNode | undefined;
    MICROSECOND(): TerminalNode | undefined;
    MICROSECONDS(): TerminalNode | undefined;
    MILLISECOND(): TerminalNode | undefined;
    MILLISECONDS(): TerminalNode | undefined;
    MINUTE(): TerminalNode | undefined;
    MINUTES(): TerminalNode | undefined;
    MONTH(): TerminalNode | undefined;
    MONTHS(): TerminalNode | undefined;
    MSCK(): TerminalNode | undefined;
    NAME(): TerminalNode | undefined;
    NAMESPACE(): TerminalNode | undefined;
    NAMESPACES(): TerminalNode | undefined;
    NANOSECOND(): TerminalNode | undefined;
    NANOSECONDS(): TerminalNode | undefined;
    NO(): TerminalNode | undefined;
    NOT(): TerminalNode | undefined;
    NULL(): TerminalNode | undefined;
    NULLS(): TerminalNode | undefined;
    NUMERIC(): TerminalNode | undefined;
    OF(): TerminalNode | undefined;
    OFFSET(): TerminalNode | undefined;
    ONLY(): TerminalNode | undefined;
    OPTION(): TerminalNode | undefined;
    OPTIONS(): TerminalNode | undefined;
    OR(): TerminalNode | undefined;
    ORDER(): TerminalNode | undefined;
    OUT(): TerminalNode | undefined;
    OUTER(): TerminalNode | undefined;
    OUTPUTFORMAT(): TerminalNode | undefined;
    OVER(): TerminalNode | undefined;
    OVERLAPS(): TerminalNode | undefined;
    OVERLAY(): TerminalNode | undefined;
    OVERWRITE(): TerminalNode | undefined;
    PARTITION(): TerminalNode | undefined;
    PARTITIONED(): TerminalNode | undefined;
    PARTITIONS(): TerminalNode | undefined;
    PERCENTILE_CONT(): TerminalNode | undefined;
    PERCENTILE_DISC(): TerminalNode | undefined;
    PERCENTLIT(): TerminalNode | undefined;
    PIVOT(): TerminalNode | undefined;
    PLACING(): TerminalNode | undefined;
    POSITION(): TerminalNode | undefined;
    PRECEDING(): TerminalNode | undefined;
    PRIMARY(): TerminalNode | undefined;
    PRINCIPALS(): TerminalNode | undefined;
    PROPERTIES(): TerminalNode | undefined;
    PURGE(): TerminalNode | undefined;
    QUARTER(): TerminalNode | undefined;
    QUERY(): TerminalNode | undefined;
    RANGE(): TerminalNode | undefined;
    REAL(): TerminalNode | undefined;
    RECORDREADER(): TerminalNode | undefined;
    RECORDWRITER(): TerminalNode | undefined;
    RECOVER(): TerminalNode | undefined;
    REDUCE(): TerminalNode | undefined;
    REFERENCES(): TerminalNode | undefined;
    REFRESH(): TerminalNode | undefined;
    RENAME(): TerminalNode | undefined;
    REPAIR(): TerminalNode | undefined;
    REPEATABLE(): TerminalNode | undefined;
    REPLACE(): TerminalNode | undefined;
    RESET(): TerminalNode | undefined;
    RESPECT(): TerminalNode | undefined;
    RESTRICT(): TerminalNode | undefined;
    REVOKE(): TerminalNode | undefined;
    RLIKE(): TerminalNode | undefined;
    ROLE(): TerminalNode | undefined;
    ROLES(): TerminalNode | undefined;
    ROLLBACK(): TerminalNode | undefined;
    ROLLUP(): TerminalNode | undefined;
    ROW(): TerminalNode | undefined;
    ROWS(): TerminalNode | undefined;
    SCHEMA(): TerminalNode | undefined;
    SCHEMAS(): TerminalNode | undefined;
    SECOND(): TerminalNode | undefined;
    SECONDS(): TerminalNode | undefined;
    SELECT(): TerminalNode | undefined;
    SEPARATED(): TerminalNode | undefined;
    SERDE(): TerminalNode | undefined;
    SERDEPROPERTIES(): TerminalNode | undefined;
    SESSION_USER(): TerminalNode | undefined;
    SET(): TerminalNode | undefined;
    SETS(): TerminalNode | undefined;
    SHORT(): TerminalNode | undefined;
    SHOW(): TerminalNode | undefined;
    SKEWED(): TerminalNode | undefined;
    SMALLINT(): TerminalNode | undefined;
    SOME(): TerminalNode | undefined;
    SORT(): TerminalNode | undefined;
    SORTED(): TerminalNode | undefined;
    SOURCE(): TerminalNode | undefined;
    START(): TerminalNode | undefined;
    STATISTICS(): TerminalNode | undefined;
    STORED(): TerminalNode | undefined;
    STRATIFY(): TerminalNode | undefined;
    STRING(): TerminalNode | undefined;
    STRUCT(): TerminalNode | undefined;
    SUBSTR(): TerminalNode | undefined;
    SUBSTRING(): TerminalNode | undefined;
    SYNC(): TerminalNode | undefined;
    SYSTEM_TIME(): TerminalNode | undefined;
    SYSTEM_VERSION(): TerminalNode | undefined;
    TABLE(): TerminalNode | undefined;
    TABLES(): TerminalNode | undefined;
    TABLESAMPLE(): TerminalNode | undefined;
    TARGET(): TerminalNode | undefined;
    TBLPROPERTIES(): TerminalNode | undefined;
    TEMPORARY(): TerminalNode | undefined;
    TERMINATED(): TerminalNode | undefined;
    THEN(): TerminalNode | undefined;
    TIME(): TerminalNode | undefined;
    TIMESTAMP(): TerminalNode | undefined;
    TIMESTAMP_LTZ(): TerminalNode | undefined;
    TIMESTAMP_NTZ(): TerminalNode | undefined;
    TIMESTAMPADD(): TerminalNode | undefined;
    TIMESTAMPDIFF(): TerminalNode | undefined;
    TINYINT(): TerminalNode | undefined;
    TO(): TerminalNode | undefined;
    TOUCH(): TerminalNode | undefined;
    TRAILING(): TerminalNode | undefined;
    TRANSACTION(): TerminalNode | undefined;
    TRANSACTIONS(): TerminalNode | undefined;
    TRANSFORM(): TerminalNode | undefined;
    TRIM(): TerminalNode | undefined;
    TRUE(): TerminalNode | undefined;
    TRUNCATE(): TerminalNode | undefined;
    TRY_CAST(): TerminalNode | undefined;
    TYPE(): TerminalNode | undefined;
    UNARCHIVE(): TerminalNode | undefined;
    UNBOUNDED(): TerminalNode | undefined;
    UNCACHE(): TerminalNode | undefined;
    UNIQUE(): TerminalNode | undefined;
    UNKNOWN(): TerminalNode | undefined;
    UNLOCK(): TerminalNode | undefined;
    UNPIVOT(): TerminalNode | undefined;
    UNSET(): TerminalNode | undefined;
    UPDATE(): TerminalNode | undefined;
    USE(): TerminalNode | undefined;
    USER(): TerminalNode | undefined;
    VALUES(): TerminalNode | undefined;
    VARCHAR(): TerminalNode | undefined;
    VERSION(): TerminalNode | undefined;
    VIEW(): TerminalNode | undefined;
    VIEWS(): TerminalNode | undefined;
    VOID(): TerminalNode | undefined;
    WEEK(): TerminalNode | undefined;
    WEEKS(): TerminalNode | undefined;
    WHEN(): TerminalNode | undefined;
    WHERE(): TerminalNode | undefined;
    WINDOW(): TerminalNode | undefined;
    WITH(): TerminalNode | undefined;
    WITHIN(): TerminalNode | undefined;
    YEAR(): TerminalNode | undefined;
    YEARS(): TerminalNode | undefined;
    ZONE(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: SparkSqlParserListener): void;
    exitRule(listener: SparkSqlParserListener): void;
    accept<Result>(visitor: SparkSqlParserVisitor<Result>): Result;
}
